<?php

/**
 * @name		Template Creator CK
 * @copyright	Copyright (C) since 2011. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access
defined('TCK_LOADED') or die;
require_once TEMPLATECREATORCK_PATH . '/controller.php';

/**
 * Template controller class.
 */
class TemplateckControllerTemplate extends TemplateckController {

	function __construct() {
		parent::__construct();
	}

	/**
	 * Method to check out an item for editing and redirect to the edit form.
	 *
	 * @since	1.6
	 */
	public function edit() {
		$editIds = $this->input->get('cid', null, 'array');
		if (count($editIds)) {
			$editId = (int) $editIds[0];
		} else {
			$editId = (int) $this->input->get('id', null, 'int');
		}

		// Redirect to the edit screen.
		TemplateckHelper::redirect(TEMPLATECREATORCK_ADMIN_URL . '&view=template&layout=edit&id=' . $editId);
	}

	/**
	 * Method to check out an item for editing and redirect to the edit form.
	 *
	 * @since	1.6
	 */
	public function copy() {
		$editIds = $this->input->get('cid', null, 'array');
		if (count($editIds)) {
			$id = (int) $editIds[0];
		} else {
			$id = (int) $this->input->get('id', null, 'int');
		}
		$model = $this->getModel('template');
		if ($model->copy($id)) {
			TemplateckHelper::enqueueMessage('CK_SUCCESS_ITEM_COPY');
		} else {
			TemplateckHelper::enqueueMessage('CK_ERROR_ITEM_COPY');
		}

		// Redirect to the edit screen.
//		TemplateckHelper::redirect(TEMPLATECREATORCK_ADMIN_GENERAL_URL);
	}

	/**
	 * Method to check out an item for editing and redirect to the edit form.
	 *
	 * @since	1.6
	 */
	public function delete() {
		$editIds = $this->input->get('cid', null, 'array');
		if (count($editIds)) {
			$id = (int) $editIds[0];
		} else {
			$id = (int) $this->input->get('id', null, 'int');
		}
		$model = $this->getModel('template');
		if ($model->delete($id)) {
			TemplateckHelper::enqueueMessage('CK_SUCCESS_ITEM_DELETED');
		} else {
			TemplateckHelper::enqueueMessage('CK_ERROR_ITEM_DELETED');
		}

		// Redirect to the edit screen.
//		TemplateckHelper::redirect(TEMPLATECREATORCK_ADMIN_GENERAL_URL);
	}

	/**
	 * Method to save a user's profile data.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public function save() {
		TemplateckHelper::checkToken();

		// Get the user data.
		$data = $this->input->getArray($_POST);

		$model = $this->getModel('template');
		$id = $model->save($data);
//		 $wpdb->print_error();
		if (
				$id === false
			) {
				$msg[] = TCK_Text::_('CK_TEMPLATE_SAVE_ERROR');;
			} else {
				$msg[] = TCK_Text::_('CK_TEMPLATE_SAVED');
			}

		// add the information message
		set_transient( 'templatecreatorck_message', $msg, 60 );

		// redirect to the edition page
		TemplateckHelper::redirect(TEMPLATECREATORCK_ADMIN_URL . '&id=' . (int) $id);
	}

	function cancel() {
		TemplateckHelper::redirect(TEMPLATECREATORCK_ADMIN_GENERAL_URL);
	}

	/**
	* Write the export file
	*/
	public function export() {
		$ids = $this->input->get('cid', null, 'array');
		if (count($ids)) {
			$id = (int) $ids[0];
		} else {
			$id = (int) $this->input->get('id', null, 'int');
		}
		$model = $this->getModel('Template', 'TemplateckModel');
		$model->export($id);
	}

	function download() {
		$filepath = $this->input->get('filepath', '', 'string');
		TemplateckHelper::pushFileForDownload($filepath);
	}
	/**
	 * import a theme from a zip file
	 * @return void
	 */
	function import() {
		$model = $this->getModel('Template', 'TemplateckModel');
		if (!$model->import()) {
			$msg = TCK_Text::_('CK_INSTALL_GABARIT_ERROR');
			$link = TEMPLATECREATORCK_ADMIN_GENERAL_URL;
			$type = 'error';
		} else {
			$msg = TCK_Text::_('CK_GABARIT_INSTALLED');
			$link = TEMPLATECREATORCK_ADMIN_GENERAL_URL;
			$type = 'message';
		}

		TemplateckHelper::redirect($link, $msg, $type);
	}

	/**
	 * import a theme from a zip file
	 * @return void
	 */
	function ajaxImport() {
		TemplateckHelper::checkAjaxToken();
		$input = new TCK_Input();
		$model = $this->getModel('Template', 'TemplateckModel');
		$file = $input->get('gabariturl', null, 'url');

		$id = $model->ajaxInstallGabarit($file);

		echo '{"status" : "' . ($id ? '1' : '0') . '", "id" : "' . $id . '"}';
		exit;
	}
}