<?php
/**
 * @name		Template Creator CK
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access to this file
defined('TCK_LOADED') or die('Restricted access');

$objclass = $this->input->get('objclass', '');
$objid = $this->input->get('ckobjid', '');
$objtype = $this->input->get('element', '');
$expertmode = $this->input->get('expertmode', false);
$saveFunc = $this->input->get('savefunc', '', 'cmd');
$saveFunc = $saveFunc ? $saveFunc . '()' : '';

$showheight = (stristr($objclass, 'mainbanner') OR stristr($objclass, 'bannerlogo') OR stristr($objclass, 'horizmenu')) ? true : false;
$showwidth = ((stristr($objclass, 'wrapper') OR stristr($objclass, 'bannerlogo') OR stristr($objclass, 'banner') OR stristr($objclass, 'column')) AND !stristr($objclass, 'content')) ? true : false;
$isContent = (stristr($objclass, 'content') OR stristr($objclass, 'bannerlogodesc')) ? true : false;
$isBody = stristr($objclass, 'body') ? true : false;
$isWrapper = stristr($objclass, 'wrapper') ? true : false;
$isContainer = (stristr($objclass, 'body') OR stristr($objclass, 'wrapper') OR stristr($objclass, 'mainbanner') OR stristr($objclass, 'bannerlogo') OR stristr($objclass, 'flexiblemodules') OR stristr($objclass, 'maincontent') OR stristr($objclass, 'content') OR stristr($objclass, 'ckrow') OR ( stristr($objclass, 'center') && !stristr($objclass, 'centertop') && !stristr($objclass, 'centerbottom') )) ? true : false;
$isColumn = (stristr($objclass, 'column1') OR stristr($objclass, 'column2')) ? true : false;
$isLogo = (stristr($objclass, 'bannerlogo')) ? true : false;
$isCustomStyle = ($objtype == 'customstyle') ? true : false;
$isFavorite = (stristr($objclass, 'ckmyfavorite')) ? true : false;
$isModulesContainer = stristr($objclass, 'flexiblemodules') ? true : false;
$isMaincontentContainer = stristr($objclass, 'maincontent') ? true : false;
$isSingleModule = (stristr($objclass, 'singlemodule') || (stristr($objclass, 'flexiblemodule') && !stristr($objclass, 'flexiblemodules'))) ? true : false;
$isHoriznav = (stristr($objclass, 'horiznav') || stristr($objclass, 'bannermenu')) ? true : false;
$isRow = (stristr($objclass, 'ckrow')) ? true : false;
$menustyles = new CKInterface();
?>
<div class="ckleftpanelheader">
	<span class="ckleftpaneltitle"><?php echo TCK_Text::_('CK_EDIT') ?>
		<?php if (! $isCustomStyle && ! $isFavorite) { ?><span class="ckleftpanelsubtitle ckleftpanelsubtitleunder">[ <?php echo $objid ?> ]</span><?php } ?>
	</span>
	<span class="ckleftpanelheadericon ckclose ckhastip" title="<?php echo TCK_Text::_('CK_SAVE_CLOSE'); ?>" onclick="<?php echo $saveFunc ?>;ckRenderCss();ckCloseEdition();">×</span>
	<span class="ckleftpanelheadericon cksave ckhastip" title="<?php echo TCK_Text::_('CK_APPLY'); ?>" onclick="ckRenderCss();"><span class="fa fa-check"></span></span>
	<?php if (! $isCustomStyle && ! $isFavorite) { ?>
	<span class="ckleftpanelheadericon ckpaste ckhastip" onclick="ckPasteFromClipboard(this)" title="<?php echo TCK_Text::_('CK_PASTE_CSS'); ?>"><span class="fa fa-clipboard"></span></span>
	<span class="ckleftpanelheadericon ckcopy ckhastip" onclick="ckCopyToClipboard(this)" title="<?php echo TCK_Text::_('CK_COPY_CSS'); ?>"><span class="fa fa-files-o"></span></span>
	<?php } ?>
</div>
<div id="ckelementscontainer" class="ckinterface">
	<?php if ($isCustomStyle) { ?>
		<p></p>
		<div class="ckbutton" onclick="ckRemoveCustomStyle()"><span class="fa fa-remove" style="color:red;"></span> <?php echo TCK_Text::_('CK_DELETE') ?></div>
		<div class="ckoption">
			<?php $this->interface->createLabel('CK_STYLE_NAME', 'text_signature.png') ?>
			<span class="ckoption-field">
				<input class="inputboxfake ckhastip" type="text" title="<?php echo TCK_Text::_('CK_STYLE_NAME_DESC'); ?>" name="ckcustomstylename" id="ckcustomstylename" value="" onchange="ckUpdateCustomStyleData()" />
			</span>
		</div>
		<div class="ckoption">
			<?php $this->interface->createLabel('CK_CSS_SELECTOR', 'text_signature.png') ?>
			<span class="ckoption-field">
				<input class="inputboxfake ckhastip" type="text" title="<?php echo TCK_Text::_('CK_CSS_SELECTOR_DESC'); ?>" name="ckcustomstylecssselector" id="ckcustomstylecssselector" value="" onchange="ckUpdateCustomStyleData()" />
			</span>
		</div>
		<div class="ckproperty" id="tab_blocstyles">
		<?php echo $this->interface->createBlocStyles($objid) ?>
		</div>
	<?php } else if ($isLogo) { ?>
		<div class="ckclr"></div>
		<div id="elementscontent">
			<div class="ckinterfacetablink " tab="tab_blocstyles"><?php echo TCK_Text::_('CK_LOGO_STYLES'); ?></div>
			<div class="ckinterfacetab ckproperty" id="tab_blocstyles">
				<?php echo $menustyles->createLogoStyles('bloc', $objclass) ?>
				<div class="ckclr"></div>
			</div>
			<div class="ckinterfacetablink" tab="tab_logodescstyles"><?php echo TCK_Text::_('CK_LOGODESC_STYLES'); ?></div>
			<div class="ckinterfacetab ckproperty" id="tab_logodescstyles">
				<div class="ckoption">
					<span class="ckoption-label">
						<img class="ckoption-icon" src="<?php echo $this->imagespath; ?>switch.png" width="16" height="16" />
						<?php echo TCK_Text::_('CK_USE_LOGODESC'); ?>
					</span>
					<span class="ckoption-field ckbutton-group">
						<input type="radio" class="logodesc inputbox" value="1" id="uselogodescyes" name="uselogodesc" />
						<label class="ckbutton" for="uselogodescyes"><?php echo TCK_Text::_('JYES'); ?>
						</label><input type="radio" class="logodesc inputbox" value="0" id="uselogodescno" name="uselogodesc" />
						<label class="ckbutton"  for="uselogodescno"><?php echo TCK_Text::_('JNO'); ?>
						</label>
					</span>
					<div class="clr"></div>
				</div>
				<div class="ckoption">
					<span class="ckoption-label">
						<img class="ckoption-icon" src="<?php echo $this->imagespath; ?>text_signature.png" width="16" height="16" />
						<?php echo TCK_Text::_('CK_LOGODESC_TEXT'); ?></span>
					<span class="ckoption-field">
						<input class="logodesc inputbox" type="text" name="logodesctext" id="logodesctext" value="" />
					</span>
					<div class="clr"></div>
				</div>
				<br />
				<?php echo $menustyles->createBlocStyles('logodesc', $objclass, $expertmode, false) ?>
				<div class="ckclr"></div>
			</div>
		</div>
		<?php
	} else {
		$menulinktext = $isWrapper ? TCK_Text::_('CK_WRAPPER_STYLES') : TCK_Text::_('CK_BLOCK_STYLES');
		$blocinfos = $isWrapper ? TCK_Text::_('CK_WRAPPER_INFOS') : TCK_Text::_('CK_BLOC_INFOS');
		$blocdesc = $isWrapper ? TCK_Text::_('CK_WRAPPER_DESC') : TCK_Text::_('CK_BLOC_DESC');
		?>
		<div class="ckclr"></div>
		<div id="elementscontent">
			<?php if ($isWrapper || ($isRow && $expertmode == 'true')) { ?>
				<div class="ckinterfacetablink" tab="tab_bodystyles"><?php echo TCK_Text::_('CK_BODY_STYLES'); ?></div>
				<div class="ckinterfacetab ckproperty" id="tab_bodystyles">
					<?php echo $menustyles->createBlocStyles('body', 'wrapper', $expertmode) ?>
					<div class="ckclr"></div>
				</div>
			<?php } ?>
			<div class="ckinterfacetablink" tab="tab_blocstyles"><?php echo $menulinktext; ?></div>
			<div class="ckinterfacetab ckproperty" id="tab_blocstyles">
				<?php echo $menustyles->createBlocStyles('bloc', $objclass, $expertmode) ?>
				<div class="ckclr"></div>
			</div>
			
			<?php if (($expertmode == 'true' && !$isContainer) || $isColumn) { ?>
				<div class="ckinterfacetablink<?php if ($expertmode == 'true') echo ' ckexpertmode'; ?>" tab="tab_modulestyles"><?php echo TCK_Text::_('CK_MODULES_STYLES'); ?></div>
				<div class="ckinterfacetab ckproperty" id="tab_modulestyles">
					<?php echo $menustyles->createModuleStyles('module', $objclass) ?>
					<div class="ckclr"></div>
				</div>
			<?php } ?>
			<?php if (!$isContainer) { ?>
				<div class="ckinterfacetablink" tab="tab_moduletitlestyles"><?php echo TCK_Text::_('CK_MODULES_TITLE_STYLES'); ?></div>
				<div class="ckinterfacetab ckproperty" id="tab_moduletitlestyles">
					<?php echo $menustyles->createModuletitleStyles('moduletitle', $objclass) ?>
					<div class="ckclr"></div>
				</div>
				<div class="ckinterfacetablink" tab="tab_moduletextstyles"><?php echo TCK_Text::_('CK_MODULES_TEXT_STYLES'); ?></div>
				<div class="ckinterfacetab ckproperty" id="tab_moduletextstyles">
					<?php echo $menustyles->createBlocStyles('moduletext', $objclass) ?>
					<div class="ckclr"></div>
				</div>
				<?php if ($isSingleModule) { ?>
				<div class="ckinterfacetablink" tab="tab_iconstyles"><?php echo TCK_Text::_('CK_ICON_STYLES'); ?></div>
				<div class="ckinterfacetab ckproperty" id="tab_iconstyles">
					<?php echo $menustyles->createIconStyles('icon', $fromicon = '.ckfocus span.fack', $objclass = '', $space = false, $align = true, $font = true) /* onclick="$ck('<?php echo $fromicon ?>').remove()"*/ ?>
					<div class="ckclr"></div>
				</div>
				<?php } ?>
				<?php if ($expertmode == 'true' || $isHoriznav) { ?>
				<div class="ckinterfacetablink<?php if ($expertmode == 'true' && !$isHoriznav) echo ' ckexpertmode'; ?>" tab="tab_menustyles"><?php echo TCK_Text::_('CK_MENUS_STYLES'); ?></div>
				<div class="ckinterfacetab" id="tab_menustyles" style="position:relative;"></div>
				<script>ckLoadTab_menustyles();</script>
				<?php } ?>
			<?php } ?>
			<?php if ($isContainer || $isSingleModule) { ?>
				<div class="ckinterfacetablink" tab="tab_videobgstyles"><?php echo TCK_Text::_('CK_VIDEO_BACKGROUND_STYLES'); ?></div>
				<div class="ckinterfacetab ckproperty" id="tab_videobgstyles">
					<?php echo $menustyles->createVideobgStyles() ?>
					<div class="ckclr"></div>
				</div>
			<?php } ?>
		</div>
	<?php } ?>
</div>
<div class="ckclr"></div>
<script language="javascript" type="text/javascript">
	ckInitOptionsTabs();
	ckInitColorPickers();
	ckInitModalPopup();
	ckInitOptionsAccordions();
</script>