<?php

/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access.
defined('TCK_LOADED') or die;

/**
 * Templateck model.
 */
class TemplateckModelTemplate {

	var $_item = null;

	/**
	 * Method to get an ojbect.
	 *
	 * @param	integer	The id of the object to get.
	 *
	 * @return	mixed	Object on success, false on failure.
	 */
	public function &getData($id = null) {
		// $app = JFactory::getApplication();
		global $wpdb;
		if ($this->_item === null) {
			if ($id) {
				$this->_item = new stdClass();
				$this->_item = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . 'templateck_templates WHERE id=' . (int) $id);
				$this->_item->layouts = $this->getLayouts($id);
			} else {
				$this->_item = new stdClass();
				$this->_item->id = 0;
				$this->_item->joomlaversion = '';
				$this->_item->name = '';
				$this->_item->creationdate = '';
				$this->_item->author = '';
				$this->_item->authoremail = '';
				$this->_item->authorurl = '';
				$this->_item->copyright = '';
				$this->_item->license = '';
				$this->_item->version = '';
				$this->_item->description = '';
				$this->_item->htmlcode = '';
				$this->_item->theme = '';
				$this->_item->cssparams = '';
				$this->_item->options = '';
				$this->_item->widgets = '';
				$this->_item->layouts = array();
			}
		}

		return $this->_item;
	}

	public function getLayouts($id) {
		global $wpdb;
		$layouts = $wpdb->get_results('SELECT id,type,htmlcode FROM ' . $wpdb->prefix . 'templateck_layouts WHERE template_id=' . (int) $id);

		$l = $this->initLayouts();
		foreach($layouts as $layout) {
			$l[$layout->type] = new stdClass();
			$l[$layout->type]->id = $layout->id;
			$l[$layout->type]->htmlcode = $layout->htmlcode;
		}

		return $l;
	}

	private function initLayouts() {
		$l = array();
		$types = array('comments', 'error404');

		foreach ($types as $type) {
			$l[$type] = new stdClass();
			$l[$type]->id = 0;
			$l[$type]->htmlcode = '';
		}
		return $l;
	}

	public function save($data) {
		global $wpdb;
		$id = (int) $data['id'];
		$table = $wpdb->prefix . 'templateck_templates';
		$ck_post = array(
			'id' => $id,
			'joomlaversion' => '',
			'name' => sanitize_text_field($data['name']),
			'ordering' => 0,
			'published' => 1,
			'creationdate' => sanitize_text_field($data['creationdate']),
			'author' => sanitize_text_field($data['author']),
			'authoremail' => sanitize_text_field($data['authoremail']),
			'authorurl' => sanitize_text_field($data['authorurl']),
			'copyright' => sanitize_text_field($data['copyright']),
			'license' => sanitize_text_field($data['license']),
			'version' => sanitize_text_field($data['version']),
			'description' => sanitize_text_field($data['description']),
			'htmlcode' =>  stripslashes($_POST['htmlcode']),
			'stylecode' =>  stripslashes($_POST['stylecode']),
			'theme' => '',
			'cssparams' => '',
			'options' => '',
			'widgets' => $data['widgets'],
			'htmlcode_responsive' => $data['htmlcode_responsive']
		);
		$format = $this->getPostFormat();

		// make a backup before save
		$this->makeBackup($id);

		// save the post into the database
//		$wpdb->show_errors();
		if ($id === 0) {
			$save = $wpdb->insert( $table, $ck_post, $format );
			$ck_post_id = $wpdb->insert_id;
		} else {
			$where = array( 'id' => $id );
			$save = $wpdb->update( $table, $ck_post, $where, $format );
			$ck_post_id = $id;
		}
//		$wpdb->print_error();

		// save the layouts
		if (isset($_POST['layouts']) && count($_POST['layouts'])) {
			$layouts = $_POST['layouts'];
			$layoutsid = $_POST['layoutsid'];
			foreach ($layouts as $name => $layout) {
				$layout_id = $layoutsid[$name] ? $layoutsid[$name] : 0;
				$table = $wpdb->prefix . 'templateck_layouts';
				$ck_post = array(
					'id' => $layout_id,
					'template_id' => (int) $ck_post_id,
					'type' => sanitize_text_field($name),
					'htmlcode' => trim($layout),
					'styles' => '',
					'published' => 1
				);
				$format = array( 
					'%d',
					'%d',
					'%s',
					'%s',
					'%s',
					'%d'
				);

				if ($layout_id === 0) {
					$save2 = $wpdb->insert( $table, $ck_post, $format );
					$ck_layout_id = $wpdb->insert_id;
				} else {
					$where = array( 'id' => $layout_id);
					$save2 = $wpdb->update( $table, $ck_post, $where, $format );
					$ck_layout_id = $layout_id;
				}
			}
		}

		$return = $ck_post_id;

		return $return;
	}

	public function delete($id) {
		global $wpdb;
		$table = $wpdb->prefix . 'templateck_templates';
		$where = array( 'id' => (int)$id );
		return $wpdb->delete( $table, $where, $where_format = null );
	}

	public function copy($id) {
		global $wpdb;

		$query = 'SELECT * FROM ' . $wpdb->prefix . 'templateck_templates WHERE id=' . (int) $id;

		$this->_item = $wpdb->get_row($query);
		$format = $this->getPostFormat();
		$post = $this->getPostData(0, $this->_item->name . '(copy)', $this->_item->htmlcode, $this->_item->stylecode);
		return $wpdb->insert( $wpdb->prefix . 'templateck_templates', $post, $format );
	}
	
	public function getPostFormat() {
		$format = array( 
			'%d',
			'%s',
			'%s',
			'%d',
			'%d',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s',
			'%s' 
		);

		return $format;
	}

	public function getPostData($id, $name, $htmlcode, $stylecode) {
		$post = array(
			'id' => (int) $id,
			'joomlaversion' => '',
			'name' => sanitize_text_field($name),
			'ordering' => 0,
			'published' => 1,
			'creationdate' => '',
			'author' => '',
			'authoremail' => '',
			'authorurl' => '',
			'copyright' => '',
			'license' => '',
			'version' => '',
			'description' => '',
			'htmlcode' =>  $htmlcode,
			'theme' => '',
			'cssparams' => '',
			'options' => '',
			'htmlcode_responsive' => '',
			'stylecode' =>  $stylecode
		);

		return $post;
	}
	
	public function bindPostData($post) {
		$post = array(
			'id' => (int) $post->id,
			'joomlaversion' => sanitize_text_field($post->joomlaversion),
			'name' => sanitize_text_field($post->name),
			'ordering' => (int) $post->ordering,
			'published' => (int) $post->published,
			'creationdate' => sanitize_text_field($post->creationdate),
			'author' => sanitize_text_field($post->author),
			'authoremail' => sanitize_text_field($post->authoremail),
			'authorurl' => sanitize_text_field($post->authorurl),
			'copyright' => sanitize_text_field($post->copyright),
			'license' => sanitize_text_field($post->license),
			'version' => sanitize_text_field($post->version),
			'description' => sanitize_text_field($post->description),
			'htmlcode' =>  $post->htmlcode,
			'theme' => sanitize_text_field($post->theme),
			'cssparams' => sanitize_text_field($post->cssparams),
			'options' => sanitize_text_field($post->options),
			'htmlcode_responsive' => sanitize_text_field($post->htmlcode_responsive),
			'stylecode' =>  $post->stylecode
		);

		return $post;
	}
	
	/**
	 * Method to install a gabarit
	 *
	 * @access	public
	 * @return	true on success
	 */
	public function import() {
	  $input = new TCK_Input();
	  $file = $input->files->get('file', '', 'array');

		if (!is_array($file))
			return false;

		// check if the file has been transfered by the server
		if ($file['tmp_name'] == '' || $file['error'] == 1) {
			$msg[] = Array("text" => TCK_Text::_('CK_FILE_NOT_UPLOADED_BY_SERVER'), "type" => 'error');
			// add the information message
			set_transient( 'templatecreatorck_message', $msg, 60 );

			return false;
		}

		//Clean up filename to get rid of strange characters like spaces etc
		$filename = TCK_File::makeSafe($file['name']);

		// check if the file exists
		if (TCK_File::getExt($filename) != 'tck3' && TCK_File::getExt($filename) != 'tck3z') {
			$msg[] = Array("text" => TCK_Text::_('CK_NOT_TCK3_AND_NOT_TCK3Z_FILE'), "type" => 'error');
			// add the information message
			set_transient( 'templatecreatorck_message', $msg, 60 );

			return false;
		}

		if (TCK_File::getExt($filename) === 'tck3') {
			if (! $this->import_tck3_file($file) ) {
				$msg[] = Array("text" => TCK_Text::_('CK_NOT_TCK3_AND_NOT_TCK3Z_FILE'), "type" => 'error');
				// add the information message
				set_transient( 'templatecreatorck_message', $msg, 60 );

				return false;
			}
		} else if (TCK_File::getExt($filename) === 'tck3z') {
			if (! $this->import_tck3z_file($file) ) {
				return false;
			}
		}

		return true;
	}
	
	private function import_tck3_file($file) {
		global $wpdb;

		//Set up the source and destination of the file
		$src = $file['tmp_name'];

		// check if the file exists
		if (!$src || !TCK_File::exists($src)) {
			$msg[] = Array("text" => TCK_Text::_('CK_FILE_NOT_EXISTS'), "type" => 'error');
			// add the information message
			set_transient( 'templatecreatorck_message', $msg, 60 );

			return false;
		}

		// read the file
		if (!$filecontent = TCK_File::read($src)) {
			$msg[] = Array("text" => TCK_Text::_('CK_UNABLE_READ_FILE'), "type" => 'error');
			// add the information message
			set_transient( 'templatecreatorck_message', $msg, 60 );

			return false;
		}


		$tck_uri = trim(str_replace(site_url(), '', plugins_url() . '/template-creator-ck'), '/');
		$filecontent = str_replace("|URIBASE|", site_url() . "/", $filecontent);
		$filecontent = str_replace("|TCK_COMPONENT|", $tck_uri, $filecontent);
		$filecontent = str_replace("|TCK_ADMIN_COMPONENT|", $tck_uri, $filecontent);

		$gabarittmp = explode("||TCK||", $filecontent);
		$gabarit = isset($gabarittmp[0]) ? json_decode($gabarittmp[0]) : json_decode($filecontent);
		if ($gabarit === null)
			return false;
		$gabaritmobile = isset($gabarittmp[1]) ? json_decode($gabarittmp[1]) : json_decode('{}');
		$gabarit->id = '0'; // set id to 0 to automatically increment value in database
		$gabarit->htmlcode = str_replace("|IMPORTFOLDER|", $tck_uri . '/imported/' . $gabarit->name . '/images', $gabarit->htmlcode);
		$gabarit->htmlcode = stripslashes($gabarit->htmlcode);
		
		// do the replacement also for the stylecode
		if (isset($gabarit->stylecode)) {
			$gabarit->stylecode = str_replace("|IMPORTFOLDER|", $tck_uri . '/imported/' . $gabarit->name . '/images', $gabarit->stylecode);
			$gabarit->stylecode = stripslashes($gabarit->stylecode);
		}

		// store the gabarit in the DB
		$format = $this->getPostFormat();
		$post = $this->bindPostData($gabarit);
		$wpdb->insert( $wpdb->prefix . 'templateck_templates', $post, $format );
		$id = $wpdb->insert_id;

		return $id;
	}
	
	private function import_tck3z_file($file) {
		include_once TEMPLATECREATORCK_PATH . '/helpers/zip.php';

		// instanciate ZIP archiver
		$archiver = new CKArchiveZip();

		$tck_path_root = WP_PLUGIN_DIR . '/template-creator-ck/';
		// extract archive
		$gabarit_folder_name = TCK_File::stripext($file['name']);
		$template_folder_name = str_replace('_gabarit', '', $gabarit_folder_name);
		$dest_extracted_zip_folder = $tck_path_root . '/tmp/' . $gabarit_folder_name;
		$themepath = get_theme_root() . '/' . $template_folder_name;

		$isSuccess = $archiver->extract($file['tmp_name'], $dest_extracted_zip_folder, $options = array());

		if ($isSuccess === false) {
			return false;
		}

		// import the tck3 gabarit file
		$gabarit_file = array('tmp_name' => $dest_extracted_zip_folder . '/' . $template_folder_name . '.tck3');
		$id = $this->import_tck3_file($gabarit_file);
		if ($id === false) {
			return false;
		}

		// create the destination folder for images
		if (! TCK_Folder::exists( $tck_path_root . '/imported/'. $template_folder_name . '/images/'  ) ) {
			TCK_Folder::create( $tck_path_root . '/imported/'. $template_folder_name . '/images/'  );
		}
		// copy the images
		$exclude_files = array('tck3','css','php');
		$files = TCK_Folder::files($dest_extracted_zip_folder, false, true, true);
		foreach ($files as $file) {
			$filename = explode('/', $file);
			$filename = end($filename);
			if (! in_array(TCK_File::getExt($file), $exclude_files) ) {
				TCK_File::copy($file, $tck_path_root . '/imported/'. $template_folder_name . '/images/' . $filename);
			}
		}

		if (! TCK_Folder::exists( $themepath ) ) {
			TCK_Folder::create( $themepath );
		}

		// copy the custom.css file
		if ( TCK_File::exists($dest_extracted_zip_folder . '/custom.css' ) ) {
			// create the destination folder for css
			if (! TCK_Folder::exists( $themepath . '/css' ) ) {
				TCK_Folder::create( $themepath . '/css' );
			}
			TCK_File::copy($dest_extracted_zip_folder . '/custom.css', $themepath . '/css/custom.css' );
		}

		// copy the customheader.php file
		if ( TCK_File::exists($dest_extracted_zip_folder . '/customheader.php' ) ) {
			// create the destination folder for css
			TCK_File::copy($dest_extracted_zip_folder . '/customheader.php', $themepath . '/customheader.php' );
		}

		// copy the html folder
		if ( TCK_Folder::exists( $dest_extracted_zip_folder . '/html' ) ) {
			// create the destination folder for css
			if (! TCK_Folder::exists( $tck_path_root . '/imported/' . $template_folder_name . '/html' ) ) {
				TCK_Folder::create( $tck_path_root . '/imported/' . $template_folder_name . '/html' );
			}
			TCK_Folder::copy($dest_extracted_zip_folder . '/html', $tck_path_root . '/imported/' . $template_folder_name . '/html', '', true);
		}

		// remove the copy from the tmp folder
		TCK_Folder::delete($dest_extracted_zip_folder);

		return $id;
	}
	
	public function export($id) {
		$input = new TCK_Input();
		// path to store the file
		$path = TEMPLATECREATORCK_PATH . '/export';
		$id = $input->get('id', $id, 'int');

		// get the item data
		$item = $this->getData($id);
		$name = $input->get('name', $item->name, 'string');

		// get the item encoded to be saved
//		$exportfiletext = $model->getExportFile($item);
		$exportfiletext = TemplateckHelper::getExportFile($item);
		$exportfiledest = $path . '/' . $name . '.tck3';
		// delete the gabarit folder and recreate it, so it is empty
		if (TCK_Folder::exists($path . '/' . $name . '_gabarit/')) {
			TCK_Folder::delete($path . '/' . $name . '_gabarit/');
		}
		TCK_Folder::create($path . '/' . $name . '_gabarit/');

		// replace the path for imageurl data
		preg_match_all('/imageurl=\\\"(.*?)\\\"/i', $exportfiletext, $files);
		preg_match_all('/customimage.?=\\\"(.*?)\\\"/i', $exportfiletext, $files2);

		$allimgs = array_merge($files[1], $files2[1]);

		foreach ($allimgs as $i => $file) {
			if (! $file) continue;
			$filename = explode('/', $file);
			$filename = end($filename);

			$exportfiletext = str_replace('imageurl=\"' . $file, 'imageurl=\"|IMPORTFOLDER|\/' . $filename , $exportfiletext);
			$exportfiletext = str_replace('<img src=\"\/' . $file, '<img src=\"|URIBASE|\/|IMPORTFOLDER|\/' . $filename , $exportfiletext);
			$exportfiletext = str_replace("url('\/" . $file, "url('|URIBASE|\/|IMPORTFOLDER|\/" . $filename , $exportfiletext);
			if (TEMPLATECREATORCK_URI_ROOT && TEMPLATECREATORCK_URI_ROOT != '/') 
				$exportfiletext = str_replace(addcslashes(TEMPLATECREATORCK_URI_ROOT, '/'), '|URIBASE|', $exportfiletext);
			$file = str_replace('|URIBASE|\/', '', $file);
			$exportfiletext = str_replace($file, '|IMPORTFOLDER|\/' . $filename , $exportfiletext);

			// save the images
			$localfile = trim(stripslashes(str_replace('|URIBASE|', '', $file)), '/');
			if (! TCK_File::copy(TEMPLATECREATORCK_SITE_ROOT . '/' . $localfile, $path . '/' . $name . '_gabarit/' . $filename) ) {
				$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_COPY_IMAGE') . ' : ' . TEMPLATECREATORCK_SITE_ROOT . '/' . $localfile . '</p>';
			} else {
				$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_COPY_IMAGE') . ' : ' . TEMPLATECREATORCK_SITE_ROOT . '/' . $localfile . '</p>';
			}
			echo $msg;
		}

		// replace the path for <img /> tags
		preg_match_all('/ <img src=\\\"(.*?)\\\"/i', $exportfiletext, $imgs);
		foreach ($imgs[1] as $i => $file) {
			$filename = explode('/', $file);
			$filename = end($filename);
			$exportfiletext = str_replace($file, '|URIBASE|\/|IMPORTFOLDER|\/' . $filename , $exportfiletext);
		}


		// create the file .tck3
		$exportfiletext = str_replace("administrator/components/com_templateck", "|TCK_ADMIN_COMPONENT|",  $exportfiletext);
		$exportfiletext = str_replace("components/com_templateck", "|TCK_COMPONENT|",  $exportfiletext);
		if (!TCK_File::write($exportfiledest, $exportfiletext)) {
			$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATE_GABARIT') . '</p>';
		} else {
			$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATE_GABARIT') . '</p>';
		}
		echo $msg;

		// save the gabarit file
		if (! TCK_File::copy($exportfiledest, $path . '/' . $name . '_gabarit/' . $name . '.tck3' ) ) {
			$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_COPY_GABARIT') . '</p>';
		} else {
			$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_COPY_GABARIT') . '</p>';
		}
		echo $msg;


		// save the html folder
		if (TCK_Folder::exists( $path . '/' . $name . '/html' ) ) {
			TCK_Folder::create($path . '/' . $name . '_gabarit/html');
			TCK_Folder::copy($path . '/' . $name . '/html', $path . '/' . $name . '_gabarit/html/', '', true);
		}

		// save the custom.css file
		if (TCK_File::exists($path . '/' . $name . '/css/custom.css') ) {
			TCK_File::copy($path . '/' . $name . '/css/custom.css', $path . '/' . $name . '_gabarit/custom.css' );
		}

		// save the customheader.php file
		if (TCK_File::exists($path . '/' . $name . '/customheader.php') ) {
			TCK_File::copy($path . '/' . $name . '/customheader.php', $path . '/' . $name . '_gabarit/customheader.php' );
		}

		// save the custom js file
		if (TCK_File::exists($path . '/' . $name . '/js/custom.js') ) {
			TCK_File::copy($path . '/' . $name . '/js/custom.js', $path . '/' . $name . '_gabarit/custom.js' );
		}


		//save the modules data
		/*if (! empty($item->modules)) {
			$modules = explode(',', $item->modules);
			$modulesdata = array();
			$db = JFactory::getDbo();
			foreach($modules as $module) {
				$query = "SELECT * FROM #__modules WHERE position='" . $module . "' AND published='1' AND client_id='0'";
				$db->setQuery($query);
				$moduleObj = $db->loadObjectList();

				if (!empty($moduleObj)) {
					$modulesdata = array_merge($moduleObj, $modulesdata);
				} else {
					// add the SQL field to the main table
		//			$db->setQuery('ALTER TABLE `#__templateck_fonts` ADD `alternatives` text NOT NULL;');
		//			if (!$db->query()) {
		//				echo '<p class="alert alert-danger">Error during export of module ID ' . $moduleObj->id .'</p>';
		//			} else {
		//				echo '<p class="alert alert-success">Table alternatives updated !</p>';
		//			}
				}
			}
			$modulesdata = serialize($modulesdata);
			file_put_contents($path . '/' . $name . '_gabarit/modules.txt', $modulesdata);
		}*/

		// save the template into zip
		$templatePath = TEMPLATECREATORCK_SITE_ROOT . '/themes/' . $name;
		if (TCK_Folder::exists($templatePath)) {
			$files = TCK_Folder::files($templatePath, false, true, true);
			$exporter = new ZipArchiver();
			$isSuccess = $exporter->create($files, $templatePath . '.zip', $templatePath , true);

			TCK_File::copy(TEMPLATECREATORCK_SITE_ROOT . '/themes/' . $name . '.zip', $path . '/' . $name . '_gabarit/' . $name . '.zip');
			// return message after creating the zip archive
			if (!$isSuccess && $exporter->getError()) {
				$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_ARCHIVE') . '</p>';
			} else {
				$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_ARCHIVE') . '</p>';
			}
		}

		echo $msg;

		$files = TCK_Folder::files($path . '/' . $name . '_gabarit/', false, true, true);
		$exporter = new ZipArchiver();
		$isSuccess = $exporter->create($files, $path . '/' . $name . '_gabarit.tck3z',$path . '/' . $name . '_gabarit', true);
		echo '<p style="padding: 15px;"><a class="ckdownload" style="background: #3D3D3D;border-radius: 3px;color: #E1E1E1;cursor: pointer;margin: 3px;padding: 2px 5px;text-decoration: none;" target="_blank" href="' . TEMPLATECREATORCK_MEDIA_URI . '/export/' . $name . '_gabarit.tck3z">' . TCK_Text::_('CK_DOWNLOAD_GABARIT') . '</a></p>';
//		TemplateckHelper::pushFileForDownload($name . '_gabarit.tck3z', );
//		header("Location: " . JURI::root() . "administrator/components/com_templateck/export/" . $name . "_gabarit.tck3z");
		// or however you get the path

		exit;
	}

	public function makeBackup($id) {
		$path = TEMPLATECREATORCK_PATH . '/backup';

		// get item
		$item = $this->getData($id);
		$exportfiletext = json_encode($item);
		
		// create the folder
		if (! TCK_Folder::exists($path . '/' . $item->id . '_bak/')) {
			TCK_Folder::create($path . '/' . $item->id . '_bak/');
		}

		// check if we have more than 5 existing backups, delete the old one
		$existingBackups = TCK_Folder::files($path . '/' . $item->id . '_bak/', '^backup_' . $item->id);
		if (count($existingBackups) > 5) {
//			$this->deleteOldestBackup($path . '/' . $item->id . '_bak/');
			natsort($existingBackups);
			$oldest = $existingBackups[0];
			TCK_File::delete($path . '/' . $item->id . '_bak/' . $oldest);
		}

		$exportfiledest = $path . '/' . $item->id . '_bak/backup_' . $item->id . '_' . date("d-m-Y-G-i-s") . '.tck3';
		TCK_File::write($exportfiledest, $exportfiletext);
		
	}

	/**
	 * Method to install a gabarit
	 *
	 * @access	public
	 * @return	true on success
	 */
	public function ajaxInstallGabarit($url) {

		set_time_limit(0);
		try {
			$file = file_get_contents(urldecode($url));
		} catch (Exception $e) {
			echo 'Exception : ',  $e->getMessage(), "\n";
			exit;
		}
		$names = explode('/', $url);
		$filename = end($names);
		$name = TCK_File::stripExt($filename);

		$dest = TEMPLATECREATORCK_PATH . '/tmp/' . $name . '.zip';
		file_put_contents($dest, $file);

		// give the gabarit file to import
		$ffile = array('name' => $name, 'tmp_name' => $dest);
		$id = $this->import_tck3z_file($ffile);

		return $id;
	}

}