<?php
defined('TCK_LOADED') or die;
$input = new TCK_Input();

//Our class extends the WP_List_Table class, so we need to make sure that it's there
if (!class_exists('TCK_ListTable')) {
	require_once( TEMPLATECREATORCK_PATH . '/helpers/cklisttable.php' );
}

if (!class_exists('TCK_ListTableFont')) {
	require_once( TEMPLATECREATORCK_PATH . '/helpers/cklisttablefont.php' );
}


//Prepare Table of elements
$wp_list_table = new TCK_ListTableFont();
$wp_list_table->prepare_items();
?>
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URL ?>/assets/ckframework.css" type="text/css" />
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URL ?>/assets/templateck.css" type="text/css" />
<div class="ckadminwrap">
	<?php echo TemplateckHelper::displayMessages(); ?>
	<img src="<?php echo TEMPLATECREATORCK_MEDIA_URL ?>/images/logo_templatecreatorck_64.png" style="float:left; margin: 0px 5px;" />
	<h2>Template Creator CK - <?php echo _('Fonts') ?>
<?php
	// echo ' <a href="admin.php?page=templatecreatorck_fonts&id=0" class="add-new-h2">' . __('Add New') . '</a>';
?></h2>
<div style="clear:both;margin-bottom: 10px;"></div>
<div class="ckalert"><?php echo TCK_Text::_('CK_GOOGLEFONT_INSTALL_INFOS'); ?></div>
<?php 
if (current_user_can('edit_plugins')) {
	if (isset($_GET['task']) && $_GET['task'] === 'edit' && isset($_GET['id']) && (int)$_GET['id'] !== 0) {
		global $wpdb;
		$query = 'SELECT name,subset,alternatives FROM '. $wpdb->prefix . 'templateck_fonts WHERE id=' . (int)$_GET['id'];
		$font = $wpdb->get_row($query, OBJECT);
	?>
	<form action="" method="post" enctype="multipart/form-data" name="adminForm" id="adminForm" class="">
		<div>
			<fieldset class="adminform" style="border: 1px solid rgb(204, 204, 204); padding: 10px;">
				<h3><?php echo TCK_Text::_('CK_EDIT_FONT'); ?></h3>
				<table class="admintable">
					<tr>
						<td width="110" class="key">
							<label for="title">
								<?php echo TCK_Text::_('CK_FONT_NAME'); ?>:
							</label>
						</td>
						<td colspan="3">
							<input class="inputbox" type="text" name="name" id="name" size="60" value="<?php echo $font->name ?>" />
						</td>
					</tr>
					<tr>
						<td width="110" class="key">
							<label for="title">
								<?php echo TCK_Text::_('CK_SUBSET'); ?>:
							</label>
						</td>
						<td>
							<input class="inputbox" type="text" name="subset" id="subset" size="30" value="<?php echo $font->subset ?>" />
						</td>
						<td>
							<small><?php echo TCK_Text::_('CK_SUBSET_DESC'); ?></small>
						</td>
					</tr>
					<tr>
						<td width="110" class="key">
							<label for="title">
								<?php echo TCK_Text::_('CK_ALTERNATIVES'); ?>:
							</label>
						</td>
						<td>
							<input class="inputbox" type="text" name="alternatives" id="alternatives" size="30" value="<?php echo $font->alternatives ?>" />
						</td>
						<td>
							<small><?php echo TCK_Text::_('CK_ALTERNATIVES_DESC'); ?></small>
						</td>
					</tr>
					<tr>
						<td colspan="2">
							<input type="submit" name="submitbutton" class="ckbutton" value="<?php echo TCK_Text::_('CK_SAVE_FONT'); ?>" />
						</td>
					</tr>
				</table>
			</fieldset>
		</div>
		<input type="hidden" name="action" value="edit_font"/>
		<input type="hidden" name="_wpnonce" value="<?php echo wp_create_nonce('templatecreatorck_editfont'); ?>" />
	</form>
	<?php
	} else {
?>
	<form action="<?php echo admin_url() ?>admin.php?page=templatecreatorck_fonts" method="post" enctype="multipart/form-data" name="adminForm" id="adminForm" class="form-validate">
		<div>
			<fieldset class="adminform" style="border: 1px solid rgb(204, 204, 204); padding: 10px;margin: 10px 0;">
				<h3><?php echo TCK_Text::_('CK_INSTALL_FONTSQUIRREL'); ?></h3>
				<div class="alert alert-info"><?php echo TCK_Text::_('CK_HOW_TO_DL_FONTKIT'); ?></div>
				<table class="admintable">
					<tr>
						<td width="110" class="key">
							<label for="title">
								<?php echo TCK_Text::_('File (.zip) to import'); ?>:
							</label>
						</td>
						<td>
							<input class="inputbox" type="file" name="fontsquirrel_file" id="fontsquirrel_file" size="60" />
							
						</td>
						<tr>
							<td width="110" class="key">
								<label for="title">
									<?php echo TCK_Text::_('CK_ALTERNATIVES'); ?>:
								</label>
							</td>
							<td>
								<input class="inputbox" type="text" name="sqfontalternatives" id="sqfontalternatives" size="30" />
							</td>
							<td>
								<small><?php echo TCK_Text::_('CK_ALTERNATIVES_DESC'); ?></small>
							</td>
						</tr>
						<tr>
						<td colspan="2">
							<input type="submit" name="submitbutton" class="ckbutton" value="<?php echo TCK_Text::_('CK_INSTALL_FONT'); ?>" />
						</td>
					</tr>
					</tr>
				</table>
				<iframe style="margin: 10px 10px 0 10px;" width="340" height="180" src="http://www.youtube.com/embed/RXNlVevvKHY" frameborder="0" allowfullscreen></iframe>
			</fieldset>
		</div>

		<input type="hidden" name="action" value="install_fontsquirrel"/>
		<input type="hidden" name="_wpnonce" value="<?php echo wp_create_nonce('templatecreatorck_install_fontsquirrel'); ?>" />
	</form>

<?php
	}
}
?>
	<div style="clear:both;"></div>
	<form id="fonts-filter" method="get">
		<input type="hidden" name="page" value="<?php echo esc_attr( $_REQUEST['page'] ) ?>" />
		<input type="hidden" name="post_status" class="post_status_page" value="<?php echo!empty($_REQUEST['post_status']) ? esc_attr($_REQUEST['post_status']) : 'all'; ?>" />
		<input type="hidden" name="post_type" class="post_type_page" value="templateck_font" />
<?php
$wp_list_table->display()
?>
	</form>
</div>