<?php
/**
 * @name		Template Creator CK
 * @copyright	Copyright (C) since 2011. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// no direct access
defined('TCK_LOADED') or die;
require_once(TEMPLATECREATORCK_PATH . '/helpers/ckwidgets.php');
//require_once(TEMPLATECREATORCK_PATH . '/helpers/ckmodules.php');
?>
<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<?php require_once('edit_head.php'); ?>
</head>
<body class="cktemplatecreatorinterface <?php echo ($this->item->htmlcode ? '' : 'ckfirststep') ?>">
<?php 
// manage the information messages
TemplateckHelper::displayMessages();
//
// BC compatibility
if (empty($this->item->modules)) $this->item->modules = '';
// loads the needed files for the widgets
// check first that the widgets are defined, because of retrocompatibility
// get the list of widgets
$widgets = CKWidgets::loadWidgets();
// get the widgets states from the template settings
if (empty($this->item->widgets)) {
	$this->item->widgets = '';
} else {
	$itemWidgets = json_decode(str_replace('|qq|', '"', $this->item->widgets));
}
?>
<div id="widgetsElements">
<?php
if (count($widgets)) {
	foreach ($widgets as $widget) {
		$state = '0';
		$data = '';
		if (isset($itemWidgets->{$widget->name})) {
			$state = $widget->installed ? $itemWidgets->{$widget->name}->enabled : '0';
			$data = $itemWidgets->{$widget->name}->data;
		}
?>
		<div class="widget" data-name="<?php echo $widget->name ?>" data-enabled="<?php echo $state ?>">
			<div class="widgetdata"><?php echo $data ?></div>
		</div>
<?php
	}
}

?>
</div>
<div id="bootstrapload"><link rel="stylesheet" type="text/css" href="<?php echo TEMPLATECREATORCK_PLUGIN_URL ?>/default.css"></div>
<div id="googlefontscall"></div>
<form action="<?php echo (TEMPLATECREATORCK_ADMIN_URL  . '&id=' . (int) $this->item->id); ?>" enctype="multipart/form-data" method="post" name="adminForm" id="adminForm" class="form-validate">
	<input type="hidden" name="htmlcode" id="htmlcode" value="" />
	<input type="hidden" name="stylecode" id="stylecode" value="" />
	<input type="hidden" name="htmlcode_responsive" id="htmlcode_responsive" value="<?php echo str_replace('"', '|qq|',  $this->item->htmlcode_responsive); ?>" />
	<input type="hidden" name="option" value="com_templateck" />
	<input type="hidden" name="widgets" id="widgets" value="<?php echo $this->item->widgets; ?>" />
	<input type="hidden" name="modules" id="modules" value="<?php echo $this->item->modules; ?>" />
	<input type="hidden" class="layoutfield" name="layouts[error404]" id="layouts_error404" data-type="error404" value="" />
	<input type="hidden" class="layoutfieldid" name="layoutsid[error404]" id="layoutsid_error404" data-type="error404" value="<?php echo $this->item->layouts['error404']->id; ?>" />
	<input type="hidden" name="id" value="<?php echo $this->item->id; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="controller" value="templateck" />
	<input type="hidden" name="_wpnonce" value="<?php echo wp_create_nonce('templatecreatorck_save'); ?>" />
	<?php require_once('edit_globalinfos.php'); ?>
</form>
<?php require_once('edit_mediamanager.php'); ?>
<?php require_once('edit_mainmenu.php'); ?>
<?php require_once('edit_leftpanel.php'); ?>
<div id="ckedition" class="ckleftpanel">
	<?php /* the left panel edition will take place here */ ?>
</div>
<div id="cktemplatecontainer">
	<div id="ckstylescontainer">
		<?php if (isset($this->item->stylecode)) { ?>
			<?php echo $this->item->stylecode; ?>
		<?php } ?>
	</div>
	<div id="ckhtmlcontainer" class="focusbar focus">
		<?php
		if ($this->item->htmlcode) {
			echo $this->item->htmlcode;
		} else {
			require_once('edit_modeles.php');
		}
		?>
	</div>
	<div class="clr"></div>
	<?php require_once('edit_stylescreator.php'); ?>
</div>
<div class="clr"></div>
<?php //require_once('edit_package.php'); ?>
<?php require_once('edit_restore.php'); ?>
<?php require_once('edit_replacecolors.php'); ?>
<?php require_once('edit_wizard.php'); ?>
<div id="tab_customcode"></div>
<div id="tab_customcss"></div>
<div id="tab_customjs"></div>
<div id="tab_customfunctions"></div>
<div id="layout_error404_html" class="ckbloc ckbloclayout">
	<?php echo ($this->item->layouts['error404']->htmlcode ? $this->item->layouts['error404']->htmlcode : '<div class="ckstyle"></div>'); ?>
</div>
<div id="ckpopup"></div>
</body>
</html>