<?php

/**
 * @name		Template Creator CK
 * @copyright	Copyright (C) since 2011. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access
defined('TCK_LOADED') or die;
//jimport('joomla.application.component.view');

/**
 * View to edit
 */
class TemplateckViewTemplate extends TemplateckView {

	protected $state;
	protected $item;
	protected $form;

	/**
	 * Display the view
	 */
	public function display($tpl = null) {

		$this->view = 'template';
		global $wpdb;

		// check if the user has the rights to access this page
		if (!current_user_can('manage_options')) {
			wp_die(__('You do not have sufficient permissions to access this page.'));
		}
		$id = $this->input->get('id', 0, 'int');
		$this->item = $this->get('template', 'Data', $id);
		$this->isTemplateInstalled = $this->_checkIfTemplateInstalled($this->item->name);
		$this->imagespath = TEMPLATECREATORCK_MEDIA_URI . '/images/menustyles/';
		$this->interface = new CKInterface();
		$this->input = new TCK_Input();

		parent::display($tpl);
	}

	/**
	 * private function to load the fonts in the page
	 */
	function _callfonts() {
		$fontstyles = '';
		$fontsheets = '';

		global $wpdb;
		$query = 'SELECT * FROM '. $wpdb->prefix . 'templateck_fonts';
		$query.=' ORDER BY id ASC';
		$rows = $wpdb->get_results($query, OBJECT);

		if (!$rows)
			return false;

		foreach ($rows as $row) {
			if (stristr($row->styles, '@import')) 
			{
				$fontsheets .= str_replace(");", "' rel='stylesheet' type='text/css'>", str_replace("@import url(", "<link href='", $row->styles));
			} else {
				$fontstyles .= str_replace("url('", "url('" . TEMPLATECREATORCK_MEDIA_URL . "/fonts/" . $row->name . "/", $row->styles);
			}
		}
		if ($fontstyles)
			echo "<style type=\"text/css\">" . $fontstyles . "</style>";
		if ($fontsheets)
			echo $fontsheets;
	}

	/**
	 * private function to check if the template templatecreatorck is installed
	 */
	function _checkIfTemplateInstalled($name) {
		if (! $name) return false;
		if (! TCK_Folder::exists( get_theme_root() . '/' . $name )) {
			return false;
		} else {
			return true;
		}

		return false;
	}

}