<?php

/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access to this file
defined('ABSPATH') or die('Restricted access');
// jimport('joomla.filesystem.file');
$input = new TCK_Input();
$templatename = $input->get('templatename', '', 'string');
$saveintemplate = $input->get('saveintemplate') == 'copy' ? true : false;
// $path = TCK_PATH_COMPONENT . '/projects/' . $templatename;
$path = get_theme_root() . '/' . $templatename;

if ($saveintemplate == true) {
	$defaulttemplatesrc = $path;
	$defaulttemplatedest = site_url() . '/wp-content/themes/' . $templatename;

	// check if template aldready intalled
	if (!TCK_Folder::exists($defaulttemplatedest)) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_TEMPLATECOPY_TEMPLATENOTINSTALLED') . '</p>';
		echo $msg;
	} else {
		/*if (!TCK_Folder::delete($defaulttemplatedest)) {
			$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_DELETING_TEMPLATE_FOLDER') . '</p>';
		} else {
			$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_DELETING_TEMPLATE_FOLDER') . '</p>';
		}
		echo $msg;*/

		// make that the path are written the same
		$defaulttemplatesrc = str_replace('\\', '/', $defaulttemplatesrc);
		
		// crée les dossiers manquants
		$folderstocopy = TCK_Folder::folders($defaulttemplatesrc, '.', true, true);
		foreach ($folderstocopy as $foldertocopy) {
			$foldertocopy = str_replace('\\', '/', $foldertocopy);
			$foldername = str_replace($defaulttemplatesrc, '', $foldertocopy);
			$folderdest = $defaulttemplatedest . $foldername;
			if (!TCK_Folder::exists($folderdest)) {
				TCK_Folder::create($folderdest); 
			}
		}
		
		// copie tous les fichiers
		$filestocopy = TCK_Folder::files($defaulttemplatesrc, '.', true, true);
		$success_copy = true;
		foreach ($filestocopy as $filetocopy) {
			// make that the path are written the same
			// $defaulttemplatesrc = str_replace('\\', '/', $defaulttemplatesrc);
			$filetocopy = str_replace('\\', '/', $filetocopy);

			$filename = str_replace($defaulttemplatesrc, '', $filetocopy);
			$filedest = $defaulttemplatedest . $filename;
			
			if (!TCK_File::copy($filetocopy, $filedest)) {
				$msg2 = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_TEMPLATECOPY') . ' : ' . $filename . '</p>';
				clearstatcache(null, $filedest);
				// check if the file permissions can be read
				if (file_exists($filedest) && @fileperms($filedest)) {
					$fileperms = fileperms($filedest);
					$filerights = decoct( $fileperms & 0777 );
					if ((int)$filerights < 644) {
						// change the file permissions
						if (chmod($filedest,0644)) {
							$msg2 .= '<p class="errorck" style="font-weight:bold;color: orange;">' . TCK_Text::_('CK_FILE_RIGHTS_CHANGED_TO') . ' : 0644</p>';
							if (TCK_File::copy($filetocopy, $filedest)) {
								$msg2 .= '<p class="successck"  style="font-weight:bold;">Second try : ' . TCK_Text::_('CK_SUCCESS_CREATING_TEMPLATECOPY') . ' : ' . $filename . '</p>';
							} else {
								$msg2 .= '<p class="errorck">Second try : ' . TCK_Text::_('CK_ERROR_CREATING_TEMPLATECOPY') . ' : ' . $filename . '</p>';
								$success_copy = false;
							}
						} else {
							$msg2 .= '<p class="errorck">Second try : ' . TCK_Text::_('CK_ERROR_CHMODING_FILE') . ' : ' . $filename . '</p>';
							$success_copy = false;
						}
					}
				} else {
					$msg2 .= '<p class="errorck">Second try : ' . TCK_Text::_('CK_ERROR_CHECKING_FILEPERMS') . ' : ' . $filename . '</p>';
					$success_copy = false;
				}
				echo $msg2;
			} //else {
				// $msg = '<p class="successck" style="Font-size:14px;font-weight:bold;">' . TCK_Text::_('CK_SUCCESS_CREATING_TEMPLATECOPY') . '</p>';
			// }
		}
		// echo $msg;
		if ($success_copy) {
			echo '<p class="successck" style="Font-size:14px;font-weight:bold;">' . TCK_Text::_('CK_SUCCESS_CREATING_TEMPLATECOPY') . '</p>';
		} else {
			echo '<p class="errorck" style="Font-size:14px;font-weight:bold;">' . TCK_Text::_('CK_ERROR_CREATING_TEMPLATECOPY') . '</p>';
		}
	}
	
} else {
	$files = TCK_Folder::files($path, false, true, true);
	$exporter = new ZipArchiver();
	$isSuccess = $exporter->create($files, '.zip', $path, true);

	// return message after creating the zip archive
	if (!$isSuccess && $exporter->getError()) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_ARCHIVE') . '</p>';
	} else {
		$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_ARCHIVE') . '</p>';
	}

	echo $msg;

	// create button to download the package
	echo '<p style="padding: 15px;"><a class="ckdownload  ckbuttonstyle" href="' . get_theme_root_uri() . '/' . $templatename . '.zip">' . TCK_Text::_('CK_DOWNLOAD_TEMPLATE') . '</a></p>';
}
global $wp_scripts, $wp_customize;
// var_dump( wp_create_nonce( 'save-customize_' . $templatename ) );
// var_dump( wp_create_nonce( 'preview-customize_' . $templatename ) ); // � utiliser dans url
// preview url.
// http://localhost/wordpress/?wp_customize=on&theme=ari&nonce=bcc7c55d6c >> semble fonctionner
// http://localhost/wordpress/?wp_customize=on&theme=ari&nonce=bcc7c55d6c&customize_messenger_channel=preview-0