<?php

/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access to this file
defined('ABSPATH') or die('Restricted access');
$input = new TCK_Input();

// retrieve variables
$templatename = $input->get('templatename');
$positions = $input->get('positions', array(), 'array');
$blocs = $input->get('blocs', null, null);
$blocs = stripslashes(str_replace("|di|", "#", $blocs));
$blocs = json_decode($blocs);
$loadBootstrap = (isset($blocs[0]->blocloadboostrap) && $blocs[0]->blocloadboostrap == '1') ? '1' : '0';
$googleanalytics = (isset($blocs[0]->blocloadgoogleanalytics)) ? $blocs[0]->blocloadgoogleanalytics : false;

$path = get_theme_root() . '/' . $templatename;

$functext = '<?php
';

$functext_options = "";

// check if there is some logos in the template
$logos_id = array();
foreach ($blocs as $i => $bloc) {
	// manage logo option
	if (stristr($bloc->class, 'bannerlogo')) {
		// $logos_id[$bloc->ckid] = new stdClass();
		// $logos_id[$bloc->ckid]->imgsrc = $bloc->blocbackgroundimageurl;
		// $logos_id[$bloc->ckid]->height = isset($bloc->logoheight) ? $bloc->logoheight : 'auto';
		// $logos_id[$bloc->ckid]->width = isset($bloc->logowidth) ? $bloc->logowidth : '100%';
		
		$imageurl = explode("/", $bloc->blocbackgroundimageurl);
		$imageurl = end($imageurl);
		$imageurl = get_theme_root_uri() . '/' . $templatename . '/images/' . $imageurl;

		// adds the code for the option
		// $functext .= '// active the header fuction
// $args = array(
	// \'width\'         => '.(isset($bloc->logowidth) ? $bloc->logowidth : '100%').',
	// \'height\'        => '.(isset($bloc->logoheight) ? $bloc->logoheight : 'auto').',
	// \'default-image\' => \''.$imageurl.'\',
// );
// add_theme_support( \'custom-header\', $args );

// ';

// method to overwrite the logo options if the theme is already installed and the option already set
$default_theme_options = get_option('theme_test_options');
$default_theme_options[$bloc->ckid.'_logo_image'] = $imageurl;
$default_theme_options[$bloc->ckid.'_logo_width'] = (isset($bloc->logowidth) ? $bloc->logowidth : '');
$default_theme_options[$bloc->ckid.'_logo_height'] = (isset($bloc->logoheight) ? $bloc->logoheight : '');
update_option('theme_test_options', $default_theme_options);

	$functext_options .= "
	// This adds a new section (i.e. category/group) to the Theme Customizer page. 
	\$wp_customize->add_section(
		'".$bloc->ckid."_logo_tck_options',
		array(
			'title' => __( '[ ".$bloc->ckid." ] Logo Options', '".$templatename."' ),
			'priority'   => 100,
			'capability' => 'edit_theme_options'
		)
	);

	//  =============================
    //  = Image Upload              =
    //  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[".$bloc->ckid."_logo_image]', array(
		'default'           => '".$imageurl."',
		'capability'        => 'edit_theme_options',
		'type'          	 => 'option',
		'priority'   		=> 1

	));
 
	\$wp_customize->add_control( new WP_Customize_Image_Control(\$wp_customize, '".$bloc->ckid."_logo_image', array(
		'label'    => __('Logo Image', '".$templatename."'),
		'section'  => '".$bloc->ckid."_logo_tck_options',
		'settings' => 'theme_".$templatename."_options[".$bloc->ckid."_logo_image]',
	)));

	//  =============================
	//  = Width Input               =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[".$bloc->ckid."_logo_width]', array(
		'default'        => '".(isset($bloc->logowidth) ? $bloc->logowidth : '')."', // default value
		'capability'     => 'edit_theme_options',
		'type'           => 'option',

	));

	\$wp_customize->add_control('theme_".$templatename."_options_".$bloc->ckid."_logo_width', array(
		'label'      => __('Logo width', '".$templatename."'), // title 
		'section'    => '".$bloc->ckid."_logo_tck_options', // refer to the section name created before
		'settings'   => 'theme_".$templatename."_options[".$bloc->ckid."_logo_width]', // refer to the add_setting name
	));
	
	//  =============================
	//  = Height Input              =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[".$bloc->ckid."_logo_height]', array(
		'default'        => '".(isset($bloc->logoheight) ? $bloc->logoheight : 'auto')."', // default value
		'capability'     => 'edit_theme_options',
		'type'           => 'option',

	));

	\$wp_customize->add_control('theme_".$templatename."_options_".$bloc->ckid."_logo_height', array(
		'label'      => __('Logo height', '".$templatename."'), // title 
		'section'    => '".$bloc->ckid."_logo_tck_options', // refer to the section name created before
		'settings'   => 'theme_".$templatename."_options[".$bloc->ckid."_logo_height]', // refer to the add_setting name
	));
	
	//  =============================
	//  = Link url Input            =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[".$bloc->ckid."_logo_link]', array(
		'default'        => '', // default value
		'capability'     => 'edit_theme_options',
		'type'           => 'option',

	));

	\$wp_customize->add_control('theme_".$templatename."_options_".$bloc->ckid."_logo_link', array(
		'label'      => __('Logo link', '".$templatename."'), // title 
		'section'    => '".$bloc->ckid."_logo_tck_options', // refer to the section name created before
		'settings'   => 'theme_".$templatename."_options[".$bloc->ckid."_logo_link]', // refer to the add_setting name
	));
	
	//  =============================
	//  = Title Input               =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[".$bloc->ckid."_logo_title]', array(
		'default'        => '', // default value
		'capability'     => 'edit_theme_options',
		'type'           => 'option',

	));

	\$wp_customize->add_control('theme_".$templatename."_options_".$bloc->ckid."_logo_title', array(
		'label'      => __('Logo title', '".$templatename."'), // title 
		'section'    => '".$bloc->ckid."_logo_tck_options', // refer to the section name created before
		'settings'   => 'theme_".$templatename."_options[".$bloc->ckid."_logo_title]', // refer to the add_setting name
	));
	
	//  =============================
	//  = Description Input         =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[".$bloc->ckid."_logo_desc]', array(
		'default'        => '', // default value
		'capability'     => 'edit_theme_options',
		'type'           => 'option',

	));

	\$wp_customize->add_control('theme_".$templatename."_options_".$bloc->ckid."_logo_desc', array(
		'label'      => __('Logo alt description', '".$templatename."'), // title 
		'section'    => '".$bloc->ckid."_logo_tck_options', // refer to the section name created before
		'settings'   => 'theme_".$templatename."_options[".$bloc->ckid."_logo_desc]', // refer to the add_setting name
	));";

	}
	
	// register menus
	if (stristr($bloc->class, 'horiznav') || stristr($bloc->class, 'bannermenu')) {
	$functext .= '// register the menus
	register_nav_menus( array(
		\'' . $bloc->ckmoduleposition . '\'   => __( \'' . $bloc->ckid . '\', \'' . $templatename . '\' )
	) );
	
	';
	}
}

// add options for responsive, google analytics
$functext_options .= "
	// This adds a new section (i.e. category/group) to the Theme Customizer page. 
	\$wp_customize->add_section(
		'advanced_tck_options',
		array(
			'title' => __( 'Advanced Options', '".$templatename."' ),
			'priority'   => 100,
			'capability' => 'edit_theme_options'
			// 'description' => __( 'Setup your theme.', '".$templatename."' )
		)
	);

	//  =============================
	//  = Responsive Input               =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[responsive]', array(
		'default'        => '1',
		'capability'     => 'edit_theme_options',
		'type'           => 'option',
	));

	\$wp_customize->add_control('theme_".$templatename."_options_responsive', array(
		'label'      => __('Activate responsive', '".$templatename."'),
		'section'    => 'advanced_tck_options',
		'settings'   => 'theme_".$templatename."_options[responsive]',
		'type'       => 'radio',
		'choices'    => array(
			'1' => __('Yes', '".$templatename."'),
			'0' => __('No', '".$templatename."'),
		),
	));
	
	//  =============================
	//  = Enable comments           =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[comments]', array(
		'default'        => '1',
		'capability'     => 'edit_theme_options',
		'type'           => 'option',
	));

	\$wp_customize->add_control('theme_".$templatename."_options_comments', array(
		'label'      => __('Enable comments', '".$templatename."'),
		'section'    => 'advanced_tck_options',
		'settings'   => 'theme_".$templatename."_options[comments]',
		'type'       => 'radio',
		'choices'    => array(
			'1' => __('Yes', '".$templatename."'),
			'0' => __('No', '".$templatename."'),
		),
	));

	//  =============================
	//  = Custom background         =
	//  =============================

	\$wp_customize->add_setting('background_image[cover]', array(
		'default'        => '1',
		'capability'     => 'edit_theme_options',
		'type'           => 'option',
	));

	\$wp_customize->add_control('cover', array(
		'label'      => __('Image Cover', '".$templatename."'),
		'section'    => 'background_image',
		'settings'   => 'background_image[cover]',
		'type'       => 'radio',
		'choices'    => array(
			'1' => __('Yes', '".$templatename."'),
			'0' => __('No', '".$templatename."'),
		),
	));

";
if ($googleanalytics) {
$functext_options .= "
	//  =============================
	//  = Google Analytics Input         =
	//  =============================
	\$wp_customize->add_setting('theme_".$templatename."_options[analytics]', array(
		'default'        => '', // default value
		'capability'     => 'edit_theme_options',
		'type'           => 'option',

	));

	\$wp_customize->add_control('theme_".$templatename."_options_analytics', array(
		'label'      => __('Google Analytics code', '".$templatename."'), // title 
		'section'    => 'advanced_tck_options', // refer to the section name created before
		'settings'   => 'theme_".$templatename."_options[analytics]', // refer to the add_setting name
	));
";

}


$functext .= "
// create options in the admin customize page
function theme_".$templatename."_customize_register(\$wp_customize){

";
// adds all options
$functext .= $functext_options;

$functext .= "
}
add_action('customize_register', 'theme_".$templatename."_customize_register');

// function for frontend
function theme_".$templatename."_options(\$name, \$default = false) {
    \$options = ( get_option( 'theme_".$templatename."_options' ) ) ? get_option( 'theme_".$templatename."_options' ) : null;
    // return the option if it exists
    if ( isset( \$options[ \$name ] ) ) {
        return apply_filters( 'theme_".$templatename."_options_\$name', \$options[ \$name ] );
    }
    // return default if nothing else
    return apply_filters( 'theme_".$templatename."_options_\$name', \$default );
}
";

//'default-image' => get_template_directory_uri() . '/images/logo.png',


// $functext .='
	// <name>' . $templatename . '</name>
	// <creationDate>' . $creationdate . '</creationDate>
	// <author>' . $author . '</author>
	// <authorEmail>' . $authorEmail . '</authorEmail>
	// <authorUrl>' . $authorUrl . '</authorUrl>
	// <copyright>' . $copyright . '</copyright>
	// <license>' . $license . '</license>
	// <version>' . $version . '</version>
	// <description>' . $description . '</description>

// ';

// save root folder


// list files to archive
// $files = TCK_Folder::files($path, false, true, true);

// $functext .= "\t<files>\r\n";

// $tmppath = str_replace('\\', '/', $path);
// foreach ($files as $file) {
	// $tmpfile = str_replace('\\', '/', $file);
	// $tmpfile = str_replace($tmppath, '', $tmpfile);
	// $tmpfile = trim($tmpfile, '/');
	// $functext .= "\t\t<filename>" . $tmpfile . "</filename>\r\n";
// }

// $functext .= "\t</files>\r\n";

// list all positions
// $functext .= "\t<positions>\r\n";

// register the sidebars
if (count($positions)) {
	$functext .= '// register the sidebars
function theme_'.$templatename.'_widgets_init() {
';

// old method, working but without name
	// foreach ($positions as $position) {
		// if ($position) {
			// $functext .= "		register_sidebar( array(
		// 'name'          => __( '" . $position . "', '" . $templatename . "' ),
		// 'id'            => '" . $position . "',
		// 'description'   => __( '" . $position . " sidebar', '" . $templatename . "' ),
		// 'before_widget' => '<aside id=\"%1\$s\" class=\"widget %2\$s\">',
		// 'after_widget'  => '</aside>',
		// 'before_title'  => '<h3 class=\"widget-title\">',
		// 'after_title'   => '</h3>',
	// ) );

// ";
		// }
	// }
	
	// new method with name
	foreach ($blocs as $bloc) {
		if (isset($bloc->ckmoduleposition)) {
			// Icon settings
			$iconpos = (isset($bloc->iconpos) && $bloc->iconpos) ? $bloc->iconpos : '';
			$iconsize = (isset($bloc->iconsize) && $bloc->iconsize) ? $bloc->iconsize : '';
			$iconvpos = (isset($bloc->iconvpos) && $bloc->iconvpos) ? 'vertical-align:' . $bloc->iconvpos . ';' : '';
			$iconposstyle = ($iconpos == 'top' || $iconpos == 'bottom') ? 'display:block;' : 'display:inline-block;';
			$fackstyle = ($iconposstyle != '') ? 'style="' . $iconposstyle . $iconvpos . '"' : '';
//			$fastyle = ($iconvpos != '') ? 'style="' . $iconvpos . '"' : '';
			$icon = (isset($bloc->icon) && $bloc->icon) ? '<span class="fack ' . $iconsize . '" ' . $fackstyle . '><span class="' . $bloc->icon . '"></span></span>' : '';

			$functext .= "		register_sidebar( array(
		'name'          => __( '" . $bloc->ckmoduleposition . ' [' . $bloc->ckid . "]', '" . $templatename . "' ),
		'id'            => '" . $bloc->ckmoduleposition . "',
		'description'   => __( '" . $bloc->ckmoduleposition . " sidebar', '" . $templatename . "' ),
		'before_widget' => '<aside id=\"%1\$s\" class=\"widget %2\$s\">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h3 class=\"widget-title\">" . (($iconpos == 'left' || $iconpos == 'top') ? $icon : '') . "',
		'after_title'   => '" . (($iconpos == 'right' || $iconpos == 'bottom') ? $icon : '') . "</h3>',
	) );

";
		}
	}

	$functext .= '}
add_action( \'widgets_init\', \'theme_'.$templatename.'_widgets_init\' );

';
}

// add support for page title
$functext .= '
function theme_'.$templatename.'_setup() {
	add_theme_support( \'title-tag\' );
}

add_action( \'after_setup_theme\', \'theme_'.$templatename.'_setup\' );

';

// add support for woocommerce
$functext .= '
function theme_'.$templatename.'_woocommerce_support() {
	add_theme_support( \'woocommerce\' );
}

add_action( \'after_setup_theme\', \'theme_'.$templatename.'_woocommerce_support\' );

//  =============================
//  = Enable custom background  =
//  =============================
add_theme_support( \'custom-background\' );

';

$functext .= 'if (file_exists(dirname( __FILE__ ) . \'/customfunctions.php\')) {
	include_once(dirname( __FILE__ ) . \'/customfunctions.php\');
}
';

// define path to file
$funcdest = $path . '/functions.php';

// create the file templateDetails.xml
if (!TCK_File::write($funcdest, $functext)) {
	$msg = '<p class="error">' . TCK_Text::_('CK_ERROR_CREATING_FUNCTIONSPHP') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FUNCTIONSPHP') . '</p>';
}
echo $msg;