<?php

/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */

// No direct access to this file
defined('ABSPATH') or die('Restricted access');
$input = new TCK_Input();
global $wpdb;
require_once(TEMPLATECREATORCK_PATH . '/helpers/ckwidgets.php');

// $bodycode = JRequest::getVar('bodycode', '', 'post', 'string', JREQUEST_ALLOWRAW);
// $headcode = JRequest::getVar('headcode', '', 'post', 'string', JREQUEST_ALLOWRAW);
$bodycode = $input->get('bodycode', '', 'raw');
$headcode = $input->get('headcode', '', 'raw');
// $bodycode = $input->get('bodycode', null, null, JREQUEST_ALLOWRAW);
// $headcode = $input->get('headcode', null, null);
$joomlaversion = $input->get('joomlaversion');
$templatename = $input->get('templatename', '', 'string');
$creationdate = $input->get('creationdate', '', 'string');
$author = $input->get('author', '', 'string');
$authorEmail = $input->get('authorEmail', '', 'string');
$authorUrl = $input->get('authorUrl', '', 'string');
$copyright = $input->get('copyright', '', 'string');
$license = $input->get('license', '', 'string');
$version = $input->get('version', '', 'string');
$description = $input->get('description', '', 'string');
$makearchive = ($input->get('makearchive') != 'preview') ? true : false;
$blocs = $input->get('blocs', null, null);
$blocs = stripslashes(str_replace("|di|", "#", $blocs));
$blocs = json_decode($blocs);
$isFluid = (isset($blocs[0]->blocwrapperfluid) && $blocs[0]->blocwrapperfluid == 'fluid') ? true : false;
$loadBootstrap = (isset($blocs[0]->blocloadboostrap) && $blocs[0]->blocloadboostrap == '1') ? true : false;
$loadFontawesome = (isset($blocs[0]->blocloadfontawesome) && $blocs[0]->blocloadfontawesome == '1') ? true : false;
$googleanalytics = (isset($blocs[0]->blocloadgoogleanalytics)) ? $blocs[0]->blocloadgoogleanalytics : false;
$customcss = '';
$customheader = '';
$customcodeendbody = '';
$customjs = '';
$templateid = $input->get('id', 0, 'int'); 

if ($loadFontawesome == '1') {
	$facktoload = true;
} else if ($loadFontawesome == '0') {
	$facktoload = false;
} else {
	$facktoload = $input->get('facktoload', 0, 'string');
}

$widgets = $input->get('widgets', '', 'raw');
$widgetsList = json_decode($widgets);

// create root folder
// $path = TCK_PATH_COMPONENT . '/projects/' . $templatename;
$path = get_theme_root() . '/' . $templatename;
$msg = '';

// copy the HTML override folder if exists in the template
// $pathhtmlfolder = TCK_PATH_COMPONENT . '/projects/' . $templatename . '/html';
// if (TCK_Folder::exists(TEMPLATECREATORCK_PATH . '/templates/' . $templatename . '/html')) {
	// if (!TCK_Folder::copy(TEMPLATECREATORCK_PATH . '/templates/' . $templatename . '/html', $pathhtmlfolder, '', true, true)) {
		// $msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_HTMLFOLDER_PROJECTS') . '</p>';
	// } else {
		// $msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_HTMLFOLDER_PROJECTS') . '</p>';
	// }
	// echo $msg;
// }

// test if a custom css exists
if (TCK_File::exists($path . '/css/custom.css')) {
	$customcss = TCK_File::read($path . '/css/custom.css');
}

// test if a custom css exists
//if (TCK_File::exists($path . '/customheader.php')) {
//	$customheader = TCK_File::read($path . '/customheader.php');
//}

// test if a custom code before end body exists
if (TCK_File::exists($path . '/customcodeendbody.php')) {
	$customcodeendbody = TCK_File::read($path . '/customcodeendbody.php');
}

if (file_exists($path . '/js/custom.js')) {
	$customjs = TCK_File::read($path . '/js/custom.js');
}

// delete the entire folder if already exists
// if (TCK_Folder::exists($path)) {
	// if (!TCK_Folder::delete($path)) {
		// $msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_DELETING_FOLDER_PROJECTS') . '</p>';
	// } else {
		// $msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_DELETING_FOLDER_PROJECTS') . '</p>';
	// }
// }
// echo $msg;

// if (!TCK_Folder::create($path)) {
	// $msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOLDER_PROJECTS') . '</p>';
// } else {
	// $msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOLDER_PROJECTS') . '</p>';
// }

// echo $msg;

// automatically backup the gabarit
$query = ' SELECT * FROM '. $wpdb->prefix . 'templateck_templates' .
		' WHERE id = ' . (int) $templateid;
$gabaritcode = $wpdb->get_row($query);
//  if template exists in the database
if ($gabaritcode) {
	$exportfiledest = $path . '/' . $templatename . '.tck3';
	$gabaritcode->htmlcode = str_replace(TCK_Uri::root(true), "|URIBASE|", $gabaritcode->htmlcode);
	$exportfiletext = json_encode($gabaritcode);

	if (!TCK_File::write($exportfiledest, $exportfiletext)) {
		$msg = '<p class="error">' . TCK_Text::_('CK_ERROR_COPY_GABARIT') . '</p>';
	} else {
		$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_COPY_GABARIT') . '</p>';
	}
	echo $msg;
}

// create css folder
$pathcss = $path . '/css';
if (!TCK_Folder::create($pathcss)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOLDER_CSS') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOLDER_CSS') . '</p>';
}

echo $msg;

// create css folder (removed in 3.3.11)
//$pathfonts = $path . '/css/fonts';
//if (!TCK_Folder::create($pathfonts)) {
//	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOLDER_FONTS') . '</p>';
//} else {
//	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOLDER_FONTS') . '</p>';
//}
//
//echo $msg;

// copy the fonts folder for fontawesome
if ($facktoload && $facktoload !== 'false') {
	$pathfontsfolder = $path . '/fonts';

	// create fonts folder
	if (!TCK_Folder::create($pathfontsfolder)) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOLDER_FONTS') . '</p>';
	} else {
		$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOLDER_FONTS') . '</p>';
	}

	echo $msg;

//	TCK_Folder::create($pathcss);
	$fontfiles = TCK_Folder::files(TEMPLATECREATORCK_PATH . '/fonts');
	foreach ($fontfiles as $fontfile) {
		if (!TCK_File::copy(TEMPLATECREATORCK_PATH . '/fonts/' . $fontfile, $pathfontsfolder . '/' . $fontfile)) {
			$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FONTSAWESOMEFOLDER_PROJECTS') . '</p>';
		} else {
			$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FONTSAWESOMEFOLDER_PROJECTS') . '</p>';
		}
		echo $msg;
	}

	// copy the fontawesome css file
	$defaultfontawesomecsssrc = JPATH_ROOT . '/administrator/components/com_templateck/assets/font-awesome.min.css';
	$defaultfontawesomecssdest = $path . '/css/font-awesome.min.css';

	if (!TCK_File::copy($defaultfontawesomecsssrc, $defaultfontawesomecssdest)) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FONTSAWESOMECSS_PROJECTS') . '</p>';
	} else {
		$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FONTSAWESOMECSS_PROJECTS') . '</p>';
}
	echo $msg;
}

// create images folder
$pathimg = $path . '/images';
if (!TCK_Folder::create($pathimg)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOLDER_IMAGES') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOLDER_IMAGES') . '</p>';
}

echo $msg;

// create images system folder
$pathimgsystem = $path . '/images/system';
if (!TCK_Folder::create($pathimgsystem)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOLDER_IMAGES') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOLDER_IMAGES') . '</p>';
}

echo $msg;

if ($facktoload && $facktoload !== 'false') {
	// copy the fontawesome css file
	$defaultfontawesomecsssrc = TEMPLATECREATORCK_PATH . '/assets/font-awesome.min.css';
	$defaultfontawesomecssdest = $path . '/css/font-awesome.min.css';

	if (!TCK_File::copy($defaultfontawesomecsssrc, $defaultfontawesomecssdest)) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FONTSAWESOMECSS_PROJECTS') . '</p>';
	} else {
		$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FONTSAWESOMECSS_PROJECTS') . '</p>';
	}
	echo $msg;
}

// create custom.css file if exists
if ($customcss) {
	if (!TCK_File::write($path . '/css/custom.css', $customcss)) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_CUSTOMCSS') . '</p>';
		echo $msg;
	}
}

// create customheader.php file if exists
//if ($customheader) {
//	if (!TCK_File::write($path . '/customheader.php', $customheader)) {
//		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_CUSTOMHEADER') . '</p>';
//		echo $msg;
//	}
//}

// create customcodeendbody.php file if exists
if ($customcodeendbody) {
	if (!TCK_File::write($path . '/customcodeendbody.php', $customcodeendbody)) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_CUSTOMCODEENDBODY') . '</p>';
		echo $msg;
	}
}

// create index.html file (root)
$indexhtmlsrc = TCK_PATH_COMPONENT . '/index.html';
$indexhtmldest = $path . '/index.html';

if (!TCK_File::copy($indexhtmlsrc, $indexhtmldest)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_INDEXHTML_PROJECTS') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_INDEXHTML_PROJECTS') . '</p>';
}
echo $msg;

// create index.html file (css)
$indexhtmldest = $path . '/css/index.html';

if (!TCK_File::copy($indexhtmlsrc, $indexhtmldest)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_INDEXHTML_CSS') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_INDEXHTML_CSS') . '</p>';
}
echo $msg;

// create the file font.css
// removed from version 3.3.11 because the fonts are loaded into index.php
// $fontscontent = '';
// if (!TCK_File::write($path . '/css/fonts/fonts.css', $fontscontent)) {
	// $msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FONTSCSS') . '</p>';
// } else {
	// $msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FONTSCSS') . '</p>';
// }
// echo $msg;


// create index.html file (images)
$indexhtmldest = $path . '/images/index.html';

if (!TCK_File::copy($indexhtmlsrc, $indexhtmldest)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_INDEXHTML_IMAGES') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_INDEXHTML_IMAGES') . '</p>';
}
echo $msg;


// create index.html file (images system)
$indexhtmldest = $path . '/images/system/index.html';

if (!TCK_File::copy($indexhtmlsrc, $indexhtmldest)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_INDEXHTML_IMAGES') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_INDEXHTML_IMAGES') . '</p>';
}
echo $msg;

$ie7inlineblock =  Array();
$external_fonts = Array();
foreach ($blocs as $bloc) {

	$systemimages = array(
		// "emailsystemimageurl",
		// "printsystemimageurl",
		// "ratingblanksystemimageurl",
		// "ratingfilledsystemimageurl",
		// "editsystemimageurl",
		// "arrowsystemimageurl",
		"faviconsystemimageurl",
		// "template_thumbnailsystemimageurl",
		"template_previewsystemimageurl");
	foreach ($systemimages as $systemimage) {
		if (isset($bloc->$systemimage) AND $bloc->$systemimage) {
			if ($systemimage == 'emailsystemimageurl')
				$destimgname = 'images/system/emailButton.png';
			if ($systemimage == 'printsystemimageurl')
				$destimgname = 'images/system/printButton.png';
			if ($systemimage == 'ratingblanksystemimageurl')
				$destimgname = 'images/system/rating_star_blank.png';
			if ($systemimage == 'ratingfilledsystemimageurl')
				$destimgname = 'images/system/rating_star.png';
			if ($systemimage == 'editsystemimageurl')
				$destimgname = 'images/system/edit.png';
			if ($systemimage == 'arrowsystemimageurl')
				$destimgname = 'images/system/arrow.png';
			if ($systemimage == 'faviconsystemimageurl')
				$destimgname = 'favicon.ico';
			if ($systemimage == 'template_thumbnailsystemimageurl')
				$destimgname = 'template_thumbnail.png';
			if ($systemimage == 'template_previewsystemimageurl')
				$destimgname = 'screenshot.png';
			$imgurl = $bloc->$systemimage;

			$imgname = explode("/", $bloc->$systemimage);
			$imgname = end($imgname);

			$imagesdest = $path . '/' . $destimgname;
			$imagessrc = TEMPLATECREATORCK_PATH . '/' . $imgurl;

			if (!TCK_File::copy($imagessrc, $imagesdest)) {
				$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_IMAGEFILES') . ' : ' . $bloc->$systemimage . '</p>';
			} else {
				$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_IMAGEFILES') . ' ' . $imgname . '</p>';
			}
			echo $msg;
		}
	}

	$bloc->ckid = $bloc->ckid . ' > div.inner';

	// IE7 compatibility for horizontal menu
	
	if (stristr($bloc->class, 'menu') || stristr($bloc->class, 'horiznav')) {
		$ie7inlineblock[] = '#' . $bloc->ckid . ' ul.menu > li';
	}
	
	// test for the google fonts
	
	// $prefix = 'bloc';
	// $fontfamily = $prefix . 'fontfamily';
	// var_dump($bloc->$fontfamily);
	
	// if ($action != 'preview') $this->_injectFonts($cssparams, $fontfamily);

	$native_fonts = array('default'
		,'Times New Roman, Serif'
		,'Helvetica, sans-serif'
		,'Georgia, serif'
		,'Courier New, serif'
		,'Arial, sans-serif'
		,'Verdana, sans-serif'
		,'Comic Sans MS, cursive'
		,'Tahoma, sans-serif'
		,'Segoe UI, sans-serif'
		);

	if ($bloc->ckid == 'body' || stristr($bloc->class, 'body')) {
		$prefixes = array(
			"pagenavbutton",
			"pagenavbuttonhover",
			"readmorebutton",
			"readmorebuttonhover",
			"buttonbutton",
			"buttonbuttonhover",
			"inputfieldbutton",
			"inputfieldbuttonactive",
			"level0bg",
			"level0item",
			"level0itemhover",
			"level0itemactive",
			"level1bg",
			"level1item",
			"level1itemhover",
			"level1itemactive",
			"level2bg",
			"h1title",
			"h2title",
			"h3title",
			"h4title",
			"h5title",
			"h6title",
			"bloc",
			"module",
			"moduletitle",
			"body");
	} else {
		$prefixes = array(
			"level0bg",
			"level0item",
			"level0itemhover",
			"level0itemactive",
			"level1bg",
			"level1item",
			"level1itemhover",
			"level1itemactive",
			"level2bg",
			"bloc",
			"module",
			"moduletitle",
			"body");
}

	foreach ($prefixes as $prefix) {
		$fontfamily = $prefix . 'fontfamily';
		if (isset($bloc->$fontfamily) AND ! in_array($bloc->$fontfamily, $native_fonts)) {
			if (! in_array($bloc->$fontfamily, $external_fonts)) {
				array_push($external_fonts, $bloc->$fontfamily);
			}
		}
	}
} // fin boucle des blocs

$templatepath = '<?php echo get_template_directory_uri() ?>';

// loop through the enabled plugin and load the needed CSS / JS files
$widgets = array();
foreach ($widgetsList as &$widget) {

	// if the widget is enabled, call the rendering features
	if ($widget->enabled) {
		$name = $widget->name;
		$widgets[$name] = new stdClass();
		include_once(TEMPLATECREATORCK_PATH . '/widgets/' . $name . '/' . $name . '.php');
		$widgetClassName = 'TCK_Widget' . ucfirst($name);
		$widgetClass = new $widgetClassName();
		$widgetsRenderInit = array();
		$widgetsRenderInit['php'] = '';
		$widgetsRenderInit['script'] = '';
		$widgetsRenderInit['scriptDeclaration'] = '';
		$widgetsRenderInit['stylesheet'] = '';
		$widgetsRenderInit['styleDeclaration'] = '';
		$widgetRender = $widgetClass->renderFrontendWidget($templatepath, $templatename, $widget->data);
		$widgets[$name]->render = $widgetRender ? $widgetRender : $widgetsRenderInit;
//		$widgets[$name]->name = $name;
	}
}

// var_dump($external_fonts);
$gfonts_url = "\t";
$fontsquirrel_url = "\t";
// check for specific font to add
if (count($external_fonts) > 0) {
	$gfonts_url = "";
	$fontsquirrel_urls = "";
	// dans DB cercher fontfamilies (Lato), puis recuperer styles (@import url(http://fonts.googleapis.com/css?family=Lato:300,400,700);), si @import alors c'est gfont et doit utiliser <link />
	// sinon c'est Fsquirrel, utiliser methode normale avec ecriture dans fonts.css
	// mettre creation fonts.css + dossier fonts ici, comme ca si pas de font externe on ne le cree pas !
	// supprimer les lignes dans le helper stylescss.php
	
	// loads the fonts list
	// $db = JFactory::getDBO();
	// $query = "SELECT * FROM #__templateck_fonts";
	// $db->setQuery($query);
	// $db_fonts = $db->loadObjectList('fontfamilies');
	
	// $query = 'SELECT options FROM '. $wpdb->prefix . 'templateck_fonts';

	$query = 'SELECT * FROM '. $wpdb->prefix . 'templateck_fonts';
	$query.=' ORDER BY id ASC';
	$db_fonts = $wpdb->get_results($query, OBJECT);

	$font_names = array();
	// create a list of available fonts
	foreach ($db_fonts as $db_font) {
		$db_font_exploded = explode(',', $db_font->fontfamilies);
		foreach ($db_font_exploded as $font_name) {
			$font_names[$font_name] = $db_font;
			$font_names[$font_name]->copied = false;
		}
	}

	// loop for the needed fonts to add
	
	foreach ($external_fonts as $external_font) {
		$external_font = trim($external_font, "'");
		$external_font = explode(',', $external_font);
		$external_font = trim($external_font[0]);

		if (isset($font_names[$external_font]) && $font_names[$external_font]->copied == false) {
			// check if it is a google font
			preg_match('/@import url\((.*?)\);/', $font_names[$external_font]->styles, $matches);
			if (isset($matches[1])) {
				// if this is a googlefont
				$gfont_url = str_replace('http:', '', $matches[1]);
				$subset = isset($font_names[$external_font]->subset) && $font_names[$external_font]->subset ? '&subset=' . $font_names[$external_font]->subset : '';
				$gfonts_url .= "\t<link href='" . $gfont_url . $subset . "' rel='stylesheet' type='text/css'>\n";
				$font_names[$external_font]->copied = true;
			} else {
				// if this is a fontsquirrel
				$fontsquirrel_urls .= trim(str_replace("url('", "url('" . $templatepath . "/fonts/", $font_names[$external_font]->styles));
				// copy the font files into the template
				$dest = $path . '/fonts';
				$src = TCK_PATH_COMPONENT . '/fonts/' . $font_names[$external_font]->name;
				// create the folder fonts if needed
				if (!TCK_Folder::exists($dest)) {
					if (!TCK_Folder::create($dest)) {
						$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOLDER_FONTS') . '</p>';
					} else {
						$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOLDER_FONTS') . '</p>';
					}
					echo $msg;

					// create index.html file (css)
					$indexhtmldest = $path . '/fonts/index.html';

					if (!TCK_File::copy($indexhtmlsrc, $indexhtmldest)) {
						$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FILE') . ' : fonts/index.html</p>';
					} else {
						$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FILE') . ' : fonts/index.html</p>';
					}
					echo $msg;
				}
				$fontfiles = TCK_Folder::files($src);
				foreach ($fontfiles as $fontfile) {
					$fileext = strtolower(TCK_File::getExt($fontfile));
					if ($fileext != 'css' AND $fileext != 'html' AND $fileext != 'txt')
						if (!TCK_File::copy($src . '/' . $fontfile, $dest . '/' . $fontfile)) {
							echo 'ERREUR COPIE FONT';
						}
				}
				$font_names[$external_font]->copied = true;
			}
		}
	}
	$gfonts_url .= "\t";
	if ( trim($fontsquirrel_urls) != "") {
		$fontsquirrel_url = "<style type='text/css'>\n";
		$fontsquirrel_url .= $fontsquirrel_urls;
		$fontsquirrel_url .= "\n\t</style>\n\t";
	}
}

/* * * create index.php ** */

// make code for special characters
$headcode = str_replace('|lt|', '<', $headcode);
$headcode = str_replace('|gt|', '>', $headcode);
$headcode = str_replace("|rr|", "\r\n", $headcode);
$headcode = str_replace("|tab|", "\t", $headcode);
$headcode = str_replace("|plus|", "+", $headcode);
$headcode = str_replace("|di|", "#", $headcode);

// make code for special characters
$bodycode = str_replace('|lt|', '<', $bodycode);
$bodycode = str_replace('|gt|', '>', $bodycode);
$bodycode = str_replace("|rr|", "\r\n", $bodycode);
$bodycode = str_replace("|tab|", "\t", $bodycode);
$bodycode = str_replace("|di|", "#", $bodycode);


$stylesheet = '';
$script = '';
$scriptDeclaration = '';
$styleDeclaration = '';
$php = '';

// loads the fonts
$stylesheet .= $gfonts_url;
$stylesheet .= $fontsquirrel_url;

	$stylesheet .= '
	<link rel="stylesheet" href="<?php bloginfo(\'stylesheet_url\') ?>"/>';
	$stylesheet .= '
	<?php if (theme_'.$templatename.'_options(\'responsive\', \'1\')) { ?>
	<meta name="viewport" content="width=device-width, initial-scale=1.0" />
	<link rel="stylesheet" href="<?php echo get_template_directory_uri() ?>/css/mobile.css" type="text/css" />
	<?php } ?>';

	if ($facktoload && $facktoload !== 'false') {
		$stylesheet .= '
	<link rel="stylesheet" href="' . $templatepath . '/css/font-awesome.min.css" type="text/css" />';
	}

	if ($customcss) {
		$stylesheet .= '
	<link rel="stylesheet" href="<?php echo get_template_directory_uri() ?>/css/custom.css" type="text/css" />';
	}

foreach ($widgets as $widget) {
	$stylesheet .= $widget->render['stylesheet'] ? "\n\t" . $widget->render['stylesheet'] : '';
	$script .= $widget->render['script'] ? "\n\t" . $widget->render['script'] : '';
	$scriptDeclaration .= $widget->render['scriptDeclaration'] ? "\n\t" . $widget->render['scriptDeclaration'] : '';
	$styleDeclaration .= $widget->render['styleDeclaration']? "\n\t" . $widget->render['styleDeclaration'] : $widget->render['styleDeclaration'];
	$php .= $widget->render['php'] ? "\n\t" . $widget->render['php'] : '';
}

// create custom.css file if exists
if ($customjs) {
	// delete the entire folder if already exists
	if (TCK_Folder::exists($path . '/js')) {
		TCK_Folder::create($path . '/js');
	}

	if (!TCK_File::write($path . '/js/custom.js', $customjs)) {
		$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_CUSTOMCSS') . '</p>';
		echo $msg;
	} else {
		$script .= "\n\t" . '<script src="<?php echo get_template_directory_uri() ?>/js/custom.js" type="text/javascript" ></script>';
	}
}

// define path to file
$headerphpdest = $path . '/header.php';
$indexphpdest = $path . '/index.php';
$footerphpdest = $path . '/footer.php';

// create header
$headerphptext = '<?php

/**
 * @copyright	' . $copyright . '
 * ' . $authorUrl . '
 * Theme made with Template Creator CK - http://www.template-creator.com
 * ' . $templatename . '
 * @license ' . $license . '
 * @version ' . $version . '
 * */

// No direct access to this file
defined(\'ABSPATH\') or die;
wp_enqueue_script(\'jquery\');
?>

<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
	<meta charset="<?php bloginfo(\'charset\'); ?>" />
	<meta name="viewport" content="width=device-width" />
	<link rel="profile" href="http://gmpg.org/xfn/11" />
	<link rel="pingback" href="<?php bloginfo(\'pingback_url\'); ?>" />
	<?php wp_head(); ?>
	';

// a ajouter si utilisation 
/* <!--[if lt IE 9]>
<script src="<?php echo get_template_directory_uri(); ?>/js/html5.js" type="text/javascript"></script>
<![endif]--> */
	
$headerphptext .= $stylesheet
	. ($styleDeclaration ? "\n\t" . '<style type="text/css">' . $styleDeclaration . "\n\t" . '</style>' : '')
	. $script
	. ($scriptDeclaration ? "\n\t" . '<script type="text/javascript">' . $scriptDeclaration . "\n\t" . '</script>' : '')
	. ($php ? "\n\t" . '<?php ' . $php . "\n\t" . ' ?>' : '')
	. '
';

// inject php code in document head
// $headerphptext .= stripslashes($headcode);
//$containerClass = $isFluid ? 'container-fluid' : 'container';

if ($ie7inlineblock) $headerphptext .= "<!--[if lte IE 7]>
<style type=\"text/css\">
" . implode(",", $ie7inlineblock) . " {
\tdisplay: inline !important;
\tzoom: 1;
}
</style>
<![endif]-->
";

// add google analytics
if ($googleanalytics) {
	$headerphptext .= "<?php if (theme_".$templatename."_options('googleanalyticscode')) { ?>
<script type=\"text/javascript\">
  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', '<?php echo theme_".$templatename."_options('googleanalyticscode') ?>']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();
</script>
<?php } ?>";
}
// custom code here
if (file_exists($path . '/customheader.php')) {
	$headerphptext .= "<?php include_once(dirname( __FILE__ ) . '/customheader.php'); ?>";
}
$headerphptext .= '
</head>
<?php
$bgoption = get_option(\'background_image\');
$bgcover = (isset($bgoption[\'cover\']) && $bgoption[\'cover\'] == \'1\') ? \'background-size:cover;\' : \'\';
?>
<body <?php body_class(); ?> style="<?php echo $bgcover ?>">';
$indexphptext = '<?php
// load the header.php file
get_header();
$tmpl = isset($_GET[\'tmpl\']) && $_GET[\'tmpl\'] ? $_GET[\'tmpl\'] : \'\';
if ($tmpl) : 
?>
<style type="text/css">
body {
	background: #fff;
}
</style>
<?php
require_once(\'content.php\');
else :
?>
';

$contentphp = "<?php
/** 
 * Theme made with Template Creator CK - http://www.template-creator.com
 * @copyright	Template Creator CK
 * */

// No direct access to this file
defined('ABSPATH') or die;
?>
<?php dynamic_sidebar( 'message' ); ?>
<?php if ( have_posts() ) : ?>											
	<?php /* Start the Loop */ ?>
	<?php while ( have_posts() ) : the_post(); ?>
	<article id=\"post-<?php the_ID(); ?>\" <?php post_class(); ?>>
		<header>
		<?php if ( is_single() ) :
		the_title( '<h2 class=\"entry-title\">', '</h2>' );
		else :
		the_title( '<h2 class=\"entry-title\"><a href=\"' . esc_url( get_permalink() ) . '\" rel=\"bookmark\">', '</a></h2>' );
		endif;
		?>
		</header>
		<?php the_content(); ?>
	</article>
	<?php if (theme_".$templatename."_options('comments', '1')) { 
		comments_template(); 
	} ?>
	<?php endwhile; ?>
<?php endif; ?>
";

// create the file content.php
if (!TCK_File::write($path . '/content.php', $contentphp)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FILE') . ' content.php</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FILE') . ' content.php</p>';
}
echo $msg;

// inject html code
$indexphptext .= stripslashes($headcode);
$indexphptext .= stripslashes($bodycode);

// close body and html page
$indexphptext .= '
    </div>
</div>
<?php 
endif;
get_footer();';

$footerphptext = '<?php 
// load the footer.php file
wp_footer(); ?>
</body>
</html>';

// copy the standard file code to reuse it for other templates
$standarphptext = $indexphptext;

// create the file header.php
if (!TCK_File::write($headerphpdest, $headerphptext)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_HEADERPHP') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_HEADERPHP') . '</p>';
}
echo $msg;

// create the file index.php
$bodycode = '<?php dynamic_sidebar( \'message\' ); ?>
	<?php if ( have_posts() ) : ?>											
		<?php /* Start the Loop */ ?>
		<?php while ( have_posts() ) : the_post(); ?>
		<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
			<header>
			<?php if ( is_single() ) :
			the_title( \'<h2 class="entry-title">\', \'</h2>\' );
			else :
			the_title( \'<h2 class="entry-title"><a href="\' . esc_url( get_permalink() ) . \'" rel="bookmark">\', \'</a></h2>\' );
			endif;
			?>
			</header>
			<?php the_content(); ?>
		</article>
		<?php if (theme_'.$templatename.'_options(\'comments\', \'1\')) { 
			comments_template(); 
		} ?>
		<?php endwhile; ?>
	<?php endif; ?>';
$bodycode = '<?php require_once("content.php"); ?>';
$indexphptext = str_replace('|BODYCODE|', $bodycode, $indexphptext);
if (!TCK_File::write($indexphpdest, $indexphptext)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_INDEXPHP') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_INDEXPHP') . '</p>';
}
echo $msg;

// create the file footer.php
if (!TCK_File::write($footerphpdest, $footerphptext)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_FOOTERPHP') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_FOOTERPHP') . '</p>';
}
echo $msg;

// create the file woocommerce.php
$woocommercephpdest = $path . '/woocommerce.php';
$woocommercecode = '<?php dynamic_sidebar( \'message\' ); ?>
	<div class="woocommerce">
		<?php woocommerce_content(); ?>
	</div>';
$woocommercephptext = str_replace('|BODYCODE|', $woocommercecode, $standarphptext);
if (!TCK_File::write($woocommercephpdest, $woocommercephptext)) {
	$msg = '<p class="errorck">' . TCK_Text::_('CK_ERROR_CREATING_WOOCOMMERCEPHP') . '</p>';
} else {
	$msg = '<p class="successck">' . TCK_Text::_('CK_SUCCESS_CREATING_WOOCOMMERCEPHP') . '</p>';
}
echo $msg;

echo $customcodeendbody;