<?php
/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access to this file
defined('ABSPATH') or die('Restricted access');
$input = new TCK_Input();
$templateid = $input->get('templateid', '', 'int'); 
$templatename = $input->get('templatename', '', 'string');
$path = get_theme_root() . '/' . $templatename;

$customcss = '';
// test if a custom css exists
if (TCK_File::exists($path . '/css/custom.css')) {
	$customcss = TCK_File::read($path . '/css/custom.css');
} else {
	echo TCK_Text::_('CK_NO_CUSTOMCSS_FILE_FOUND');
}
?>
<script>
var editor_customcss = CodeMirror.fromTextArea(document.getElementById("customcss"), {
	mode: "css",
//	styleActiveLine: true,
	lineNumbers: true,
//	lineWrapping: true
});
</script>
<table>
	<tr>
		<td style="vertical-align:top;">
			<div class="layoutinfos">
				<div class="layoutinfostitle"><?php echo TCK_Text::_('CK_PAGECUSTOMCSS_INFOS'); ?></div>
				<div class="layoutinfosdesc"><?php echo TCK_Text::_('CK_PAGECUSTOMCSS_DESC'); ?></div>
			</div>
		</td>
		<td style="vertical-align:top;">
			<textarea id="customcss" cols="50" rows="20" style="color: #777;"><?php echo $customcss; ?></textarea>
		</td>
	</tr>
</table>

