<?php
/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access to this file
defined('TCK_LOADED') or die('Restricted access');
require_once(TEMPLATECREATORCK_PATH . '/helpers/ckwidgets.php');

// get the list of widgets
$widgets = CKWidgets::loadWidgets();

?>
<div class="ckpopupoverlay"></div>
<div class="ckpopupheader">
    <div class="ckpopuplogo"></div>
    <div class="ckpopuptitle"><?php echo TCK_Text::_('CK_WIDGETSMANAGER'); ?></div>
    <div style="float:right;">
        <div class="ckclose ckcancel" onclick="$ck('#popup_editionck').empty().hide();"><?php echo TCK_Text::_('CK_CLOSE'); ?></div>
    </div>
    <div class="clr"></div>
</div>
<table>
	<tr>
		<td style="vertical-align:top;">
			<div class="layoutinfos">
				<div class="layoutinfostitle"><?php echo TCK_Text::_('CK_WIDGETSMANAGER_INFOS'); ?></div>
				<div class="layoutinfosdesc"><?php echo TCK_Text::_('CK_WIDGETSMANAGER_DESC'); ?></div>
			</div>
		</td>
		<td style="vertical-align:top;">
			<div id="elementscontainer" style="margin-top: 8px;">
				<div id="widgetsmanager">
					<?php foreach ($widgets as $widget) { 
					switch($widget->type) {
						case 'widget' :
						default :
							$label = 'info';
							break;
						case 'plugin' :
							$label = 'warning';
							break;
					}
					?>
					<div class="widgetrow clearfix" data-installed="<?php echo $widget->installed ?>" data-name="<?php echo $widget->name ?>" data-url="<?php echo $widget->url ?>" data-type="<?php echo $widget->type ?>" data-enabled="">
						<span class="widgettitledesc">
							<div class="widgettitle"><?php echo $widget->title; ?>&nbsp;<span class="cklabel cklabel-<?php echo $label ?>"><?php echo $widget->type ?></span></div>
							<div class="widgetdescription"><?php echo $widget->description; ?></div>
						</span>
						<span class="widgetactions">
							<span class="widgetinstall ckbutton" onclick="ckInstallWidget(this)"><span class="fa fa-download"></span> <?php echo TCK_Text::_('CK_INSTALL'); ?></span>
							<span class="widgetupdate ckbutton" onclick="ckInstallWidget(this, true)"><span class="fa fa-refresh"></span> <?php echo TCK_Text::_('CK_UPDATE'); ?></span>
							<span class="widgetenable ckbutton" onclick="ckEnableWidget(this)"><span class="fa fa-check"></span> <?php echo TCK_Text::_('CK_ENABLE'); ?></span>
							<span class="widgetdisable ckbutton" onclick="ckDisableWidget(this)"><span class="fa fa-ban"></span> <?php echo TCK_Text::_('CK_DISABLE'); ?></span>
							<?php if ($widget->edition) { ?>
							<span class="widgetedit ckbutton" onclick="ckEditWidget(this)"><span class="fa fa-edit"></span> <?php echo TCK_Text::_('CK_EDIT'); ?></span>
							<?php } ?>
						</span>
					</div>
					<?php } ?>
					<div class="clr"></div>
					<div id="widgetsdownload">
						<p></p>
						<hr />
						<div class="cktitle"><?php echo TCK_Text::_('CK_WIDGET_MANUAL_DOWNLOAD'); ?></div>
						<div><?php echo TCK_Text::_('CK_WIDGET_MANUAL_DOWNLOAD_DESC'); ?></div>
						<?php foreach ($widgets as $widget) { 
						?>
							<a class="ckbutton" href="<?php echo $widget->url ?>" target="_blank"><span class="fa fa-download"></span> <?php echo $widget->title ?></a>
						<?php
						}?>
						<p></p>
						<div>
							<input type="file" id="tck_file_upload" />
							<div class="ckbutton" id="ckInstallWidgetManualButton"><?php echo TCK_Text::_('CK_INSTALL'); ?></div>
				</div>
					</div>
				</div>
				
				<div id="widgetedition">
				</div>
				<div class="clr"></div>
			</div>
		</td>
	</tr>
</table>
<script language="javascript" type="text/javascript">
	$ck('#ckInstallWidgetManualButton').click(function() {
		ckInstallWidgetManually();
	});
</script>