<?php
/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access to this file
defined('ABSPATH') or die('Restricted access');

$comments_options = $blocsbyname['layout_comments_html'];
$commentsavatarsize = isset($comments_options->commentsavatarsize) ? $comments_options->commentsavatarsize : '100';
$commentsnumber = isset($comments_options->commentsnumber) ? $comments_options->commentsnumber : '100';
$iconsclass = isset($comments_options->commentsicons) && $comments_options->commentsicons == '1' ? ' comments-with-icons' : '';
$styleclass = '';
if (isset($comments_options->commentsstyle1) && $comments_options->commentsstyle1 == 'checked') {
	$styleclass = ' comments-style1';
} else if (isset($comments_options->commentsstyle2) && $comments_options->commentsstyle2 == 'checked') {
	$styleclass =  ' comments-style2';
} else if (isset($comments_options->commentsstyle3) && $comments_options->commentsstyle3 == 'checked') {
	$styleclass = ' comments-style3';
}

$comments_php = '<?php
/**
 * Created by Template Creator CK
 * http://www.template-creator.com
 */

/*
 * If the current post is protected by a password and
 * the visitor has not yet entered the password we will
 * return early without loading the comments.
 */
if ( post_password_required() ) {
	return;
}
?>

<div id="comments" class="comments-area' . $iconsclass . $styleclass . '">

	<?php
	// You can start editing here -- including this comment!
	if ( have_comments() ) : ?>
		<h2 class="comments-title">
			<?php
				$comments_number = get_comments_number();
				if ( \'1\' === $comments_number ) {
					/* translators: %s: post title */
					printf( _x( \'One Reply to &ldquo;%s&rdquo;\', \'comments title\', \'' . $templatename . '\' ), get_the_title() );
				} else {
					printf(
						/* translators: 1: number of comments, 2: post title */
						_nx(
							\'%1$s Reply to &ldquo;%2$s&rdquo;\',
							\'%1$s Replies to &ldquo;%2$s&rdquo;\',
							$comments_number,
							\'comments title\',
							\'' . $templatename . '\'
						),
						number_format_i18n( $comments_number ),
						get_the_title()
					);
				}
			?>
		</h2>

		<ol class="comment-list">
			<?php
				wp_list_comments( array(
					\'avatar_size\' => ' . (int)$commentsavatarsize . ',
					\'style\'       => \'ol\',
					// \'short_ping\'  => true,
					\'format\'  => \'html5\'
				) );
			?>
		</ol>

		<?php the_comments_pagination( array(
			\'prev_text\' => \'<span class="screen-reader-text">\' . __( \'Previous\', \'' . $templatename . '\' ) . \'</span>\',
			\'next_text\' => \'<span class="screen-reader-text">\' . __( \'Next\', \'' . $templatename . '\' ) . \'</span>\',
		) );

	endif; // Check for have_comments().

	// If comments are closed and there are comments, let\'s leave a little note, shall we?
	if ( ! comments_open() && get_comments_number() && post_type_supports( get_post_type(), \'comments\' ) ) : ?>

		<p class="no-comments"><?php _e( \'Comments are closed.\', \'' . $templatename . '\' ); ?></p>
	<?php
	endif;

	comment_form();
	?>

</div><!-- #comments -->';

@file_put_contents($path . '/comments.php', $comments_php);