<?php

/**
 * @name		Template Creator CK 3
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */
// No direct access
defined('ABSPATH') or die;

/**
 * View to edit
 */
class TemplateckViewTemplate extends TemplateckView {

	protected $state;
	protected $item;
	protected $form;
	protected $params;

	public function __construct() {
		parent::__construct();
	}

	/**
	 * Display the view
	 */
	public function display($tpl = null) {

		$this->view = 'template';

		require_once TEMPLATECREATORCK_PATH . '/helpers/creatorck.php';
		require_once TEMPLATECREATORCK_PATH . '/helpers/ckinterface.php';
		require_once TEMPLATECREATORCK_PATH . '/helpers/ckstyles.php';
		require_once TEMPLATECREATORCK_PATH . '/helpers/zip.php';
		require_once TEMPLATECREATORCK_PATH . '/helpers/ziparchiver.php';

		// init variables
//		$post = $post_type = $post_type_object = null;

		/*if (empty($id)) {
			// check if the post exists
			if (isset($_GET['id'])) {
				$post_id = (int) $_GET['id'];
			} elseif (isset($_POST['post_ID'])) {
				$post_id = (int) $_POST['post_ID'];
			} else {
				$post_id = 0;
			}
		}*/

		// do an action
//		if (!empty($_REQUEST['action']) && isset($post_id)) {
//			if ($_REQUEST['action'] == 'save' && wp_verify_nonce($_REQUEST['_wpnonce'], 'templatecreatorck_save')) {
//				
//			}
//		}

		$this->item = $this->get('template', 'Data', $post_id);
		$this->isTemplateInstalled = $this->_checkIfTemplateInstalled($this->item->name);
		$this->imagespath = TEMPLATECREATORCK_MEDIA_URL . '/images/menustyles/';
		parent::display($tpl);
	}

	private function makeBackup($id) {
		// $wpdb->delete( $table, $where, $where_format = null );
		require_once( TEMPLATECREATORCK_PATH . '/models/template.php' );
		$className = 'TemplateckModelTemplate';
		$model = new $className;
		$model->makeBackup($id);
	}
	/**
	 * private function to load the fonts in the page
	 */
	function _callfonts() {
		$fontstyles = '';
		$fontsheets = '';

		global $wpdb;
		$query = 'SELECT * FROM '. $wpdb->prefix . 'templateck_fonts';
		$query.=' ORDER BY id ASC';
		$rows = $wpdb->get_results($query, OBJECT);

		if (!$rows)
			return false;

		foreach ($rows as $row) {
			if (stristr($row->styles, '@import')) 
			{
				$fontsheets .= str_replace(");", "' rel='stylesheet' type='text/css'>", str_replace("@import url(", "<link href='", $row->styles));
			} else {
				$fontstyles .= str_replace("url('", "url('" . TEMPLATECREATORCK_MEDIA_URL . "/fonts/" . $row->name . "/", $row->styles);
			}
		}
		if ($fontstyles)
			echo "<style type=\"text/css\">" . $fontstyles . "</style>";
		if ($fontsheets)
			echo $fontsheets;
	}
	
	/**
	 * private function to check if the template templatecreatorck is installed
	 */
	function _checkIfTemplateInstalled($name) {
		if (! $name) return false;
		if (! TCK_Folder::exists( get_theme_root() . '/' . $name )) {
			return false;
		} else {
			return true;
		}

		return false;
	}

}