<?php
defined('TCK_LOADED') or die;

//Our class extends the WP_List_Table class, so we need to make sure that it's there
if (!class_exists('TCK_ListTable')) {
	require_once( TEMPLATECREATORCK_PATH . '/helpers/cklisttable.php' );
}

if (!class_exists('TCK_ListTableTemplate')) {
	require_once( TEMPLATECREATORCK_PATH . '/helpers/cklisttabletemplate.php' );
}


//Prepare Table of elements
$wp_list_table = new TCK_ListTableTemplate();
$wp_list_table->prepare_items();
?> 
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URL ?>/assets/ckframework.css" type="text/css" />
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URL ?>/assets/admin.css" type="text/css" />
<?php echo TemplateckHelper::loadCkbox(); ?>
<script>
function TCK_submitform(action) {
	var form = document.getElementById('templates-filter');
	// var selector = document.getElementsByName('action')[0];
	var selector = form.task;
	selector.value = action;
	var selection = TCK_getcheckedthemes('cid[]');
	if (! selection.length) {
		alert('Please select a theme');
		return;
	}
	form.submit();
}

function TCK_getcheckedthemes(name) {
	var list = document.getElementsByName(name);
	var results = [];
	for(var i = 0; i < list.length; i++){
		list[i].checked ? results.push(list[i]):"";
	}
	return results;
}

function TCK_import_theme() {
	TCK_show_modal('import-theme-modal');
}

function TCK_hide_modal(el) {
	var p = jQuery(el).parents('.ck-modal-wrap')[0];
	jQuery(p).hide();
}

function TCK_show_modal(id) {
	jQuery('#' + id).show();
}

</script>
<div class="ckadminwrap">
	<?php echo TemplateckHelper::displayMessages(); ?>
	<a href="https://www.template-creator.com" target="_blank"><img src="<?php echo TEMPLATECREATORCK_MEDIA_URL ?>/images/logo_templatecreatorck_64.png" style="margin: 0px 5px;" /></a>
	<div style="clear:both;"></div>
	<?php if (current_user_can('edit_plugins')) { ?>
	<div class="toolbar">
		<a href="admin.php?page=templatecreatorck_edit&id=0" class="btn-action"><span class="dashicons dashicons-welcome-add-page"></span><?php echo __('Add new') ?></a>
		<a href="javascript:void(0)" class="btn-action" onclick="TCK_submitform('template.edit')"><span class="dashicons dashicons-welcome-write-blog"></span><?php echo __('Edit') ?></a>
		<a href="javascript:void(0)" class="btn-action" onclick="TCK_submitform('template.copy')"><span class="dashicons dashicons-admin-page"></span><?php echo __('Copy') ?></a>
		<a href="javascript:void(0)" class="btn-action" onclick="TCK_submitform('template.delete')"><span class="dashicons dashicons-trash"></span><?php echo __('Delete') ?></a>
		<a href="javascript:void(0)" class="btn-action" onclick="CKBox.open({handler: 'inline', content: 'ckimportmodal', fullscreen: false, size: {x: '600px', y: '200px'}});"><span class="dashicons dashicons-upload"></span><?php echo __('Import') ?></a>
		<a href="javascript:void(0)" class="btn-action" onclick="TCK_submitform('template.export')"><span class="dashicons dashicons-download"></span><?php echo __('Export') ?></a>
	</div>
	<?php } ?>
	<form id="templates-filter" method="post">
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="page" value="<?php echo esc_attr( $_REQUEST['page'] ) ?>" />
		<input type="hidden" name="post_status" class="post_status_page" value="<?php echo!empty($_REQUEST['post_status']) ? esc_attr($_REQUEST['post_status']) : 'all'; ?>" />
		<input type="hidden" name="post_type" class="post_type_page" value="templatecreatorck" />
<?php
$wp_list_table->display()
?>
	</form>

</div>
<?php // modal popup for import ?>
<div id="ckimportmodal" class="" style="position:relative;display:none;">
	<div style="padding: 10px;">
		<div class="ckimportmodalcontent">
			<h1><?php echo TCK_Text::_('CK_INSTALL_GABARIT'); ?></h1>
			<form id="importpage" method="post" enctype="multipart/form-data">
				<div>
					<fieldset>
						<table class="table table-striped">
							<tr>
								<td width="110" class="key">
									<label for="title">
										<?php echo TCK_Text::_('CK_CHOOSE_FILE_TCK'); ?>:
									</label>
								</td>
								<td>
									<input class="inputbox" type="file" name="file" id="file" size="60" />
									<input type="submit" name="submitfile" class="inputbox ckbutton" value="<?php echo TCK_Text::_('CK_INSTALL'); ?>" />
								</td>
							</tr>
						</table>
					</fieldset>
				</div>
				<input type="hidden" name="_wpnonce" value="<?php echo wp_create_nonce('templatecreatorck'); ?>" />
				<input type="hidden" name="task" value="template.import" />
			</form>
		</div>
	</div>
</div>
<?php // modal popup for export ?>
<div id="ckExportModal" class="" style="position:relative;display:none;">
	<div style="padding: 10px;">
		<div class="ckExportModalContent">
			<div class="" id="">
				<div class=""><h1><?php echo TCK_Text::_('CK_EXPORT'); ?></h1></div>
					<div id="ckExportPageDownload" style="border-top: 1px solid #ddd;padding: 0.75em;">

					</div>
			</div>
		</div>
	</div>
</div>
<form id="downloadexportpage" method="post" enctype="multipart/form-data" style="display: none;">
	<input type="text" name="filepath" id="filepath" />
	<input type="submit" name="submitfile" />
	<?php echo JHtml::_('form.token'); ?>
	<input type="hidden" name="task" value="template.download" />
</form>
<script>
/* get the file and submit it for download */
function ckExportPage(form) {
	var cid = jQuery(form).find('input[name="cid[]"]:checked');
	if (cid.length) {
		var id = cid[0].value;
		ckDoExport(id);
	} else {
		alert('<?php echo TCK_Text::_('CK_PLEASE_SELECT_ITEM', true) ?>');
	}
}

/* export the file and load it in the page */
function ckDoExport(id) {
	jQuery('#ckExportPageDownload').addClass('ckwait');
	var name = jQuery(jQuery('input[name="cid[]"]:checked')[0]).parent().attr('data-name');
	CKBox.open({handler: 'inline', content: 'ckExportModal', fullscreen: false, size: {x: '600px', y: '150px'}})
	var myurl = "<?php echo TEMPLATECREATORCK_ADMIN_URL ?>&task=template.export";
	jQuery.ajax({
		type: "POST",
		url: myurl,
		data: {
			id: id,
			name: jQuery(jQuery('input[name="cid[]"]:checked')[0]).parent().attr('data-name')
		}
	}).done(function(code) {
		jQuery('#ckExportPageDownload').removeClass('ckwait').html(code);
		var form = document.getElementById('downloadexportpage');
		form.filepath.value = '/export/' + name + '_gabarit.tck3z';
		form.submit();
	}).fail(function() {
		alert(TCK.Text._('CK_FAILED', 'Failed'));
	});
}
</script>


