<?php
/**
 * @name		Template Creator CK
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */

defined('TCK_LOADED') or die;

?>
<style>
body {
	color: #333;
	font-family: Helvetica;
	background: #fff;
}

.fontawesome-icon-list {
	display: flex;
	flex-wrap: wrap;
}

.fontawesome-icon-list a {
	color: #000;
}

div.fa-hover {
	float: left;
	height: 30px;
	margin: 10px;
	padding: 10px;
	width: 14%;
	text-align: center;
}

div.fa-hover:hover a {
	transform: scale(2);
	background: #fff;
	z-index: 1;
	display: block;
}

div.fa-hover a {
	text-decoration: none;
}

.sr-only {
	display: none;
}
</style>
<script src="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/assets/jquery.min.js" type="text/javascript"></script>
<script src="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/assets/jquery-noconflict.js" type="text/javascript"></script>
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/assets/font-awesome.min.css" type="text/css" />
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/assets/ckframework.css" type="text/css" />

<div class="ckinterface">
	<div id="search" class="filter-parent">
	<label for="filter-by"></label>
	<div style="position: relative; height: 46px; display: block;">
		<input type="text" tabindex="1" class="" id="filter-by" placeholder="<?php echo TCK_Text::_('CK_SEARCH_ICONS') ?>" style="height:auto;margin:0;background-color: transparent; position: relative;">
		<span class="ckbutton-group">
			<button class="ckbutton fa fa-search" id="filter-submit" onclick="searchiconsck()"></button>
			<button class="ckbutton fa fa-times" id="filter-clear" onclick="clearsearchiconsck()"></button>
		</span>
	</div>
	<div>
		<h3><?php echo TCK_Text::_('CK_FILTER_BY_GROUP') ?></h3>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('web-application')">Web Application Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('accessibility')">Accessibility Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('hand')">Hand Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('transportation')">Transportation Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('gender')">Gender Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('file-type')">File Type Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('spinner')">Spinner Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('form-control')">Form Control Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('payment')">Payment Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('chart')">Chart Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('currency')">Currency Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('text-editor')">Text Editor Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('directional')">Directional Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('video-player')">Video Player Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('brand')">Brand Icons</button>
		<button class="ckbutton filter-category" id="filter-submit" onclick="filtericonsbycatck('medical')">Medical Icons</button>
	</div>
</div>
<script>
function searchiconsck() {
	jQuery('section').show();
	jQuery('i.fa').parent().parent().hide();
	jQuery('i[class*=' + jQuery('#filter-by').val() + ']').parent().parent().show();
}

function clearsearchiconsck() {
	jQuery('section').show();
	jQuery('i.fa').parent().parent().show();
	jQuery('#filter-by').val('');
}

function filtericonsbycatck (cat) {
	jQuery('i.fa').parent().parent().show();
	jQuery('section').hide();
	jQuery('section#' + cat).show();
	jQuery('#filter-by').val('');
}

jQuery(document).ready(function() {
	jQuery('.fa-hover a').click(function(e) {
		e.preventDefault();
		window.parent.ckSelectFaIcon(jQuery(this).find('i').attr('class'));
		window.parent.CKBox.close();
	});
});
</script>

   

    <section id="web-application">
  <h2 class="page-header">Web Application Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/adjust"><i aria-hidden="true" class="fa fa-adjust"></i> <span class="sr-only">Example of </span>adjust</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/american-sign-language-interpreting"><i aria-hidden="true" class="fa fa-american-sign-language-interpreting"></i> <span class="sr-only">Example of </span>american-sign-language-interpreting</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/anchor"><i aria-hidden="true" class="fa fa-anchor"></i> <span class="sr-only">Example of </span>anchor</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/archive"><i aria-hidden="true" class="fa fa-archive"></i> <span class="sr-only">Example of </span>archive</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/area-chart"><i aria-hidden="true" class="fa fa-area-chart"></i> <span class="sr-only">Example of </span>area-chart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows"><i aria-hidden="true" class="fa fa-arrows"></i> <span class="sr-only">Example of </span>arrows</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows-h"><i aria-hidden="true" class="fa fa-arrows-h"></i> <span class="sr-only">Example of </span>arrows-h</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows-v"><i aria-hidden="true" class="fa fa-arrows-v"></i> <span class="sr-only">Example of </span>arrows-v</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/american-sign-language-interpreting"><i aria-hidden="true" class="fa fa-asl-interpreting"></i> <span class="sr-only">Example of </span>asl-interpreting <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/assistive-listening-systems"><i aria-hidden="true" class="fa fa-assistive-listening-systems"></i> <span class="sr-only">Example of </span>assistive-listening-systems</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/asterisk"><i aria-hidden="true" class="fa fa-asterisk"></i> <span class="sr-only">Example of </span>asterisk</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/at"><i aria-hidden="true" class="fa fa-at"></i> <span class="sr-only">Example of </span>at</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/audio-description"><i aria-hidden="true" class="fa fa-audio-description"></i> <span class="sr-only">Example of </span>audio-description</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/car"><i aria-hidden="true" class="fa fa-automobile"></i> <span class="sr-only">Example of </span>automobile <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/balance-scale"><i aria-hidden="true" class="fa fa-balance-scale"></i> <span class="sr-only">Example of </span>balance-scale</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ban"><i aria-hidden="true" class="fa fa-ban"></i> <span class="sr-only">Example of </span>ban</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/university"><i aria-hidden="true" class="fa fa-bank"></i> <span class="sr-only">Example of </span>bank <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bar-chart"><i aria-hidden="true" class="fa fa-bar-chart"></i> <span class="sr-only">Example of </span>bar-chart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bar-chart"><i aria-hidden="true" class="fa fa-bar-chart-o"></i> <span class="sr-only">Example of </span>bar-chart-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/barcode"><i aria-hidden="true" class="fa fa-barcode"></i> <span class="sr-only">Example of </span>barcode</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bars"><i aria-hidden="true" class="fa fa-bars"></i> <span class="sr-only">Example of </span>bars</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-empty"><i aria-hidden="true" class="fa fa-battery-0"></i> <span class="sr-only">Example of </span>battery-0 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-quarter"><i aria-hidden="true" class="fa fa-battery-1"></i> <span class="sr-only">Example of </span>battery-1 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-half"><i aria-hidden="true" class="fa fa-battery-2"></i> <span class="sr-only">Example of </span>battery-2 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-three-quarters"><i aria-hidden="true" class="fa fa-battery-3"></i> <span class="sr-only">Example of </span>battery-3 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-full"><i aria-hidden="true" class="fa fa-battery-4"></i> <span class="sr-only">Example of </span>battery-4 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-empty"><i aria-hidden="true" class="fa fa-battery-empty"></i> <span class="sr-only">Example of </span>battery-empty</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-full"><i aria-hidden="true" class="fa fa-battery-full"></i> <span class="sr-only">Example of </span>battery-full</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-half"><i aria-hidden="true" class="fa fa-battery-half"></i> <span class="sr-only">Example of </span>battery-half</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-quarter"><i aria-hidden="true" class="fa fa-battery-quarter"></i> <span class="sr-only">Example of </span>battery-quarter</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/battery-three-quarters"><i aria-hidden="true" class="fa fa-battery-three-quarters"></i> <span class="sr-only">Example of </span>battery-three-quarters</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bed"><i aria-hidden="true" class="fa fa-bed"></i> <span class="sr-only">Example of </span>bed</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/beer"><i aria-hidden="true" class="fa fa-beer"></i> <span class="sr-only">Example of </span>beer</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bell"><i aria-hidden="true" class="fa fa-bell"></i> <span class="sr-only">Example of </span>bell</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bell-o"><i aria-hidden="true" class="fa fa-bell-o"></i> <span class="sr-only">Example of </span>bell-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bell-slash"><i aria-hidden="true" class="fa fa-bell-slash"></i> <span class="sr-only">Example of </span>bell-slash</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bell-slash-o"><i aria-hidden="true" class="fa fa-bell-slash-o"></i> <span class="sr-only">Example of </span>bell-slash-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bicycle"><i aria-hidden="true" class="fa fa-bicycle"></i> <span class="sr-only">Example of </span>bicycle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/binoculars"><i aria-hidden="true" class="fa fa-binoculars"></i> <span class="sr-only">Example of </span>binoculars</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/birthday-cake"><i aria-hidden="true" class="fa fa-birthday-cake"></i> <span class="sr-only">Example of </span>birthday-cake</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/blind"><i aria-hidden="true" class="fa fa-blind"></i> <span class="sr-only">Example of </span>blind</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bluetooth"><i aria-hidden="true" class="fa fa-bluetooth"></i> <span class="sr-only">Example of </span>bluetooth</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bluetooth-b"><i aria-hidden="true" class="fa fa-bluetooth-b"></i> <span class="sr-only">Example of </span>bluetooth-b</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bolt"><i aria-hidden="true" class="fa fa-bolt"></i> <span class="sr-only">Example of </span>bolt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bomb"><i aria-hidden="true" class="fa fa-bomb"></i> <span class="sr-only">Example of </span>bomb</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/book"><i aria-hidden="true" class="fa fa-book"></i> <span class="sr-only">Example of </span>book</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bookmark"><i aria-hidden="true" class="fa fa-bookmark"></i> <span class="sr-only">Example of </span>bookmark</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bookmark-o"><i aria-hidden="true" class="fa fa-bookmark-o"></i> <span class="sr-only">Example of </span>bookmark-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/braille"><i aria-hidden="true" class="fa fa-braille"></i> <span class="sr-only">Example of </span>braille</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/briefcase"><i aria-hidden="true" class="fa fa-briefcase"></i> <span class="sr-only">Example of </span>briefcase</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bug"><i aria-hidden="true" class="fa fa-bug"></i> <span class="sr-only">Example of </span>bug</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/building"><i aria-hidden="true" class="fa fa-building"></i> <span class="sr-only">Example of </span>building</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/building-o"><i aria-hidden="true" class="fa fa-building-o"></i> <span class="sr-only">Example of </span>building-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bullhorn"><i aria-hidden="true" class="fa fa-bullhorn"></i> <span class="sr-only">Example of </span>bullhorn</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bullseye"><i aria-hidden="true" class="fa fa-bullseye"></i> <span class="sr-only">Example of </span>bullseye</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bus"><i aria-hidden="true" class="fa fa-bus"></i> <span class="sr-only">Example of </span>bus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/taxi"><i aria-hidden="true" class="fa fa-cab"></i> <span class="sr-only">Example of </span>cab <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/calculator"><i aria-hidden="true" class="fa fa-calculator"></i> <span class="sr-only">Example of </span>calculator</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/calendar"><i aria-hidden="true" class="fa fa-calendar"></i> <span class="sr-only">Example of </span>calendar</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/calendar-check-o"><i aria-hidden="true" class="fa fa-calendar-check-o"></i> <span class="sr-only">Example of </span>calendar-check-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/calendar-minus-o"><i aria-hidden="true" class="fa fa-calendar-minus-o"></i> <span class="sr-only">Example of </span>calendar-minus-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/calendar-o"><i aria-hidden="true" class="fa fa-calendar-o"></i> <span class="sr-only">Example of </span>calendar-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/calendar-plus-o"><i aria-hidden="true" class="fa fa-calendar-plus-o"></i> <span class="sr-only">Example of </span>calendar-plus-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/calendar-times-o"><i aria-hidden="true" class="fa fa-calendar-times-o"></i> <span class="sr-only">Example of </span>calendar-times-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/camera"><i aria-hidden="true" class="fa fa-camera"></i> <span class="sr-only">Example of </span>camera</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/camera-retro"><i aria-hidden="true" class="fa fa-camera-retro"></i> <span class="sr-only">Example of </span>camera-retro</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/car"><i aria-hidden="true" class="fa fa-car"></i> <span class="sr-only">Example of </span>car</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-down"><i aria-hidden="true" class="fa fa-caret-square-o-down"></i> <span class="sr-only">Example of </span>caret-square-o-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-left"><i aria-hidden="true" class="fa fa-caret-square-o-left"></i> <span class="sr-only">Example of </span>caret-square-o-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-right"><i aria-hidden="true" class="fa fa-caret-square-o-right"></i> <span class="sr-only">Example of </span>caret-square-o-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-up"><i aria-hidden="true" class="fa fa-caret-square-o-up"></i> <span class="sr-only">Example of </span>caret-square-o-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cart-arrow-down"><i aria-hidden="true" class="fa fa-cart-arrow-down"></i> <span class="sr-only">Example of </span>cart-arrow-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cart-plus"><i aria-hidden="true" class="fa fa-cart-plus"></i> <span class="sr-only">Example of </span>cart-plus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc"><i aria-hidden="true" class="fa fa-cc"></i> <span class="sr-only">Example of </span>cc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/certificate"><i aria-hidden="true" class="fa fa-certificate"></i> <span class="sr-only">Example of </span>certificate</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/check"><i aria-hidden="true" class="fa fa-check"></i> <span class="sr-only">Example of </span>check</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/check-circle"><i aria-hidden="true" class="fa fa-check-circle"></i> <span class="sr-only">Example of </span>check-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/check-circle-o"><i aria-hidden="true" class="fa fa-check-circle-o"></i> <span class="sr-only">Example of </span>check-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/check-square"><i aria-hidden="true" class="fa fa-check-square"></i> <span class="sr-only">Example of </span>check-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/check-square-o"><i aria-hidden="true" class="fa fa-check-square-o"></i> <span class="sr-only">Example of </span>check-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/child"><i aria-hidden="true" class="fa fa-child"></i> <span class="sr-only">Example of </span>child</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/circle"><i aria-hidden="true" class="fa fa-circle"></i> <span class="sr-only">Example of </span>circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/circle-o"><i aria-hidden="true" class="fa fa-circle-o"></i> <span class="sr-only">Example of </span>circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/circle-o-notch"><i aria-hidden="true" class="fa fa-circle-o-notch"></i> <span class="sr-only">Example of </span>circle-o-notch</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/circle-thin"><i aria-hidden="true" class="fa fa-circle-thin"></i> <span class="sr-only">Example of </span>circle-thin</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/clock-o"><i aria-hidden="true" class="fa fa-clock-o"></i> <span class="sr-only">Example of </span>clock-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/clone"><i aria-hidden="true" class="fa fa-clone"></i> <span class="sr-only">Example of </span>clone</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/times"><i aria-hidden="true" class="fa fa-close"></i> <span class="sr-only">Example of </span>close <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cloud"><i aria-hidden="true" class="fa fa-cloud"></i> <span class="sr-only">Example of </span>cloud</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cloud-download"><i aria-hidden="true" class="fa fa-cloud-download"></i> <span class="sr-only">Example of </span>cloud-download</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cloud-upload"><i aria-hidden="true" class="fa fa-cloud-upload"></i> <span class="sr-only">Example of </span>cloud-upload</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/code"><i aria-hidden="true" class="fa fa-code"></i> <span class="sr-only">Example of </span>code</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/code-fork"><i aria-hidden="true" class="fa fa-code-fork"></i> <span class="sr-only">Example of </span>code-fork</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/coffee"><i aria-hidden="true" class="fa fa-coffee"></i> <span class="sr-only">Example of </span>coffee</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cog"><i aria-hidden="true" class="fa fa-cog"></i> <span class="sr-only">Example of </span>cog</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cogs"><i aria-hidden="true" class="fa fa-cogs"></i> <span class="sr-only">Example of </span>cogs</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/comment"><i aria-hidden="true" class="fa fa-comment"></i> <span class="sr-only">Example of </span>comment</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/comment-o"><i aria-hidden="true" class="fa fa-comment-o"></i> <span class="sr-only">Example of </span>comment-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/commenting"><i aria-hidden="true" class="fa fa-commenting"></i> <span class="sr-only">Example of </span>commenting</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/commenting-o"><i aria-hidden="true" class="fa fa-commenting-o"></i> <span class="sr-only">Example of </span>commenting-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/comments"><i aria-hidden="true" class="fa fa-comments"></i> <span class="sr-only">Example of </span>comments</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/comments-o"><i aria-hidden="true" class="fa fa-comments-o"></i> <span class="sr-only">Example of </span>comments-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/compass"><i aria-hidden="true" class="fa fa-compass"></i> <span class="sr-only">Example of </span>compass</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/copyright"><i aria-hidden="true" class="fa fa-copyright"></i> <span class="sr-only">Example of </span>copyright</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/creative-commons"><i aria-hidden="true" class="fa fa-creative-commons"></i> <span class="sr-only">Example of </span>creative-commons</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/credit-card"><i aria-hidden="true" class="fa fa-credit-card"></i> <span class="sr-only">Example of </span>credit-card</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/credit-card-alt"><i aria-hidden="true" class="fa fa-credit-card-alt"></i> <span class="sr-only">Example of </span>credit-card-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/crop"><i aria-hidden="true" class="fa fa-crop"></i> <span class="sr-only">Example of </span>crop</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/crosshairs"><i aria-hidden="true" class="fa fa-crosshairs"></i> <span class="sr-only">Example of </span>crosshairs</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cube"><i aria-hidden="true" class="fa fa-cube"></i> <span class="sr-only">Example of </span>cube</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cubes"><i aria-hidden="true" class="fa fa-cubes"></i> <span class="sr-only">Example of </span>cubes</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cutlery"><i aria-hidden="true" class="fa fa-cutlery"></i> <span class="sr-only">Example of </span>cutlery</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tachometer"><i aria-hidden="true" class="fa fa-dashboard"></i> <span class="sr-only">Example of </span>dashboard <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/database"><i aria-hidden="true" class="fa fa-database"></i> <span class="sr-only">Example of </span>database</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/deaf"><i aria-hidden="true" class="fa fa-deaf"></i> <span class="sr-only">Example of </span>deaf</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/deaf"><i aria-hidden="true" class="fa fa-deafness"></i> <span class="sr-only">Example of </span>deafness <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/desktop"><i aria-hidden="true" class="fa fa-desktop"></i> <span class="sr-only">Example of </span>desktop</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/diamond"><i aria-hidden="true" class="fa fa-diamond"></i> <span class="sr-only">Example of </span>diamond</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/dot-circle-o"><i aria-hidden="true" class="fa fa-dot-circle-o"></i> <span class="sr-only">Example of </span>dot-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/download"><i aria-hidden="true" class="fa fa-download"></i> <span class="sr-only">Example of </span>download</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pencil-square-o"><i aria-hidden="true" class="fa fa-edit"></i> <span class="sr-only">Example of </span>edit <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ellipsis-h"><i aria-hidden="true" class="fa fa-ellipsis-h"></i> <span class="sr-only">Example of </span>ellipsis-h</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ellipsis-v"><i aria-hidden="true" class="fa fa-ellipsis-v"></i> <span class="sr-only">Example of </span>ellipsis-v</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/envelope"><i aria-hidden="true" class="fa fa-envelope"></i> <span class="sr-only">Example of </span>envelope</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/envelope-o"><i aria-hidden="true" class="fa fa-envelope-o"></i> <span class="sr-only">Example of </span>envelope-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/envelope-square"><i aria-hidden="true" class="fa fa-envelope-square"></i> <span class="sr-only">Example of </span>envelope-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eraser"><i aria-hidden="true" class="fa fa-eraser"></i> <span class="sr-only">Example of </span>eraser</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/exchange"><i aria-hidden="true" class="fa fa-exchange"></i> <span class="sr-only">Example of </span>exchange</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/exclamation"><i aria-hidden="true" class="fa fa-exclamation"></i> <span class="sr-only">Example of </span>exclamation</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/exclamation-circle"><i aria-hidden="true" class="fa fa-exclamation-circle"></i> <span class="sr-only">Example of </span>exclamation-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/exclamation-triangle"><i aria-hidden="true" class="fa fa-exclamation-triangle"></i> <span class="sr-only">Example of </span>exclamation-triangle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/external-link"><i aria-hidden="true" class="fa fa-external-link"></i> <span class="sr-only">Example of </span>external-link</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/external-link-square"><i aria-hidden="true" class="fa fa-external-link-square"></i> <span class="sr-only">Example of </span>external-link-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eye"><i aria-hidden="true" class="fa fa-eye"></i> <span class="sr-only">Example of </span>eye</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eye-slash"><i aria-hidden="true" class="fa fa-eye-slash"></i> <span class="sr-only">Example of </span>eye-slash</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eyedropper"><i aria-hidden="true" class="fa fa-eyedropper"></i> <span class="sr-only">Example of </span>eyedropper</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fax"><i aria-hidden="true" class="fa fa-fax"></i> <span class="sr-only">Example of </span>fax</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rss"><i aria-hidden="true" class="fa fa-feed"></i> <span class="sr-only">Example of </span>feed <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/female"><i aria-hidden="true" class="fa fa-female"></i> <span class="sr-only">Example of </span>female</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fighter-jet"><i aria-hidden="true" class="fa fa-fighter-jet"></i> <span class="sr-only">Example of </span>fighter-jet</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-archive-o"><i aria-hidden="true" class="fa fa-file-archive-o"></i> <span class="sr-only">Example of </span>file-archive-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-audio-o"><i aria-hidden="true" class="fa fa-file-audio-o"></i> <span class="sr-only">Example of </span>file-audio-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-code-o"><i aria-hidden="true" class="fa fa-file-code-o"></i> <span class="sr-only">Example of </span>file-code-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-excel-o"><i aria-hidden="true" class="fa fa-file-excel-o"></i> <span class="sr-only">Example of </span>file-excel-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-image-o"><i aria-hidden="true" class="fa fa-file-image-o"></i> <span class="sr-only">Example of </span>file-image-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-video-o"><i aria-hidden="true" class="fa fa-file-movie-o"></i> <span class="sr-only">Example of </span>file-movie-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-pdf-o"><i aria-hidden="true" class="fa fa-file-pdf-o"></i> <span class="sr-only">Example of </span>file-pdf-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-image-o"><i aria-hidden="true" class="fa fa-file-photo-o"></i> <span class="sr-only">Example of </span>file-photo-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-image-o"><i aria-hidden="true" class="fa fa-file-picture-o"></i> <span class="sr-only">Example of </span>file-picture-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-powerpoint-o"><i aria-hidden="true" class="fa fa-file-powerpoint-o"></i> <span class="sr-only">Example of </span>file-powerpoint-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-audio-o"><i aria-hidden="true" class="fa fa-file-sound-o"></i> <span class="sr-only">Example of </span>file-sound-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-video-o"><i aria-hidden="true" class="fa fa-file-video-o"></i> <span class="sr-only">Example of </span>file-video-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-word-o"><i aria-hidden="true" class="fa fa-file-word-o"></i> <span class="sr-only">Example of </span>file-word-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-archive-o"><i aria-hidden="true" class="fa fa-file-zip-o"></i> <span class="sr-only">Example of </span>file-zip-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/film"><i aria-hidden="true" class="fa fa-film"></i> <span class="sr-only">Example of </span>film</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/filter"><i aria-hidden="true" class="fa fa-filter"></i> <span class="sr-only">Example of </span>filter</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fire"><i aria-hidden="true" class="fa fa-fire"></i> <span class="sr-only">Example of </span>fire</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fire-extinguisher"><i aria-hidden="true" class="fa fa-fire-extinguisher"></i> <span class="sr-only">Example of </span>fire-extinguisher</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/flag"><i aria-hidden="true" class="fa fa-flag"></i> <span class="sr-only">Example of </span>flag</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/flag-checkered"><i aria-hidden="true" class="fa fa-flag-checkered"></i> <span class="sr-only">Example of </span>flag-checkered</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/flag-o"><i aria-hidden="true" class="fa fa-flag-o"></i> <span class="sr-only">Example of </span>flag-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bolt"><i aria-hidden="true" class="fa fa-flash"></i> <span class="sr-only">Example of </span>flash <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/flask"><i aria-hidden="true" class="fa fa-flask"></i> <span class="sr-only">Example of </span>flask</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/folder"><i aria-hidden="true" class="fa fa-folder"></i> <span class="sr-only">Example of </span>folder</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/folder-o"><i aria-hidden="true" class="fa fa-folder-o"></i> <span class="sr-only">Example of </span>folder-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/folder-open"><i aria-hidden="true" class="fa fa-folder-open"></i> <span class="sr-only">Example of </span>folder-open</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/folder-open-o"><i aria-hidden="true" class="fa fa-folder-open-o"></i> <span class="sr-only">Example of </span>folder-open-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/frown-o"><i aria-hidden="true" class="fa fa-frown-o"></i> <span class="sr-only">Example of </span>frown-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/futbol-o"><i aria-hidden="true" class="fa fa-futbol-o"></i> <span class="sr-only">Example of </span>futbol-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gamepad"><i aria-hidden="true" class="fa fa-gamepad"></i> <span class="sr-only">Example of </span>gamepad</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gavel"><i aria-hidden="true" class="fa fa-gavel"></i> <span class="sr-only">Example of </span>gavel</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cog"><i aria-hidden="true" class="fa fa-gear"></i> <span class="sr-only">Example of </span>gear <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cogs"><i aria-hidden="true" class="fa fa-gears"></i> <span class="sr-only">Example of </span>gears <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gift"><i aria-hidden="true" class="fa fa-gift"></i> <span class="sr-only">Example of </span>gift</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/glass"><i aria-hidden="true" class="fa fa-glass"></i> <span class="sr-only">Example of </span>glass</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/globe"><i aria-hidden="true" class="fa fa-globe"></i> <span class="sr-only">Example of </span>globe</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/graduation-cap"><i aria-hidden="true" class="fa fa-graduation-cap"></i> <span class="sr-only">Example of </span>graduation-cap</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/users"><i aria-hidden="true" class="fa fa-group"></i> <span class="sr-only">Example of </span>group <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-rock-o"><i aria-hidden="true" class="fa fa-hand-grab-o"></i> <span class="sr-only">Example of </span>hand-grab-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-lizard-o"><i aria-hidden="true" class="fa fa-hand-lizard-o"></i> <span class="sr-only">Example of </span>hand-lizard-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-paper-o"><i aria-hidden="true" class="fa fa-hand-paper-o"></i> <span class="sr-only">Example of </span>hand-paper-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-peace-o"><i aria-hidden="true" class="fa fa-hand-peace-o"></i> <span class="sr-only">Example of </span>hand-peace-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-pointer-o"><i aria-hidden="true" class="fa fa-hand-pointer-o"></i> <span class="sr-only">Example of </span>hand-pointer-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-rock-o"><i aria-hidden="true" class="fa fa-hand-rock-o"></i> <span class="sr-only">Example of </span>hand-rock-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-scissors-o"><i aria-hidden="true" class="fa fa-hand-scissors-o"></i> <span class="sr-only">Example of </span>hand-scissors-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-spock-o"><i aria-hidden="true" class="fa fa-hand-spock-o"></i> <span class="sr-only">Example of </span>hand-spock-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-paper-o"><i aria-hidden="true" class="fa fa-hand-stop-o"></i> <span class="sr-only">Example of </span>hand-stop-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/deaf"><i aria-hidden="true" class="fa fa-hard-of-hearing"></i> <span class="sr-only">Example of </span>hard-of-hearing <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hashtag"><i aria-hidden="true" class="fa fa-hashtag"></i> <span class="sr-only">Example of </span>hashtag</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hdd-o"><i aria-hidden="true" class="fa fa-hdd-o"></i> <span class="sr-only">Example of </span>hdd-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/headphones"><i aria-hidden="true" class="fa fa-headphones"></i> <span class="sr-only">Example of </span>headphones</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/heart"><i aria-hidden="true" class="fa fa-heart"></i> <span class="sr-only">Example of </span>heart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/heart-o"><i aria-hidden="true" class="fa fa-heart-o"></i> <span class="sr-only">Example of </span>heart-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/heartbeat"><i aria-hidden="true" class="fa fa-heartbeat"></i> <span class="sr-only">Example of </span>heartbeat</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/history"><i aria-hidden="true" class="fa fa-history"></i> <span class="sr-only">Example of </span>history</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/home"><i aria-hidden="true" class="fa fa-home"></i> <span class="sr-only">Example of </span>home</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bed"><i aria-hidden="true" class="fa fa-hotel"></i> <span class="sr-only">Example of </span>hotel <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass"><i aria-hidden="true" class="fa fa-hourglass"></i> <span class="sr-only">Example of </span>hourglass</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass-start"><i aria-hidden="true" class="fa fa-hourglass-1"></i> <span class="sr-only">Example of </span>hourglass-1 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass-half"><i aria-hidden="true" class="fa fa-hourglass-2"></i> <span class="sr-only">Example of </span>hourglass-2 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass-end"><i aria-hidden="true" class="fa fa-hourglass-3"></i> <span class="sr-only">Example of </span>hourglass-3 <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass-end"><i aria-hidden="true" class="fa fa-hourglass-end"></i> <span class="sr-only">Example of </span>hourglass-end</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass-half"><i aria-hidden="true" class="fa fa-hourglass-half"></i> <span class="sr-only">Example of </span>hourglass-half</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass-o"><i aria-hidden="true" class="fa fa-hourglass-o"></i> <span class="sr-only">Example of </span>hourglass-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hourglass-start"><i aria-hidden="true" class="fa fa-hourglass-start"></i> <span class="sr-only">Example of </span>hourglass-start</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/i-cursor"><i aria-hidden="true" class="fa fa-i-cursor"></i> <span class="sr-only">Example of </span>i-cursor</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/picture-o"><i aria-hidden="true" class="fa fa-image"></i> <span class="sr-only">Example of </span>image <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/inbox"><i aria-hidden="true" class="fa fa-inbox"></i> <span class="sr-only">Example of </span>inbox</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/industry"><i aria-hidden="true" class="fa fa-industry"></i> <span class="sr-only">Example of </span>industry</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/info"><i aria-hidden="true" class="fa fa-info"></i> <span class="sr-only">Example of </span>info</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/info-circle"><i aria-hidden="true" class="fa fa-info-circle"></i> <span class="sr-only">Example of </span>info-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/university"><i aria-hidden="true" class="fa fa-institution"></i> <span class="sr-only">Example of </span>institution <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/key"><i aria-hidden="true" class="fa fa-key"></i> <span class="sr-only">Example of </span>key</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/keyboard-o"><i aria-hidden="true" class="fa fa-keyboard-o"></i> <span class="sr-only">Example of </span>keyboard-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/language"><i aria-hidden="true" class="fa fa-language"></i> <span class="sr-only">Example of </span>language</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/laptop"><i aria-hidden="true" class="fa fa-laptop"></i> <span class="sr-only">Example of </span>laptop</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/leaf"><i aria-hidden="true" class="fa fa-leaf"></i> <span class="sr-only">Example of </span>leaf</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gavel"><i aria-hidden="true" class="fa fa-legal"></i> <span class="sr-only">Example of </span>legal <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/lemon-o"><i aria-hidden="true" class="fa fa-lemon-o"></i> <span class="sr-only">Example of </span>lemon-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/level-down"><i aria-hidden="true" class="fa fa-level-down"></i> <span class="sr-only">Example of </span>level-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/level-up"><i aria-hidden="true" class="fa fa-level-up"></i> <span class="sr-only">Example of </span>level-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/life-ring"><i aria-hidden="true" class="fa fa-life-bouy"></i> <span class="sr-only">Example of </span>life-bouy <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/life-ring"><i aria-hidden="true" class="fa fa-life-buoy"></i> <span class="sr-only">Example of </span>life-buoy <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/life-ring"><i aria-hidden="true" class="fa fa-life-ring"></i> <span class="sr-only">Example of </span>life-ring</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/life-ring"><i aria-hidden="true" class="fa fa-life-saver"></i> <span class="sr-only">Example of </span>life-saver <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/lightbulb-o"><i aria-hidden="true" class="fa fa-lightbulb-o"></i> <span class="sr-only">Example of </span>lightbulb-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/line-chart"><i aria-hidden="true" class="fa fa-line-chart"></i> <span class="sr-only">Example of </span>line-chart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/location-arrow"><i aria-hidden="true" class="fa fa-location-arrow"></i> <span class="sr-only">Example of </span>location-arrow</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/lock"><i aria-hidden="true" class="fa fa-lock"></i> <span class="sr-only">Example of </span>lock</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/low-vision"><i aria-hidden="true" class="fa fa-low-vision"></i> <span class="sr-only">Example of </span>low-vision</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/magic"><i aria-hidden="true" class="fa fa-magic"></i> <span class="sr-only">Example of </span>magic</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/magnet"><i aria-hidden="true" class="fa fa-magnet"></i> <span class="sr-only">Example of </span>magnet</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share"><i aria-hidden="true" class="fa fa-mail-forward"></i> <span class="sr-only">Example of </span>mail-forward <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/reply"><i aria-hidden="true" class="fa fa-mail-reply"></i> <span class="sr-only">Example of </span>mail-reply <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/reply-all"><i aria-hidden="true" class="fa fa-mail-reply-all"></i> <span class="sr-only">Example of </span>mail-reply-all <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/male"><i aria-hidden="true" class="fa fa-male"></i> <span class="sr-only">Example of </span>male</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/map"><i aria-hidden="true" class="fa fa-map"></i> <span class="sr-only">Example of </span>map</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/map-marker"><i aria-hidden="true" class="fa fa-map-marker"></i> <span class="sr-only">Example of </span>map-marker</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/map-o"><i aria-hidden="true" class="fa fa-map-o"></i> <span class="sr-only">Example of </span>map-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/map-pin"><i aria-hidden="true" class="fa fa-map-pin"></i> <span class="sr-only">Example of </span>map-pin</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/map-signs"><i aria-hidden="true" class="fa fa-map-signs"></i> <span class="sr-only">Example of </span>map-signs</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/meh-o"><i aria-hidden="true" class="fa fa-meh-o"></i> <span class="sr-only">Example of </span>meh-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/microphone"><i aria-hidden="true" class="fa fa-microphone"></i> <span class="sr-only">Example of </span>microphone</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/microphone-slash"><i aria-hidden="true" class="fa fa-microphone-slash"></i> <span class="sr-only">Example of </span>microphone-slash</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/minus"><i aria-hidden="true" class="fa fa-minus"></i> <span class="sr-only">Example of </span>minus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/minus-circle"><i aria-hidden="true" class="fa fa-minus-circle"></i> <span class="sr-only">Example of </span>minus-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/minus-square"><i aria-hidden="true" class="fa fa-minus-square"></i> <span class="sr-only">Example of </span>minus-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/minus-square-o"><i aria-hidden="true" class="fa fa-minus-square-o"></i> <span class="sr-only">Example of </span>minus-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mobile"><i aria-hidden="true" class="fa fa-mobile"></i> <span class="sr-only">Example of </span>mobile</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mobile"><i aria-hidden="true" class="fa fa-mobile-phone"></i> <span class="sr-only">Example of </span>mobile-phone <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/money"><i aria-hidden="true" class="fa fa-money"></i> <span class="sr-only">Example of </span>money</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/moon-o"><i aria-hidden="true" class="fa fa-moon-o"></i> <span class="sr-only">Example of </span>moon-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/graduation-cap"><i aria-hidden="true" class="fa fa-mortar-board"></i> <span class="sr-only">Example of </span>mortar-board <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/motorcycle"><i aria-hidden="true" class="fa fa-motorcycle"></i> <span class="sr-only">Example of </span>motorcycle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mouse-pointer"><i aria-hidden="true" class="fa fa-mouse-pointer"></i> <span class="sr-only">Example of </span>mouse-pointer</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/music"><i aria-hidden="true" class="fa fa-music"></i> <span class="sr-only">Example of </span>music</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bars"><i aria-hidden="true" class="fa fa-navicon"></i> <span class="sr-only">Example of </span>navicon <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/newspaper-o"><i aria-hidden="true" class="fa fa-newspaper-o"></i> <span class="sr-only">Example of </span>newspaper-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/object-group"><i aria-hidden="true" class="fa fa-object-group"></i> <span class="sr-only">Example of </span>object-group</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/object-ungroup"><i aria-hidden="true" class="fa fa-object-ungroup"></i> <span class="sr-only">Example of </span>object-ungroup</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paint-brush"><i aria-hidden="true" class="fa fa-paint-brush"></i> <span class="sr-only">Example of </span>paint-brush</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paper-plane"><i aria-hidden="true" class="fa fa-paper-plane"></i> <span class="sr-only">Example of </span>paper-plane</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paper-plane-o"><i aria-hidden="true" class="fa fa-paper-plane-o"></i> <span class="sr-only">Example of </span>paper-plane-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paw"><i aria-hidden="true" class="fa fa-paw"></i> <span class="sr-only">Example of </span>paw</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pencil"><i aria-hidden="true" class="fa fa-pencil"></i> <span class="sr-only">Example of </span>pencil</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pencil-square"><i aria-hidden="true" class="fa fa-pencil-square"></i> <span class="sr-only">Example of </span>pencil-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pencil-square-o"><i aria-hidden="true" class="fa fa-pencil-square-o"></i> <span class="sr-only">Example of </span>pencil-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/percent"><i aria-hidden="true" class="fa fa-percent"></i> <span class="sr-only">Example of </span>percent</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/phone"><i aria-hidden="true" class="fa fa-phone"></i> <span class="sr-only">Example of </span>phone</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/phone-square"><i aria-hidden="true" class="fa fa-phone-square"></i> <span class="sr-only">Example of </span>phone-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/picture-o"><i aria-hidden="true" class="fa fa-photo"></i> <span class="sr-only">Example of </span>photo <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/picture-o"><i aria-hidden="true" class="fa fa-picture-o"></i> <span class="sr-only">Example of </span>picture-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pie-chart"><i aria-hidden="true" class="fa fa-pie-chart"></i> <span class="sr-only">Example of </span>pie-chart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plane"><i aria-hidden="true" class="fa fa-plane"></i> <span class="sr-only">Example of </span>plane</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plug"><i aria-hidden="true" class="fa fa-plug"></i> <span class="sr-only">Example of </span>plug</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plus"><i aria-hidden="true" class="fa fa-plus"></i> <span class="sr-only">Example of </span>plus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plus-circle"><i aria-hidden="true" class="fa fa-plus-circle"></i> <span class="sr-only">Example of </span>plus-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plus-square"><i aria-hidden="true" class="fa fa-plus-square"></i> <span class="sr-only">Example of </span>plus-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plus-square-o"><i aria-hidden="true" class="fa fa-plus-square-o"></i> <span class="sr-only">Example of </span>plus-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/power-off"><i aria-hidden="true" class="fa fa-power-off"></i> <span class="sr-only">Example of </span>power-off</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/print"><i aria-hidden="true" class="fa fa-print"></i> <span class="sr-only">Example of </span>print</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/puzzle-piece"><i aria-hidden="true" class="fa fa-puzzle-piece"></i> <span class="sr-only">Example of </span>puzzle-piece</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/qrcode"><i aria-hidden="true" class="fa fa-qrcode"></i> <span class="sr-only">Example of </span>qrcode</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/question"><i aria-hidden="true" class="fa fa-question"></i> <span class="sr-only">Example of </span>question</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/question-circle"><i aria-hidden="true" class="fa fa-question-circle"></i> <span class="sr-only">Example of </span>question-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/question-circle-o"><i aria-hidden="true" class="fa fa-question-circle-o"></i> <span class="sr-only">Example of </span>question-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/quote-left"><i aria-hidden="true" class="fa fa-quote-left"></i> <span class="sr-only">Example of </span>quote-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/quote-right"><i aria-hidden="true" class="fa fa-quote-right"></i> <span class="sr-only">Example of </span>quote-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/random"><i aria-hidden="true" class="fa fa-random"></i> <span class="sr-only">Example of </span>random</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/recycle"><i aria-hidden="true" class="fa fa-recycle"></i> <span class="sr-only">Example of </span>recycle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/refresh"><i aria-hidden="true" class="fa fa-refresh"></i> <span class="sr-only">Example of </span>refresh</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/registered"><i aria-hidden="true" class="fa fa-registered"></i> <span class="sr-only">Example of </span>registered</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/times"><i aria-hidden="true" class="fa fa-remove"></i> <span class="sr-only">Example of </span>remove <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bars"><i aria-hidden="true" class="fa fa-reorder"></i> <span class="sr-only">Example of </span>reorder <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/reply"><i aria-hidden="true" class="fa fa-reply"></i> <span class="sr-only">Example of </span>reply</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/reply-all"><i aria-hidden="true" class="fa fa-reply-all"></i> <span class="sr-only">Example of </span>reply-all</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/retweet"><i aria-hidden="true" class="fa fa-retweet"></i> <span class="sr-only">Example of </span>retweet</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/road"><i aria-hidden="true" class="fa fa-road"></i> <span class="sr-only">Example of </span>road</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rocket"><i aria-hidden="true" class="fa fa-rocket"></i> <span class="sr-only">Example of </span>rocket</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rss"><i aria-hidden="true" class="fa fa-rss"></i> <span class="sr-only">Example of </span>rss</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rss-square"><i aria-hidden="true" class="fa fa-rss-square"></i> <span class="sr-only">Example of </span>rss-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/search"><i aria-hidden="true" class="fa fa-search"></i> <span class="sr-only">Example of </span>search</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/search-minus"><i aria-hidden="true" class="fa fa-search-minus"></i> <span class="sr-only">Example of </span>search-minus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/search-plus"><i aria-hidden="true" class="fa fa-search-plus"></i> <span class="sr-only">Example of </span>search-plus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paper-plane"><i aria-hidden="true" class="fa fa-send"></i> <span class="sr-only">Example of </span>send <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paper-plane-o"><i aria-hidden="true" class="fa fa-send-o"></i> <span class="sr-only">Example of </span>send-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/server"><i aria-hidden="true" class="fa fa-server"></i> <span class="sr-only">Example of </span>server</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share"><i aria-hidden="true" class="fa fa-share"></i> <span class="sr-only">Example of </span>share</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share-alt"><i aria-hidden="true" class="fa fa-share-alt"></i> <span class="sr-only">Example of </span>share-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share-alt-square"><i aria-hidden="true" class="fa fa-share-alt-square"></i> <span class="sr-only">Example of </span>share-alt-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share-square"><i aria-hidden="true" class="fa fa-share-square"></i> <span class="sr-only">Example of </span>share-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share-square-o"><i aria-hidden="true" class="fa fa-share-square-o"></i> <span class="sr-only">Example of </span>share-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/shield"><i aria-hidden="true" class="fa fa-shield"></i> <span class="sr-only">Example of </span>shield</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ship"><i aria-hidden="true" class="fa fa-ship"></i> <span class="sr-only">Example of </span>ship</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/shopping-bag"><i aria-hidden="true" class="fa fa-shopping-bag"></i> <span class="sr-only">Example of </span>shopping-bag</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/shopping-basket"><i aria-hidden="true" class="fa fa-shopping-basket"></i> <span class="sr-only">Example of </span>shopping-basket</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/shopping-cart"><i aria-hidden="true" class="fa fa-shopping-cart"></i> <span class="sr-only">Example of </span>shopping-cart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sign-in"><i aria-hidden="true" class="fa fa-sign-in"></i> <span class="sr-only">Example of </span>sign-in</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sign-language"><i aria-hidden="true" class="fa fa-sign-language"></i> <span class="sr-only">Example of </span>sign-language</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sign-out"><i aria-hidden="true" class="fa fa-sign-out"></i> <span class="sr-only">Example of </span>sign-out</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/signal"><i aria-hidden="true" class="fa fa-signal"></i> <span class="sr-only">Example of </span>signal</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sign-language"><i aria-hidden="true" class="fa fa-signing"></i> <span class="sr-only">Example of </span>signing <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sitemap"><i aria-hidden="true" class="fa fa-sitemap"></i> <span class="sr-only">Example of </span>sitemap</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sliders"><i aria-hidden="true" class="fa fa-sliders"></i> <span class="sr-only">Example of </span>sliders</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/smile-o"><i aria-hidden="true" class="fa fa-smile-o"></i> <span class="sr-only">Example of </span>smile-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/futbol-o"><i aria-hidden="true" class="fa fa-soccer-ball-o"></i> <span class="sr-only">Example of </span>soccer-ball-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort"><i aria-hidden="true" class="fa fa-sort"></i> <span class="sr-only">Example of </span>sort</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-alpha-asc"><i aria-hidden="true" class="fa fa-sort-alpha-asc"></i> <span class="sr-only">Example of </span>sort-alpha-asc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-alpha-desc"><i aria-hidden="true" class="fa fa-sort-alpha-desc"></i> <span class="sr-only">Example of </span>sort-alpha-desc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-amount-asc"><i aria-hidden="true" class="fa fa-sort-amount-asc"></i> <span class="sr-only">Example of </span>sort-amount-asc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-amount-desc"><i aria-hidden="true" class="fa fa-sort-amount-desc"></i> <span class="sr-only">Example of </span>sort-amount-desc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-asc"><i aria-hidden="true" class="fa fa-sort-asc"></i> <span class="sr-only">Example of </span>sort-asc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-desc"><i aria-hidden="true" class="fa fa-sort-desc"></i> <span class="sr-only">Example of </span>sort-desc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-desc"><i aria-hidden="true" class="fa fa-sort-down"></i> <span class="sr-only">Example of </span>sort-down <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-numeric-asc"><i aria-hidden="true" class="fa fa-sort-numeric-asc"></i> <span class="sr-only">Example of </span>sort-numeric-asc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-numeric-desc"><i aria-hidden="true" class="fa fa-sort-numeric-desc"></i> <span class="sr-only">Example of </span>sort-numeric-desc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort-asc"><i aria-hidden="true" class="fa fa-sort-up"></i> <span class="sr-only">Example of </span>sort-up <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/space-shuttle"><i aria-hidden="true" class="fa fa-space-shuttle"></i> <span class="sr-only">Example of </span>space-shuttle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/spinner"><i aria-hidden="true" class="fa fa-spinner"></i> <span class="sr-only">Example of </span>spinner</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/spoon"><i aria-hidden="true" class="fa fa-spoon"></i> <span class="sr-only">Example of </span>spoon</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/square"><i aria-hidden="true" class="fa fa-square"></i> <span class="sr-only">Example of </span>square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/square-o"><i aria-hidden="true" class="fa fa-square-o"></i> <span class="sr-only">Example of </span>square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/star"><i aria-hidden="true" class="fa fa-star"></i> <span class="sr-only">Example of </span>star</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/star-half"><i aria-hidden="true" class="fa fa-star-half"></i> <span class="sr-only">Example of </span>star-half</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/star-half-o"><i aria-hidden="true" class="fa fa-star-half-empty"></i> <span class="sr-only">Example of </span>star-half-empty <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/star-half-o"><i aria-hidden="true" class="fa fa-star-half-full"></i> <span class="sr-only">Example of </span>star-half-full <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/star-half-o"><i aria-hidden="true" class="fa fa-star-half-o"></i> <span class="sr-only">Example of </span>star-half-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/star-o"><i aria-hidden="true" class="fa fa-star-o"></i> <span class="sr-only">Example of </span>star-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sticky-note"><i aria-hidden="true" class="fa fa-sticky-note"></i> <span class="sr-only">Example of </span>sticky-note</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sticky-note-o"><i aria-hidden="true" class="fa fa-sticky-note-o"></i> <span class="sr-only">Example of </span>sticky-note-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/street-view"><i aria-hidden="true" class="fa fa-street-view"></i> <span class="sr-only">Example of </span>street-view</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/suitcase"><i aria-hidden="true" class="fa fa-suitcase"></i> <span class="sr-only">Example of </span>suitcase</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sun-o"><i aria-hidden="true" class="fa fa-sun-o"></i> <span class="sr-only">Example of </span>sun-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/life-ring"><i aria-hidden="true" class="fa fa-support"></i> <span class="sr-only">Example of </span>support <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tablet"><i aria-hidden="true" class="fa fa-tablet"></i> <span class="sr-only">Example of </span>tablet</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tachometer"><i aria-hidden="true" class="fa fa-tachometer"></i> <span class="sr-only">Example of </span>tachometer</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tag"><i aria-hidden="true" class="fa fa-tag"></i> <span class="sr-only">Example of </span>tag</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tags"><i aria-hidden="true" class="fa fa-tags"></i> <span class="sr-only">Example of </span>tags</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tasks"><i aria-hidden="true" class="fa fa-tasks"></i> <span class="sr-only">Example of </span>tasks</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/taxi"><i aria-hidden="true" class="fa fa-taxi"></i> <span class="sr-only">Example of </span>taxi</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/television"><i aria-hidden="true" class="fa fa-television"></i> <span class="sr-only">Example of </span>television</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/terminal"><i aria-hidden="true" class="fa fa-terminal"></i> <span class="sr-only">Example of </span>terminal</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumb-tack"><i aria-hidden="true" class="fa fa-thumb-tack"></i> <span class="sr-only">Example of </span>thumb-tack</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-down"><i aria-hidden="true" class="fa fa-thumbs-down"></i> <span class="sr-only">Example of </span>thumbs-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-o-down"><i aria-hidden="true" class="fa fa-thumbs-o-down"></i> <span class="sr-only">Example of </span>thumbs-o-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-o-up"><i aria-hidden="true" class="fa fa-thumbs-o-up"></i> <span class="sr-only">Example of </span>thumbs-o-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-up"><i aria-hidden="true" class="fa fa-thumbs-up"></i> <span class="sr-only">Example of </span>thumbs-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ticket"><i aria-hidden="true" class="fa fa-ticket"></i> <span class="sr-only">Example of </span>ticket</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/times"><i aria-hidden="true" class="fa fa-times"></i> <span class="sr-only">Example of </span>times</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/times-circle"><i aria-hidden="true" class="fa fa-times-circle"></i> <span class="sr-only">Example of </span>times-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/times-circle-o"><i aria-hidden="true" class="fa fa-times-circle-o"></i> <span class="sr-only">Example of </span>times-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tint"><i aria-hidden="true" class="fa fa-tint"></i> <span class="sr-only">Example of </span>tint</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-down"><i aria-hidden="true" class="fa fa-toggle-down"></i> <span class="sr-only">Example of </span>toggle-down <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-left"><i aria-hidden="true" class="fa fa-toggle-left"></i> <span class="sr-only">Example of </span>toggle-left <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/toggle-off"><i aria-hidden="true" class="fa fa-toggle-off"></i> <span class="sr-only">Example of </span>toggle-off</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/toggle-on"><i aria-hidden="true" class="fa fa-toggle-on"></i> <span class="sr-only">Example of </span>toggle-on</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-right"><i aria-hidden="true" class="fa fa-toggle-right"></i> <span class="sr-only">Example of </span>toggle-right <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-up"><i aria-hidden="true" class="fa fa-toggle-up"></i> <span class="sr-only">Example of </span>toggle-up <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/trademark"><i aria-hidden="true" class="fa fa-trademark"></i> <span class="sr-only">Example of </span>trademark</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/trash"><i aria-hidden="true" class="fa fa-trash"></i> <span class="sr-only">Example of </span>trash</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/trash-o"><i aria-hidden="true" class="fa fa-trash-o"></i> <span class="sr-only">Example of </span>trash-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tree"><i aria-hidden="true" class="fa fa-tree"></i> <span class="sr-only">Example of </span>tree</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/trophy"><i aria-hidden="true" class="fa fa-trophy"></i> <span class="sr-only">Example of </span>trophy</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/truck"><i aria-hidden="true" class="fa fa-truck"></i> <span class="sr-only">Example of </span>truck</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tty"><i aria-hidden="true" class="fa fa-tty"></i> <span class="sr-only">Example of </span>tty</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/television"><i aria-hidden="true" class="fa fa-tv"></i> <span class="sr-only">Example of </span>tv <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/umbrella"><i aria-hidden="true" class="fa fa-umbrella"></i> <span class="sr-only">Example of </span>umbrella</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/universal-access"><i aria-hidden="true" class="fa fa-universal-access"></i> <span class="sr-only">Example of </span>universal-access</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/university"><i aria-hidden="true" class="fa fa-university"></i> <span class="sr-only">Example of </span>university</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/unlock"><i aria-hidden="true" class="fa fa-unlock"></i> <span class="sr-only">Example of </span>unlock</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/unlock-alt"><i aria-hidden="true" class="fa fa-unlock-alt"></i> <span class="sr-only">Example of </span>unlock-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sort"><i aria-hidden="true" class="fa fa-unsorted"></i> <span class="sr-only">Example of </span>unsorted <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/upload"><i aria-hidden="true" class="fa fa-upload"></i> <span class="sr-only">Example of </span>upload</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/user"><i aria-hidden="true" class="fa fa-user"></i> <span class="sr-only">Example of </span>user</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/user-plus"><i aria-hidden="true" class="fa fa-user-plus"></i> <span class="sr-only">Example of </span>user-plus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/user-secret"><i aria-hidden="true" class="fa fa-user-secret"></i> <span class="sr-only">Example of </span>user-secret</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/user-times"><i aria-hidden="true" class="fa fa-user-times"></i> <span class="sr-only">Example of </span>user-times</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/users"><i aria-hidden="true" class="fa fa-users"></i> <span class="sr-only">Example of </span>users</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/video-camera"><i aria-hidden="true" class="fa fa-video-camera"></i> <span class="sr-only">Example of </span>video-camera</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/volume-control-phone"><i aria-hidden="true" class="fa fa-volume-control-phone"></i> <span class="sr-only">Example of </span>volume-control-phone</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/volume-down"><i aria-hidden="true" class="fa fa-volume-down"></i> <span class="sr-only">Example of </span>volume-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/volume-off"><i aria-hidden="true" class="fa fa-volume-off"></i> <span class="sr-only">Example of </span>volume-off</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/volume-up"><i aria-hidden="true" class="fa fa-volume-up"></i> <span class="sr-only">Example of </span>volume-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/exclamation-triangle"><i aria-hidden="true" class="fa fa-warning"></i> <span class="sr-only">Example of </span>warning <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair"><i aria-hidden="true" class="fa fa-wheelchair"></i> <span class="sr-only">Example of </span>wheelchair</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair-alt"><i aria-hidden="true" class="fa fa-wheelchair-alt"></i> <span class="sr-only">Example of </span>wheelchair-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wifi"><i aria-hidden="true" class="fa fa-wifi"></i> <span class="sr-only">Example of </span>wifi</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wrench"><i aria-hidden="true" class="fa fa-wrench"></i> <span class="sr-only">Example of </span>wrench</a></div>
    
  </div>

</section>

    <section id="accessibility">
  <h2 class="page-header">Accessibility Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/american-sign-language-interpreting"><i aria-hidden="true" class="fa fa-american-sign-language-interpreting"></i> <span class="sr-only">Example of </span>american-sign-language-interpreting</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/american-sign-language-interpreting"><i aria-hidden="true" class="fa fa-asl-interpreting"></i> <span class="sr-only">Example of </span>asl-interpreting <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/assistive-listening-systems"><i aria-hidden="true" class="fa fa-assistive-listening-systems"></i> <span class="sr-only">Example of </span>assistive-listening-systems</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/audio-description"><i aria-hidden="true" class="fa fa-audio-description"></i> <span class="sr-only">Example of </span>audio-description</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/blind"><i aria-hidden="true" class="fa fa-blind"></i> <span class="sr-only">Example of </span>blind</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/braille"><i aria-hidden="true" class="fa fa-braille"></i> <span class="sr-only">Example of </span>braille</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc"><i aria-hidden="true" class="fa fa-cc"></i> <span class="sr-only">Example of </span>cc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/deaf"><i aria-hidden="true" class="fa fa-deaf"></i> <span class="sr-only">Example of </span>deaf</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/deaf"><i aria-hidden="true" class="fa fa-deafness"></i> <span class="sr-only">Example of </span>deafness <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/deaf"><i aria-hidden="true" class="fa fa-hard-of-hearing"></i> <span class="sr-only">Example of </span>hard-of-hearing <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/low-vision"><i aria-hidden="true" class="fa fa-low-vision"></i> <span class="sr-only">Example of </span>low-vision</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/question-circle-o"><i aria-hidden="true" class="fa fa-question-circle-o"></i> <span class="sr-only">Example of </span>question-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sign-language"><i aria-hidden="true" class="fa fa-sign-language"></i> <span class="sr-only">Example of </span>sign-language</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sign-language"><i aria-hidden="true" class="fa fa-signing"></i> <span class="sr-only">Example of </span>signing <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tty"><i aria-hidden="true" class="fa fa-tty"></i> <span class="sr-only">Example of </span>tty</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/universal-access"><i aria-hidden="true" class="fa fa-universal-access"></i> <span class="sr-only">Example of </span>universal-access</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/volume-control-phone"><i aria-hidden="true" class="fa fa-volume-control-phone"></i> <span class="sr-only">Example of </span>volume-control-phone</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair"><i aria-hidden="true" class="fa fa-wheelchair"></i> <span class="sr-only">Example of </span>wheelchair</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair-alt"><i aria-hidden="true" class="fa fa-wheelchair-alt"></i> <span class="sr-only">Example of </span>wheelchair-alt</a></div>
    
  </div>

</section>

    <section id="hand">
  <h2 class="page-header">Hand Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-rock-o"><i aria-hidden="true" class="fa fa-hand-grab-o"></i> <span class="sr-only">Example of </span>hand-grab-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-lizard-o"><i aria-hidden="true" class="fa fa-hand-lizard-o"></i> <span class="sr-only">Example of </span>hand-lizard-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-down"><i aria-hidden="true" class="fa fa-hand-o-down"></i> <span class="sr-only">Example of </span>hand-o-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-left"><i aria-hidden="true" class="fa fa-hand-o-left"></i> <span class="sr-only">Example of </span>hand-o-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-right"><i aria-hidden="true" class="fa fa-hand-o-right"></i> <span class="sr-only">Example of </span>hand-o-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-up"><i aria-hidden="true" class="fa fa-hand-o-up"></i> <span class="sr-only">Example of </span>hand-o-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-paper-o"><i aria-hidden="true" class="fa fa-hand-paper-o"></i> <span class="sr-only">Example of </span>hand-paper-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-peace-o"><i aria-hidden="true" class="fa fa-hand-peace-o"></i> <span class="sr-only">Example of </span>hand-peace-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-pointer-o"><i aria-hidden="true" class="fa fa-hand-pointer-o"></i> <span class="sr-only">Example of </span>hand-pointer-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-rock-o"><i aria-hidden="true" class="fa fa-hand-rock-o"></i> <span class="sr-only">Example of </span>hand-rock-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-scissors-o"><i aria-hidden="true" class="fa fa-hand-scissors-o"></i> <span class="sr-only">Example of </span>hand-scissors-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-spock-o"><i aria-hidden="true" class="fa fa-hand-spock-o"></i> <span class="sr-only">Example of </span>hand-spock-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-paper-o"><i aria-hidden="true" class="fa fa-hand-stop-o"></i> <span class="sr-only">Example of </span>hand-stop-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-down"><i aria-hidden="true" class="fa fa-thumbs-down"></i> <span class="sr-only">Example of </span>thumbs-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-o-down"><i aria-hidden="true" class="fa fa-thumbs-o-down"></i> <span class="sr-only">Example of </span>thumbs-o-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-o-up"><i aria-hidden="true" class="fa fa-thumbs-o-up"></i> <span class="sr-only">Example of </span>thumbs-o-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/thumbs-up"><i aria-hidden="true" class="fa fa-thumbs-up"></i> <span class="sr-only">Example of </span>thumbs-up</a></div>
    
  </div>

</section>

    <section id="transportation">
  <h2 class="page-header">Transportation Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ambulance"><i aria-hidden="true" class="fa fa-ambulance"></i> <span class="sr-only">Example of </span>ambulance</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/car"><i aria-hidden="true" class="fa fa-automobile"></i> <span class="sr-only">Example of </span>automobile <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bicycle"><i aria-hidden="true" class="fa fa-bicycle"></i> <span class="sr-only">Example of </span>bicycle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bus"><i aria-hidden="true" class="fa fa-bus"></i> <span class="sr-only">Example of </span>bus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/taxi"><i aria-hidden="true" class="fa fa-cab"></i> <span class="sr-only">Example of </span>cab <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/car"><i aria-hidden="true" class="fa fa-car"></i> <span class="sr-only">Example of </span>car</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fighter-jet"><i aria-hidden="true" class="fa fa-fighter-jet"></i> <span class="sr-only">Example of </span>fighter-jet</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/motorcycle"><i aria-hidden="true" class="fa fa-motorcycle"></i> <span class="sr-only">Example of </span>motorcycle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plane"><i aria-hidden="true" class="fa fa-plane"></i> <span class="sr-only">Example of </span>plane</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rocket"><i aria-hidden="true" class="fa fa-rocket"></i> <span class="sr-only">Example of </span>rocket</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ship"><i aria-hidden="true" class="fa fa-ship"></i> <span class="sr-only">Example of </span>ship</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/space-shuttle"><i aria-hidden="true" class="fa fa-space-shuttle"></i> <span class="sr-only">Example of </span>space-shuttle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/subway"><i aria-hidden="true" class="fa fa-subway"></i> <span class="sr-only">Example of </span>subway</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/taxi"><i aria-hidden="true" class="fa fa-taxi"></i> <span class="sr-only">Example of </span>taxi</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/train"><i aria-hidden="true" class="fa fa-train"></i> <span class="sr-only">Example of </span>train</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/truck"><i aria-hidden="true" class="fa fa-truck"></i> <span class="sr-only">Example of </span>truck</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair"><i aria-hidden="true" class="fa fa-wheelchair"></i> <span class="sr-only">Example of </span>wheelchair</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair-alt"><i aria-hidden="true" class="fa fa-wheelchair-alt"></i> <span class="sr-only">Example of </span>wheelchair-alt</a></div>
    
  </div>

</section>

    <section id="gender">
  <h2 class="page-header">Gender Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/genderless"><i aria-hidden="true" class="fa fa-genderless"></i> <span class="sr-only">Example of </span>genderless</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/transgender"><i aria-hidden="true" class="fa fa-intersex"></i> <span class="sr-only">Example of </span>intersex <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mars"><i aria-hidden="true" class="fa fa-mars"></i> <span class="sr-only">Example of </span>mars</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mars-double"><i aria-hidden="true" class="fa fa-mars-double"></i> <span class="sr-only">Example of </span>mars-double</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mars-stroke"><i aria-hidden="true" class="fa fa-mars-stroke"></i> <span class="sr-only">Example of </span>mars-stroke</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mars-stroke-h"><i aria-hidden="true" class="fa fa-mars-stroke-h"></i> <span class="sr-only">Example of </span>mars-stroke-h</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mars-stroke-v"><i aria-hidden="true" class="fa fa-mars-stroke-v"></i> <span class="sr-only">Example of </span>mars-stroke-v</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mercury"><i aria-hidden="true" class="fa fa-mercury"></i> <span class="sr-only">Example of </span>mercury</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/neuter"><i aria-hidden="true" class="fa fa-neuter"></i> <span class="sr-only">Example of </span>neuter</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/transgender"><i aria-hidden="true" class="fa fa-transgender"></i> <span class="sr-only">Example of </span>transgender</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/transgender-alt"><i aria-hidden="true" class="fa fa-transgender-alt"></i> <span class="sr-only">Example of </span>transgender-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/venus"><i aria-hidden="true" class="fa fa-venus"></i> <span class="sr-only">Example of </span>venus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/venus-double"><i aria-hidden="true" class="fa fa-venus-double"></i> <span class="sr-only">Example of </span>venus-double</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/venus-mars"><i aria-hidden="true" class="fa fa-venus-mars"></i> <span class="sr-only">Example of </span>venus-mars</a></div>
    
  </div>

</section>

    <section id="file-type">
  <h2 class="page-header">File Type Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file"><i aria-hidden="true" class="fa fa-file"></i> <span class="sr-only">Example of </span>file</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-archive-o"><i aria-hidden="true" class="fa fa-file-archive-o"></i> <span class="sr-only">Example of </span>file-archive-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-audio-o"><i aria-hidden="true" class="fa fa-file-audio-o"></i> <span class="sr-only">Example of </span>file-audio-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-code-o"><i aria-hidden="true" class="fa fa-file-code-o"></i> <span class="sr-only">Example of </span>file-code-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-excel-o"><i aria-hidden="true" class="fa fa-file-excel-o"></i> <span class="sr-only">Example of </span>file-excel-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-image-o"><i aria-hidden="true" class="fa fa-file-image-o"></i> <span class="sr-only">Example of </span>file-image-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-video-o"><i aria-hidden="true" class="fa fa-file-movie-o"></i> <span class="sr-only">Example of </span>file-movie-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-o"><i aria-hidden="true" class="fa fa-file-o"></i> <span class="sr-only">Example of </span>file-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-pdf-o"><i aria-hidden="true" class="fa fa-file-pdf-o"></i> <span class="sr-only">Example of </span>file-pdf-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-image-o"><i aria-hidden="true" class="fa fa-file-photo-o"></i> <span class="sr-only">Example of </span>file-photo-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-image-o"><i aria-hidden="true" class="fa fa-file-picture-o"></i> <span class="sr-only">Example of </span>file-picture-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-powerpoint-o"><i aria-hidden="true" class="fa fa-file-powerpoint-o"></i> <span class="sr-only">Example of </span>file-powerpoint-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-audio-o"><i aria-hidden="true" class="fa fa-file-sound-o"></i> <span class="sr-only">Example of </span>file-sound-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-text"><i aria-hidden="true" class="fa fa-file-text"></i> <span class="sr-only">Example of </span>file-text</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-text-o"><i aria-hidden="true" class="fa fa-file-text-o"></i> <span class="sr-only">Example of </span>file-text-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-video-o"><i aria-hidden="true" class="fa fa-file-video-o"></i> <span class="sr-only">Example of </span>file-video-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-word-o"><i aria-hidden="true" class="fa fa-file-word-o"></i> <span class="sr-only">Example of </span>file-word-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-archive-o"><i aria-hidden="true" class="fa fa-file-zip-o"></i> <span class="sr-only">Example of </span>file-zip-o <span class="text-muted">(alias)</span></a></div>
    
  </div>

</section>

    <section id="spinner">
  <h2 class="page-header">Spinner Icons</h2>

  <div class="alert alert-success">
    <ul class="fa-ul">
      <li>
        <i aria-hidden="true" class="fa fa-info-circle fa-lg fa-li"></i>
        <strong class="sr-only">Note:</strong>
        These icons work great with the <code>fa-spin</code> class. Check out the
        <a class="alert-link" href="../examples/#animated">spinning icons example</a>.
      </li>
    </ul>
  </div>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/circle-o-notch"><i aria-hidden="true" class="fa fa-circle-o-notch"></i> <span class="sr-only">Example of </span>circle-o-notch</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cog"><i aria-hidden="true" class="fa fa-cog"></i> <span class="sr-only">Example of </span>cog</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cog"><i aria-hidden="true" class="fa fa-gear"></i> <span class="sr-only">Example of </span>gear <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/refresh"><i aria-hidden="true" class="fa fa-refresh"></i> <span class="sr-only">Example of </span>refresh</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/spinner"><i aria-hidden="true" class="fa fa-spinner"></i> <span class="sr-only">Example of </span>spinner</a></div>
    
  </div>
</section>

    <section id="form-control">
  <h2 class="page-header">Form Control Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/check-square"><i aria-hidden="true" class="fa fa-check-square"></i> <span class="sr-only">Example of </span>check-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/check-square-o"><i aria-hidden="true" class="fa fa-check-square-o"></i> <span class="sr-only">Example of </span>check-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/circle"><i aria-hidden="true" class="fa fa-circle"></i> <span class="sr-only">Example of </span>circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/circle-o"><i aria-hidden="true" class="fa fa-circle-o"></i> <span class="sr-only">Example of </span>circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/dot-circle-o"><i aria-hidden="true" class="fa fa-dot-circle-o"></i> <span class="sr-only">Example of </span>dot-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/minus-square"><i aria-hidden="true" class="fa fa-minus-square"></i> <span class="sr-only">Example of </span>minus-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/minus-square-o"><i aria-hidden="true" class="fa fa-minus-square-o"></i> <span class="sr-only">Example of </span>minus-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plus-square"><i aria-hidden="true" class="fa fa-plus-square"></i> <span class="sr-only">Example of </span>plus-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plus-square-o"><i aria-hidden="true" class="fa fa-plus-square-o"></i> <span class="sr-only">Example of </span>plus-square-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/square"><i aria-hidden="true" class="fa fa-square"></i> <span class="sr-only">Example of </span>square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/square-o"><i aria-hidden="true" class="fa fa-square-o"></i> <span class="sr-only">Example of </span>square-o</a></div>
    
  </div>
</section>

    <section id="payment">
  <h2 class="page-header">Payment Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-amex"><i aria-hidden="true" class="fa fa-cc-amex"></i> <span class="sr-only">Example of </span>cc-amex</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-diners-club"><i aria-hidden="true" class="fa fa-cc-diners-club"></i> <span class="sr-only">Example of </span>cc-diners-club</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-discover"><i aria-hidden="true" class="fa fa-cc-discover"></i> <span class="sr-only">Example of </span>cc-discover</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-jcb"><i aria-hidden="true" class="fa fa-cc-jcb"></i> <span class="sr-only">Example of </span>cc-jcb</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-mastercard"><i aria-hidden="true" class="fa fa-cc-mastercard"></i> <span class="sr-only">Example of </span>cc-mastercard</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-paypal"><i aria-hidden="true" class="fa fa-cc-paypal"></i> <span class="sr-only">Example of </span>cc-paypal</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-stripe"><i aria-hidden="true" class="fa fa-cc-stripe"></i> <span class="sr-only">Example of </span>cc-stripe</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-visa"><i aria-hidden="true" class="fa fa-cc-visa"></i> <span class="sr-only">Example of </span>cc-visa</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/credit-card"><i aria-hidden="true" class="fa fa-credit-card"></i> <span class="sr-only">Example of </span>credit-card</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/credit-card-alt"><i aria-hidden="true" class="fa fa-credit-card-alt"></i> <span class="sr-only">Example of </span>credit-card-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/google-wallet"><i aria-hidden="true" class="fa fa-google-wallet"></i> <span class="sr-only">Example of </span>google-wallet</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paypal"><i aria-hidden="true" class="fa fa-paypal"></i> <span class="sr-only">Example of </span>paypal</a></div>
    
  </div>

</section>

    <section id="chart">
  <h2 class="page-header">Chart Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/area-chart"><i aria-hidden="true" class="fa fa-area-chart"></i> <span class="sr-only">Example of </span>area-chart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bar-chart"><i aria-hidden="true" class="fa fa-bar-chart"></i> <span class="sr-only">Example of </span>bar-chart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bar-chart"><i aria-hidden="true" class="fa fa-bar-chart-o"></i> <span class="sr-only">Example of </span>bar-chart-o <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/line-chart"><i aria-hidden="true" class="fa fa-line-chart"></i> <span class="sr-only">Example of </span>line-chart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pie-chart"><i aria-hidden="true" class="fa fa-pie-chart"></i> <span class="sr-only">Example of </span>pie-chart</a></div>
    
  </div>

</section>

    <section id="currency">
  <h2 class="page-header">Currency Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/btc"><i aria-hidden="true" class="fa fa-bitcoin"></i> <span class="sr-only">Example of </span>bitcoin <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/btc"><i aria-hidden="true" class="fa fa-btc"></i> <span class="sr-only">Example of </span>btc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/jpy"><i aria-hidden="true" class="fa fa-cny"></i> <span class="sr-only">Example of </span>cny <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/usd"><i aria-hidden="true" class="fa fa-dollar"></i> <span class="sr-only">Example of </span>dollar <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eur"><i aria-hidden="true" class="fa fa-eur"></i> <span class="sr-only">Example of </span>eur</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eur"><i aria-hidden="true" class="fa fa-euro"></i> <span class="sr-only">Example of </span>euro <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gbp"><i aria-hidden="true" class="fa fa-gbp"></i> <span class="sr-only">Example of </span>gbp</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gg"><i aria-hidden="true" class="fa fa-gg"></i> <span class="sr-only">Example of </span>gg</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gg-circle"><i aria-hidden="true" class="fa fa-gg-circle"></i> <span class="sr-only">Example of </span>gg-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ils"><i aria-hidden="true" class="fa fa-ils"></i> <span class="sr-only">Example of </span>ils</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/inr"><i aria-hidden="true" class="fa fa-inr"></i> <span class="sr-only">Example of </span>inr</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/jpy"><i aria-hidden="true" class="fa fa-jpy"></i> <span class="sr-only">Example of </span>jpy</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/krw"><i aria-hidden="true" class="fa fa-krw"></i> <span class="sr-only">Example of </span>krw</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/money"><i aria-hidden="true" class="fa fa-money"></i> <span class="sr-only">Example of </span>money</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/jpy"><i aria-hidden="true" class="fa fa-rmb"></i> <span class="sr-only">Example of </span>rmb <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rub"><i aria-hidden="true" class="fa fa-rouble"></i> <span class="sr-only">Example of </span>rouble <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rub"><i aria-hidden="true" class="fa fa-rub"></i> <span class="sr-only">Example of </span>rub</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rub"><i aria-hidden="true" class="fa fa-ruble"></i> <span class="sr-only">Example of </span>ruble <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/inr"><i aria-hidden="true" class="fa fa-rupee"></i> <span class="sr-only">Example of </span>rupee <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ils"><i aria-hidden="true" class="fa fa-shekel"></i> <span class="sr-only">Example of </span>shekel <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ils"><i aria-hidden="true" class="fa fa-sheqel"></i> <span class="sr-only">Example of </span>sheqel <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/try"><i aria-hidden="true" class="fa fa-try"></i> <span class="sr-only">Example of </span>try</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/try"><i aria-hidden="true" class="fa fa-turkish-lira"></i> <span class="sr-only">Example of </span>turkish-lira <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/usd"><i aria-hidden="true" class="fa fa-usd"></i> <span class="sr-only">Example of </span>usd</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/krw"><i aria-hidden="true" class="fa fa-won"></i> <span class="sr-only">Example of </span>won <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/jpy"><i aria-hidden="true" class="fa fa-yen"></i> <span class="sr-only">Example of </span>yen <span class="text-muted">(alias)</span></a></div>
    
  </div>

</section>

    <section id="text-editor">
  <h2 class="page-header">Text Editor Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/align-center"><i aria-hidden="true" class="fa fa-align-center"></i> <span class="sr-only">Example of </span>align-center</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/align-justify"><i aria-hidden="true" class="fa fa-align-justify"></i> <span class="sr-only">Example of </span>align-justify</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/align-left"><i aria-hidden="true" class="fa fa-align-left"></i> <span class="sr-only">Example of </span>align-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/align-right"><i aria-hidden="true" class="fa fa-align-right"></i> <span class="sr-only">Example of </span>align-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bold"><i aria-hidden="true" class="fa fa-bold"></i> <span class="sr-only">Example of </span>bold</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/link"><i aria-hidden="true" class="fa fa-chain"></i> <span class="sr-only">Example of </span>chain <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chain-broken"><i aria-hidden="true" class="fa fa-chain-broken"></i> <span class="sr-only">Example of </span>chain-broken</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/clipboard"><i aria-hidden="true" class="fa fa-clipboard"></i> <span class="sr-only">Example of </span>clipboard</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/columns"><i aria-hidden="true" class="fa fa-columns"></i> <span class="sr-only">Example of </span>columns</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/files-o"><i aria-hidden="true" class="fa fa-copy"></i> <span class="sr-only">Example of </span>copy <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/scissors"><i aria-hidden="true" class="fa fa-cut"></i> <span class="sr-only">Example of </span>cut <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/outdent"><i aria-hidden="true" class="fa fa-dedent"></i> <span class="sr-only">Example of </span>dedent <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eraser"><i aria-hidden="true" class="fa fa-eraser"></i> <span class="sr-only">Example of </span>eraser</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file"><i aria-hidden="true" class="fa fa-file"></i> <span class="sr-only">Example of </span>file</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-o"><i aria-hidden="true" class="fa fa-file-o"></i> <span class="sr-only">Example of </span>file-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-text"><i aria-hidden="true" class="fa fa-file-text"></i> <span class="sr-only">Example of </span>file-text</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/file-text-o"><i aria-hidden="true" class="fa fa-file-text-o"></i> <span class="sr-only">Example of </span>file-text-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/files-o"><i aria-hidden="true" class="fa fa-files-o"></i> <span class="sr-only">Example of </span>files-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/floppy-o"><i aria-hidden="true" class="fa fa-floppy-o"></i> <span class="sr-only">Example of </span>floppy-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/font"><i aria-hidden="true" class="fa fa-font"></i> <span class="sr-only">Example of </span>font</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/header"><i aria-hidden="true" class="fa fa-header"></i> <span class="sr-only">Example of </span>header</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/indent"><i aria-hidden="true" class="fa fa-indent"></i> <span class="sr-only">Example of </span>indent</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/italic"><i aria-hidden="true" class="fa fa-italic"></i> <span class="sr-only">Example of </span>italic</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/link"><i aria-hidden="true" class="fa fa-link"></i> <span class="sr-only">Example of </span>link</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/list"><i aria-hidden="true" class="fa fa-list"></i> <span class="sr-only">Example of </span>list</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/list-alt"><i aria-hidden="true" class="fa fa-list-alt"></i> <span class="sr-only">Example of </span>list-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/list-ol"><i aria-hidden="true" class="fa fa-list-ol"></i> <span class="sr-only">Example of </span>list-ol</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/list-ul"><i aria-hidden="true" class="fa fa-list-ul"></i> <span class="sr-only">Example of </span>list-ul</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/outdent"><i aria-hidden="true" class="fa fa-outdent"></i> <span class="sr-only">Example of </span>outdent</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paperclip"><i aria-hidden="true" class="fa fa-paperclip"></i> <span class="sr-only">Example of </span>paperclip</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paragraph"><i aria-hidden="true" class="fa fa-paragraph"></i> <span class="sr-only">Example of </span>paragraph</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/clipboard"><i aria-hidden="true" class="fa fa-paste"></i> <span class="sr-only">Example of </span>paste <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/repeat"><i aria-hidden="true" class="fa fa-repeat"></i> <span class="sr-only">Example of </span>repeat</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/undo"><i aria-hidden="true" class="fa fa-rotate-left"></i> <span class="sr-only">Example of </span>rotate-left <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/repeat"><i aria-hidden="true" class="fa fa-rotate-right"></i> <span class="sr-only">Example of </span>rotate-right <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/floppy-o"><i aria-hidden="true" class="fa fa-save"></i> <span class="sr-only">Example of </span>save <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/scissors"><i aria-hidden="true" class="fa fa-scissors"></i> <span class="sr-only">Example of </span>scissors</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/strikethrough"><i aria-hidden="true" class="fa fa-strikethrough"></i> <span class="sr-only">Example of </span>strikethrough</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/subscript"><i aria-hidden="true" class="fa fa-subscript"></i> <span class="sr-only">Example of </span>subscript</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/superscript"><i aria-hidden="true" class="fa fa-superscript"></i> <span class="sr-only">Example of </span>superscript</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/table"><i aria-hidden="true" class="fa fa-table"></i> <span class="sr-only">Example of </span>table</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/text-height"><i aria-hidden="true" class="fa fa-text-height"></i> <span class="sr-only">Example of </span>text-height</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/text-width"><i aria-hidden="true" class="fa fa-text-width"></i> <span class="sr-only">Example of </span>text-width</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/th"><i aria-hidden="true" class="fa fa-th"></i> <span class="sr-only">Example of </span>th</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/th-large"><i aria-hidden="true" class="fa fa-th-large"></i> <span class="sr-only">Example of </span>th-large</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/th-list"><i aria-hidden="true" class="fa fa-th-list"></i> <span class="sr-only">Example of </span>th-list</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/underline"><i aria-hidden="true" class="fa fa-underline"></i> <span class="sr-only">Example of </span>underline</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/undo"><i aria-hidden="true" class="fa fa-undo"></i> <span class="sr-only">Example of </span>undo</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chain-broken"><i aria-hidden="true" class="fa fa-unlink"></i> <span class="sr-only">Example of </span>unlink <span class="text-muted">(alias)</span></a></div>
    
  </div>

</section>

    <section id="directional">
  <h2 class="page-header">Directional Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-double-down"><i aria-hidden="true" class="fa fa-angle-double-down"></i> <span class="sr-only">Example of </span>angle-double-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-double-left"><i aria-hidden="true" class="fa fa-angle-double-left"></i> <span class="sr-only">Example of </span>angle-double-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-double-right"><i aria-hidden="true" class="fa fa-angle-double-right"></i> <span class="sr-only">Example of </span>angle-double-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-double-up"><i aria-hidden="true" class="fa fa-angle-double-up"></i> <span class="sr-only">Example of </span>angle-double-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-down"><i aria-hidden="true" class="fa fa-angle-down"></i> <span class="sr-only">Example of </span>angle-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-left"><i aria-hidden="true" class="fa fa-angle-left"></i> <span class="sr-only">Example of </span>angle-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-right"><i aria-hidden="true" class="fa fa-angle-right"></i> <span class="sr-only">Example of </span>angle-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angle-up"><i aria-hidden="true" class="fa fa-angle-up"></i> <span class="sr-only">Example of </span>angle-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-down"><i aria-hidden="true" class="fa fa-arrow-circle-down"></i> <span class="sr-only">Example of </span>arrow-circle-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-left"><i aria-hidden="true" class="fa fa-arrow-circle-left"></i> <span class="sr-only">Example of </span>arrow-circle-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-o-down"><i aria-hidden="true" class="fa fa-arrow-circle-o-down"></i> <span class="sr-only">Example of </span>arrow-circle-o-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-o-left"><i aria-hidden="true" class="fa fa-arrow-circle-o-left"></i> <span class="sr-only">Example of </span>arrow-circle-o-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-o-right"><i aria-hidden="true" class="fa fa-arrow-circle-o-right"></i> <span class="sr-only">Example of </span>arrow-circle-o-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-o-up"><i aria-hidden="true" class="fa fa-arrow-circle-o-up"></i> <span class="sr-only">Example of </span>arrow-circle-o-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-right"><i aria-hidden="true" class="fa fa-arrow-circle-right"></i> <span class="sr-only">Example of </span>arrow-circle-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-circle-up"><i aria-hidden="true" class="fa fa-arrow-circle-up"></i> <span class="sr-only">Example of </span>arrow-circle-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-down"><i aria-hidden="true" class="fa fa-arrow-down"></i> <span class="sr-only">Example of </span>arrow-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-left"><i aria-hidden="true" class="fa fa-arrow-left"></i> <span class="sr-only">Example of </span>arrow-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-right"><i aria-hidden="true" class="fa fa-arrow-right"></i> <span class="sr-only">Example of </span>arrow-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrow-up"><i aria-hidden="true" class="fa fa-arrow-up"></i> <span class="sr-only">Example of </span>arrow-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows"><i aria-hidden="true" class="fa fa-arrows"></i> <span class="sr-only">Example of </span>arrows</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows-alt"><i aria-hidden="true" class="fa fa-arrows-alt"></i> <span class="sr-only">Example of </span>arrows-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows-h"><i aria-hidden="true" class="fa fa-arrows-h"></i> <span class="sr-only">Example of </span>arrows-h</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows-v"><i aria-hidden="true" class="fa fa-arrows-v"></i> <span class="sr-only">Example of </span>arrows-v</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-down"><i aria-hidden="true" class="fa fa-caret-down"></i> <span class="sr-only">Example of </span>caret-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-left"><i aria-hidden="true" class="fa fa-caret-left"></i> <span class="sr-only">Example of </span>caret-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-right"><i aria-hidden="true" class="fa fa-caret-right"></i> <span class="sr-only">Example of </span>caret-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-down"><i aria-hidden="true" class="fa fa-caret-square-o-down"></i> <span class="sr-only">Example of </span>caret-square-o-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-left"><i aria-hidden="true" class="fa fa-caret-square-o-left"></i> <span class="sr-only">Example of </span>caret-square-o-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-right"><i aria-hidden="true" class="fa fa-caret-square-o-right"></i> <span class="sr-only">Example of </span>caret-square-o-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-up"><i aria-hidden="true" class="fa fa-caret-square-o-up"></i> <span class="sr-only">Example of </span>caret-square-o-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-up"><i aria-hidden="true" class="fa fa-caret-up"></i> <span class="sr-only">Example of </span>caret-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-circle-down"><i aria-hidden="true" class="fa fa-chevron-circle-down"></i> <span class="sr-only">Example of </span>chevron-circle-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-circle-left"><i aria-hidden="true" class="fa fa-chevron-circle-left"></i> <span class="sr-only">Example of </span>chevron-circle-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-circle-right"><i aria-hidden="true" class="fa fa-chevron-circle-right"></i> <span class="sr-only">Example of </span>chevron-circle-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-circle-up"><i aria-hidden="true" class="fa fa-chevron-circle-up"></i> <span class="sr-only">Example of </span>chevron-circle-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-down"><i aria-hidden="true" class="fa fa-chevron-down"></i> <span class="sr-only">Example of </span>chevron-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-left"><i aria-hidden="true" class="fa fa-chevron-left"></i> <span class="sr-only">Example of </span>chevron-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-right"><i aria-hidden="true" class="fa fa-chevron-right"></i> <span class="sr-only">Example of </span>chevron-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chevron-up"><i aria-hidden="true" class="fa fa-chevron-up"></i> <span class="sr-only">Example of </span>chevron-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/exchange"><i aria-hidden="true" class="fa fa-exchange"></i> <span class="sr-only">Example of </span>exchange</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-down"><i aria-hidden="true" class="fa fa-hand-o-down"></i> <span class="sr-only">Example of </span>hand-o-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-left"><i aria-hidden="true" class="fa fa-hand-o-left"></i> <span class="sr-only">Example of </span>hand-o-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-right"><i aria-hidden="true" class="fa fa-hand-o-right"></i> <span class="sr-only">Example of </span>hand-o-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hand-o-up"><i aria-hidden="true" class="fa fa-hand-o-up"></i> <span class="sr-only">Example of </span>hand-o-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/long-arrow-down"><i aria-hidden="true" class="fa fa-long-arrow-down"></i> <span class="sr-only">Example of </span>long-arrow-down</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/long-arrow-left"><i aria-hidden="true" class="fa fa-long-arrow-left"></i> <span class="sr-only">Example of </span>long-arrow-left</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/long-arrow-right"><i aria-hidden="true" class="fa fa-long-arrow-right"></i> <span class="sr-only">Example of </span>long-arrow-right</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/long-arrow-up"><i aria-hidden="true" class="fa fa-long-arrow-up"></i> <span class="sr-only">Example of </span>long-arrow-up</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-down"><i aria-hidden="true" class="fa fa-toggle-down"></i> <span class="sr-only">Example of </span>toggle-down <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-left"><i aria-hidden="true" class="fa fa-toggle-left"></i> <span class="sr-only">Example of </span>toggle-left <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-right"><i aria-hidden="true" class="fa fa-toggle-right"></i> <span class="sr-only">Example of </span>toggle-right <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/caret-square-o-up"><i aria-hidden="true" class="fa fa-toggle-up"></i> <span class="sr-only">Example of </span>toggle-up <span class="text-muted">(alias)</span></a></div>
    
  </div>

</section>

    <section id="video-player">
  <h2 class="page-header">Video Player Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/arrows-alt"><i aria-hidden="true" class="fa fa-arrows-alt"></i> <span class="sr-only">Example of </span>arrows-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/backward"><i aria-hidden="true" class="fa fa-backward"></i> <span class="sr-only">Example of </span>backward</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/compress"><i aria-hidden="true" class="fa fa-compress"></i> <span class="sr-only">Example of </span>compress</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/eject"><i aria-hidden="true" class="fa fa-eject"></i> <span class="sr-only">Example of </span>eject</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/expand"><i aria-hidden="true" class="fa fa-expand"></i> <span class="sr-only">Example of </span>expand</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fast-backward"><i aria-hidden="true" class="fa fa-fast-backward"></i> <span class="sr-only">Example of </span>fast-backward</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fast-forward"><i aria-hidden="true" class="fa fa-fast-forward"></i> <span class="sr-only">Example of </span>fast-forward</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/forward"><i aria-hidden="true" class="fa fa-forward"></i> <span class="sr-only">Example of </span>forward</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pause"><i aria-hidden="true" class="fa fa-pause"></i> <span class="sr-only">Example of </span>pause</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pause-circle"><i aria-hidden="true" class="fa fa-pause-circle"></i> <span class="sr-only">Example of </span>pause-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pause-circle-o"><i aria-hidden="true" class="fa fa-pause-circle-o"></i> <span class="sr-only">Example of </span>pause-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/play"><i aria-hidden="true" class="fa fa-play"></i> <span class="sr-only">Example of </span>play</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/play-circle"><i aria-hidden="true" class="fa fa-play-circle"></i> <span class="sr-only">Example of </span>play-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/play-circle-o"><i aria-hidden="true" class="fa fa-play-circle-o"></i> <span class="sr-only">Example of </span>play-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/random"><i aria-hidden="true" class="fa fa-random"></i> <span class="sr-only">Example of </span>random</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/step-backward"><i aria-hidden="true" class="fa fa-step-backward"></i> <span class="sr-only">Example of </span>step-backward</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/step-forward"><i aria-hidden="true" class="fa fa-step-forward"></i> <span class="sr-only">Example of </span>step-forward</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stop"><i aria-hidden="true" class="fa fa-stop"></i> <span class="sr-only">Example of </span>stop</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stop-circle"><i aria-hidden="true" class="fa fa-stop-circle"></i> <span class="sr-only">Example of </span>stop-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stop-circle-o"><i aria-hidden="true" class="fa fa-stop-circle-o"></i> <span class="sr-only">Example of </span>stop-circle-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/youtube-play"><i aria-hidden="true" class="fa fa-youtube-play"></i> <span class="sr-only">Example of </span>youtube-play</a></div>
    
  </div>

</section>

    <section id="brand">
  <h2 class="page-header">Brand Icons</h2>

  <div class="alert alert-warning">
    <h4><i aria-hidden"true"="" class="fa fa-warning"></i> Warning!</h4>
Apparently, Adblock Plus can remove Font Awesome brand icons with their "Remove Social
Media Buttons" setting. We will not use hacks to force them to display. Please
<a class="alert-link" href="https://adblockplus.org/en/bugs">report an issue with Adblock Plus</a> if you believe this to be
an error. To work around this, you'll need to modify the social icon class names.

  </div>

  <div class="row fontawesome-icon-list margin-bottom-lg">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/500px"><i aria-hidden="true" class="fa fa-500px"></i> <span class="sr-only">Example of </span>500px</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/adn"><i aria-hidden="true" class="fa fa-adn"></i> <span class="sr-only">Example of </span>adn</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/amazon"><i aria-hidden="true" class="fa fa-amazon"></i> <span class="sr-only">Example of </span>amazon</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/android"><i aria-hidden="true" class="fa fa-android"></i> <span class="sr-only">Example of </span>android</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/angellist"><i aria-hidden="true" class="fa fa-angellist"></i> <span class="sr-only">Example of </span>angellist</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/apple"><i aria-hidden="true" class="fa fa-apple"></i> <span class="sr-only">Example of </span>apple</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/behance"><i aria-hidden="true" class="fa fa-behance"></i> <span class="sr-only">Example of </span>behance</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/behance-square"><i aria-hidden="true" class="fa fa-behance-square"></i> <span class="sr-only">Example of </span>behance-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bitbucket"><i aria-hidden="true" class="fa fa-bitbucket"></i> <span class="sr-only">Example of </span>bitbucket</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bitbucket-square"><i aria-hidden="true" class="fa fa-bitbucket-square"></i> <span class="sr-only">Example of </span>bitbucket-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/btc"><i aria-hidden="true" class="fa fa-bitcoin"></i> <span class="sr-only">Example of </span>bitcoin <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/black-tie"><i aria-hidden="true" class="fa fa-black-tie"></i> <span class="sr-only">Example of </span>black-tie</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bluetooth"><i aria-hidden="true" class="fa fa-bluetooth"></i> <span class="sr-only">Example of </span>bluetooth</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/bluetooth-b"><i aria-hidden="true" class="fa fa-bluetooth-b"></i> <span class="sr-only">Example of </span>bluetooth-b</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/btc"><i aria-hidden="true" class="fa fa-btc"></i> <span class="sr-only">Example of </span>btc</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/buysellads"><i aria-hidden="true" class="fa fa-buysellads"></i> <span class="sr-only">Example of </span>buysellads</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-amex"><i aria-hidden="true" class="fa fa-cc-amex"></i> <span class="sr-only">Example of </span>cc-amex</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-diners-club"><i aria-hidden="true" class="fa fa-cc-diners-club"></i> <span class="sr-only">Example of </span>cc-diners-club</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-discover"><i aria-hidden="true" class="fa fa-cc-discover"></i> <span class="sr-only">Example of </span>cc-discover</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-jcb"><i aria-hidden="true" class="fa fa-cc-jcb"></i> <span class="sr-only">Example of </span>cc-jcb</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-mastercard"><i aria-hidden="true" class="fa fa-cc-mastercard"></i> <span class="sr-only">Example of </span>cc-mastercard</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-paypal"><i aria-hidden="true" class="fa fa-cc-paypal"></i> <span class="sr-only">Example of </span>cc-paypal</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-stripe"><i aria-hidden="true" class="fa fa-cc-stripe"></i> <span class="sr-only">Example of </span>cc-stripe</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/cc-visa"><i aria-hidden="true" class="fa fa-cc-visa"></i> <span class="sr-only">Example of </span>cc-visa</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/chrome"><i aria-hidden="true" class="fa fa-chrome"></i> <span class="sr-only">Example of </span>chrome</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/codepen"><i aria-hidden="true" class="fa fa-codepen"></i> <span class="sr-only">Example of </span>codepen</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/codiepie"><i aria-hidden="true" class="fa fa-codiepie"></i> <span class="sr-only">Example of </span>codiepie</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/connectdevelop"><i aria-hidden="true" class="fa fa-connectdevelop"></i> <span class="sr-only">Example of </span>connectdevelop</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/contao"><i aria-hidden="true" class="fa fa-contao"></i> <span class="sr-only">Example of </span>contao</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/css3"><i aria-hidden="true" class="fa fa-css3"></i> <span class="sr-only">Example of </span>css3</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/dashcube"><i aria-hidden="true" class="fa fa-dashcube"></i> <span class="sr-only">Example of </span>dashcube</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/delicious"><i aria-hidden="true" class="fa fa-delicious"></i> <span class="sr-only">Example of </span>delicious</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/deviantart"><i aria-hidden="true" class="fa fa-deviantart"></i> <span class="sr-only">Example of </span>deviantart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/digg"><i aria-hidden="true" class="fa fa-digg"></i> <span class="sr-only">Example of </span>digg</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/dribbble"><i aria-hidden="true" class="fa fa-dribbble"></i> <span class="sr-only">Example of </span>dribbble</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/dropbox"><i aria-hidden="true" class="fa fa-dropbox"></i> <span class="sr-only">Example of </span>dropbox</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/drupal"><i aria-hidden="true" class="fa fa-drupal"></i> <span class="sr-only">Example of </span>drupal</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/edge"><i aria-hidden="true" class="fa fa-edge"></i> <span class="sr-only">Example of </span>edge</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/empire"><i aria-hidden="true" class="fa fa-empire"></i> <span class="sr-only">Example of </span>empire</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/envira"><i aria-hidden="true" class="fa fa-envira"></i> <span class="sr-only">Example of </span>envira</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/expeditedssl"><i aria-hidden="true" class="fa fa-expeditedssl"></i> <span class="sr-only">Example of </span>expeditedssl</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/font-awesome"><i aria-hidden="true" class="fa fa-fa"></i> <span class="sr-only">Example of </span>fa <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/facebook"><i aria-hidden="true" class="fa fa-facebook"></i> <span class="sr-only">Example of </span>facebook</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/facebook"><i aria-hidden="true" class="fa fa-facebook-f"></i> <span class="sr-only">Example of </span>facebook-f <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/facebook-official"><i aria-hidden="true" class="fa fa-facebook-official"></i> <span class="sr-only">Example of </span>facebook-official</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/facebook-square"><i aria-hidden="true" class="fa fa-facebook-square"></i> <span class="sr-only">Example of </span>facebook-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/firefox"><i aria-hidden="true" class="fa fa-firefox"></i> <span class="sr-only">Example of </span>firefox</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/first-order"><i aria-hidden="true" class="fa fa-first-order"></i> <span class="sr-only">Example of </span>first-order</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/flickr"><i aria-hidden="true" class="fa fa-flickr"></i> <span class="sr-only">Example of </span>flickr</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/font-awesome"><i aria-hidden="true" class="fa fa-font-awesome"></i> <span class="sr-only">Example of </span>font-awesome</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fonticons"><i aria-hidden="true" class="fa fa-fonticons"></i> <span class="sr-only">Example of </span>fonticons</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/fort-awesome"><i aria-hidden="true" class="fa fa-fort-awesome"></i> <span class="sr-only">Example of </span>fort-awesome</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/forumbee"><i aria-hidden="true" class="fa fa-forumbee"></i> <span class="sr-only">Example of </span>forumbee</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/foursquare"><i aria-hidden="true" class="fa fa-foursquare"></i> <span class="sr-only">Example of </span>foursquare</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/empire"><i aria-hidden="true" class="fa fa-ge"></i> <span class="sr-only">Example of </span>ge <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/get-pocket"><i aria-hidden="true" class="fa fa-get-pocket"></i> <span class="sr-only">Example of </span>get-pocket</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gg"><i aria-hidden="true" class="fa fa-gg"></i> <span class="sr-only">Example of </span>gg</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gg-circle"><i aria-hidden="true" class="fa fa-gg-circle"></i> <span class="sr-only">Example of </span>gg-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/git"><i aria-hidden="true" class="fa fa-git"></i> <span class="sr-only">Example of </span>git</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/git-square"><i aria-hidden="true" class="fa fa-git-square"></i> <span class="sr-only">Example of </span>git-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/github"><i aria-hidden="true" class="fa fa-github"></i> <span class="sr-only">Example of </span>github</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/github-alt"><i aria-hidden="true" class="fa fa-github-alt"></i> <span class="sr-only">Example of </span>github-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/github-square"><i aria-hidden="true" class="fa fa-github-square"></i> <span class="sr-only">Example of </span>github-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gitlab"><i aria-hidden="true" class="fa fa-gitlab"></i> <span class="sr-only">Example of </span>gitlab</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gratipay"><i aria-hidden="true" class="fa fa-gittip"></i> <span class="sr-only">Example of </span>gittip <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/glide"><i aria-hidden="true" class="fa fa-glide"></i> <span class="sr-only">Example of </span>glide</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/glide-g"><i aria-hidden="true" class="fa fa-glide-g"></i> <span class="sr-only">Example of </span>glide-g</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/google"><i aria-hidden="true" class="fa fa-google"></i> <span class="sr-only">Example of </span>google</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/google-plus"><i aria-hidden="true" class="fa fa-google-plus"></i> <span class="sr-only">Example of </span>google-plus</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/google-plus-official"><i aria-hidden="true" class="fa fa-google-plus-circle"></i> <span class="sr-only">Example of </span>google-plus-circle <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/google-plus-official"><i aria-hidden="true" class="fa fa-google-plus-official"></i> <span class="sr-only">Example of </span>google-plus-official</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/google-plus-square"><i aria-hidden="true" class="fa fa-google-plus-square"></i> <span class="sr-only">Example of </span>google-plus-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/google-wallet"><i aria-hidden="true" class="fa fa-google-wallet"></i> <span class="sr-only">Example of </span>google-wallet</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/gratipay"><i aria-hidden="true" class="fa fa-gratipay"></i> <span class="sr-only">Example of </span>gratipay</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hacker-news"><i aria-hidden="true" class="fa fa-hacker-news"></i> <span class="sr-only">Example of </span>hacker-news</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/houzz"><i aria-hidden="true" class="fa fa-houzz"></i> <span class="sr-only">Example of </span>houzz</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/html5"><i aria-hidden="true" class="fa fa-html5"></i> <span class="sr-only">Example of </span>html5</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/instagram"><i aria-hidden="true" class="fa fa-instagram"></i> <span class="sr-only">Example of </span>instagram</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/internet-explorer"><i aria-hidden="true" class="fa fa-internet-explorer"></i> <span class="sr-only">Example of </span>internet-explorer</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ioxhost"><i aria-hidden="true" class="fa fa-ioxhost"></i> <span class="sr-only">Example of </span>ioxhost</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/joomla"><i aria-hidden="true" class="fa fa-joomla"></i> <span class="sr-only">Example of </span>joomla</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/jsfiddle"><i aria-hidden="true" class="fa fa-jsfiddle"></i> <span class="sr-only">Example of </span>jsfiddle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/lastfm"><i aria-hidden="true" class="fa fa-lastfm"></i> <span class="sr-only">Example of </span>lastfm</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/lastfm-square"><i aria-hidden="true" class="fa fa-lastfm-square"></i> <span class="sr-only">Example of </span>lastfm-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/leanpub"><i aria-hidden="true" class="fa fa-leanpub"></i> <span class="sr-only">Example of </span>leanpub</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/linkedin"><i aria-hidden="true" class="fa fa-linkedin"></i> <span class="sr-only">Example of </span>linkedin</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/linkedin-square"><i aria-hidden="true" class="fa fa-linkedin-square"></i> <span class="sr-only">Example of </span>linkedin-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/linux"><i aria-hidden="true" class="fa fa-linux"></i> <span class="sr-only">Example of </span>linux</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/maxcdn"><i aria-hidden="true" class="fa fa-maxcdn"></i> <span class="sr-only">Example of </span>maxcdn</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/meanpath"><i aria-hidden="true" class="fa fa-meanpath"></i> <span class="sr-only">Example of </span>meanpath</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/medium"><i aria-hidden="true" class="fa fa-medium"></i> <span class="sr-only">Example of </span>medium</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/mixcloud"><i aria-hidden="true" class="fa fa-mixcloud"></i> <span class="sr-only">Example of </span>mixcloud</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/modx"><i aria-hidden="true" class="fa fa-modx"></i> <span class="sr-only">Example of </span>modx</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/odnoklassniki"><i aria-hidden="true" class="fa fa-odnoklassniki"></i> <span class="sr-only">Example of </span>odnoklassniki</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/odnoklassniki-square"><i aria-hidden="true" class="fa fa-odnoklassniki-square"></i> <span class="sr-only">Example of </span>odnoklassniki-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/opencart"><i aria-hidden="true" class="fa fa-opencart"></i> <span class="sr-only">Example of </span>opencart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/openid"><i aria-hidden="true" class="fa fa-openid"></i> <span class="sr-only">Example of </span>openid</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/opera"><i aria-hidden="true" class="fa fa-opera"></i> <span class="sr-only">Example of </span>opera</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/optin-monster"><i aria-hidden="true" class="fa fa-optin-monster"></i> <span class="sr-only">Example of </span>optin-monster</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pagelines"><i aria-hidden="true" class="fa fa-pagelines"></i> <span class="sr-only">Example of </span>pagelines</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/paypal"><i aria-hidden="true" class="fa fa-paypal"></i> <span class="sr-only">Example of </span>paypal</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pied-piper"><i aria-hidden="true" class="fa fa-pied-piper"></i> <span class="sr-only">Example of </span>pied-piper</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pied-piper-alt"><i aria-hidden="true" class="fa fa-pied-piper-alt"></i> <span class="sr-only">Example of </span>pied-piper-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pied-piper-pp"><i aria-hidden="true" class="fa fa-pied-piper-pp"></i> <span class="sr-only">Example of </span>pied-piper-pp</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pinterest"><i aria-hidden="true" class="fa fa-pinterest"></i> <span class="sr-only">Example of </span>pinterest</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pinterest-p"><i aria-hidden="true" class="fa fa-pinterest-p"></i> <span class="sr-only">Example of </span>pinterest-p</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/pinterest-square"><i aria-hidden="true" class="fa fa-pinterest-square"></i> <span class="sr-only">Example of </span>pinterest-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/product-hunt"><i aria-hidden="true" class="fa fa-product-hunt"></i> <span class="sr-only">Example of </span>product-hunt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/qq"><i aria-hidden="true" class="fa fa-qq"></i> <span class="sr-only">Example of </span>qq</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rebel"><i aria-hidden="true" class="fa fa-ra"></i> <span class="sr-only">Example of </span>ra <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rebel"><i aria-hidden="true" class="fa fa-rebel"></i> <span class="sr-only">Example of </span>rebel</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/reddit"><i aria-hidden="true" class="fa fa-reddit"></i> <span class="sr-only">Example of </span>reddit</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/reddit-alien"><i aria-hidden="true" class="fa fa-reddit-alien"></i> <span class="sr-only">Example of </span>reddit-alien</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/reddit-square"><i aria-hidden="true" class="fa fa-reddit-square"></i> <span class="sr-only">Example of </span>reddit-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/renren"><i aria-hidden="true" class="fa fa-renren"></i> <span class="sr-only">Example of </span>renren</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/rebel"><i aria-hidden="true" class="fa fa-resistance"></i> <span class="sr-only">Example of </span>resistance <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/safari"><i aria-hidden="true" class="fa fa-safari"></i> <span class="sr-only">Example of </span>safari</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/scribd"><i aria-hidden="true" class="fa fa-scribd"></i> <span class="sr-only">Example of </span>scribd</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/sellsy"><i aria-hidden="true" class="fa fa-sellsy"></i> <span class="sr-only">Example of </span>sellsy</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share-alt"><i aria-hidden="true" class="fa fa-share-alt"></i> <span class="sr-only">Example of </span>share-alt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/share-alt-square"><i aria-hidden="true" class="fa fa-share-alt-square"></i> <span class="sr-only">Example of </span>share-alt-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/shirtsinbulk"><i aria-hidden="true" class="fa fa-shirtsinbulk"></i> <span class="sr-only">Example of </span>shirtsinbulk</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/simplybuilt"><i aria-hidden="true" class="fa fa-simplybuilt"></i> <span class="sr-only">Example of </span>simplybuilt</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/skyatlas"><i aria-hidden="true" class="fa fa-skyatlas"></i> <span class="sr-only">Example of </span>skyatlas</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/skype"><i aria-hidden="true" class="fa fa-skype"></i> <span class="sr-only">Example of </span>skype</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/slack"><i aria-hidden="true" class="fa fa-slack"></i> <span class="sr-only">Example of </span>slack</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/slideshare"><i aria-hidden="true" class="fa fa-slideshare"></i> <span class="sr-only">Example of </span>slideshare</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/snapchat"><i aria-hidden="true" class="fa fa-snapchat"></i> <span class="sr-only">Example of </span>snapchat</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/snapchat-ghost"><i aria-hidden="true" class="fa fa-snapchat-ghost"></i> <span class="sr-only">Example of </span>snapchat-ghost</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/snapchat-square"><i aria-hidden="true" class="fa fa-snapchat-square"></i> <span class="sr-only">Example of </span>snapchat-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/soundcloud"><i aria-hidden="true" class="fa fa-soundcloud"></i> <span class="sr-only">Example of </span>soundcloud</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/spotify"><i aria-hidden="true" class="fa fa-spotify"></i> <span class="sr-only">Example of </span>spotify</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stack-exchange"><i aria-hidden="true" class="fa fa-stack-exchange"></i> <span class="sr-only">Example of </span>stack-exchange</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stack-overflow"><i aria-hidden="true" class="fa fa-stack-overflow"></i> <span class="sr-only">Example of </span>stack-overflow</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/steam"><i aria-hidden="true" class="fa fa-steam"></i> <span class="sr-only">Example of </span>steam</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/steam-square"><i aria-hidden="true" class="fa fa-steam-square"></i> <span class="sr-only">Example of </span>steam-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stumbleupon"><i aria-hidden="true" class="fa fa-stumbleupon"></i> <span class="sr-only">Example of </span>stumbleupon</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stumbleupon-circle"><i aria-hidden="true" class="fa fa-stumbleupon-circle"></i> <span class="sr-only">Example of </span>stumbleupon-circle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tencent-weibo"><i aria-hidden="true" class="fa fa-tencent-weibo"></i> <span class="sr-only">Example of </span>tencent-weibo</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/themeisle"><i aria-hidden="true" class="fa fa-themeisle"></i> <span class="sr-only">Example of </span>themeisle</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/trello"><i aria-hidden="true" class="fa fa-trello"></i> <span class="sr-only">Example of </span>trello</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tripadvisor"><i aria-hidden="true" class="fa fa-tripadvisor"></i> <span class="sr-only">Example of </span>tripadvisor</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tumblr"><i aria-hidden="true" class="fa fa-tumblr"></i> <span class="sr-only">Example of </span>tumblr</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/tumblr-square"><i aria-hidden="true" class="fa fa-tumblr-square"></i> <span class="sr-only">Example of </span>tumblr-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/twitch"><i aria-hidden="true" class="fa fa-twitch"></i> <span class="sr-only">Example of </span>twitch</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/twitter"><i aria-hidden="true" class="fa fa-twitter"></i> <span class="sr-only">Example of </span>twitter</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/twitter-square"><i aria-hidden="true" class="fa fa-twitter-square"></i> <span class="sr-only">Example of </span>twitter-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/usb"><i aria-hidden="true" class="fa fa-usb"></i> <span class="sr-only">Example of </span>usb</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/viacoin"><i aria-hidden="true" class="fa fa-viacoin"></i> <span class="sr-only">Example of </span>viacoin</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/viadeo"><i aria-hidden="true" class="fa fa-viadeo"></i> <span class="sr-only">Example of </span>viadeo</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/viadeo-square"><i aria-hidden="true" class="fa fa-viadeo-square"></i> <span class="sr-only">Example of </span>viadeo-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/vimeo"><i aria-hidden="true" class="fa fa-vimeo"></i> <span class="sr-only">Example of </span>vimeo</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/vimeo-square"><i aria-hidden="true" class="fa fa-vimeo-square"></i> <span class="sr-only">Example of </span>vimeo-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/vine"><i aria-hidden="true" class="fa fa-vine"></i> <span class="sr-only">Example of </span>vine</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/vk"><i aria-hidden="true" class="fa fa-vk"></i> <span class="sr-only">Example of </span>vk</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/weixin"><i aria-hidden="true" class="fa fa-wechat"></i> <span class="sr-only">Example of </span>wechat <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/weibo"><i aria-hidden="true" class="fa fa-weibo"></i> <span class="sr-only">Example of </span>weibo</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/weixin"><i aria-hidden="true" class="fa fa-weixin"></i> <span class="sr-only">Example of </span>weixin</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/whatsapp"><i aria-hidden="true" class="fa fa-whatsapp"></i> <span class="sr-only">Example of </span>whatsapp</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wikipedia-w"><i aria-hidden="true" class="fa fa-wikipedia-w"></i> <span class="sr-only">Example of </span>wikipedia-w</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/windows"><i aria-hidden="true" class="fa fa-windows"></i> <span class="sr-only">Example of </span>windows</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wordpress"><i aria-hidden="true" class="fa fa-wordpress"></i> <span class="sr-only">Example of </span>wordpress</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wpbeginner"><i aria-hidden="true" class="fa fa-wpbeginner"></i> <span class="sr-only">Example of </span>wpbeginner</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wpforms"><i aria-hidden="true" class="fa fa-wpforms"></i> <span class="sr-only">Example of </span>wpforms</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/xing"><i aria-hidden="true" class="fa fa-xing"></i> <span class="sr-only">Example of </span>xing</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/xing-square"><i aria-hidden="true" class="fa fa-xing-square"></i> <span class="sr-only">Example of </span>xing-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/y-combinator"><i aria-hidden="true" class="fa fa-y-combinator"></i> <span class="sr-only">Example of </span>y-combinator</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hacker-news"><i aria-hidden="true" class="fa fa-y-combinator-square"></i> <span class="sr-only">Example of </span>y-combinator-square <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/yahoo"><i aria-hidden="true" class="fa fa-yahoo"></i> <span class="sr-only">Example of </span>yahoo</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/y-combinator"><i aria-hidden="true" class="fa fa-yc"></i> <span class="sr-only">Example of </span>yc <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hacker-news"><i aria-hidden="true" class="fa fa-yc-square"></i> <span class="sr-only">Example of </span>yc-square <span class="text-muted">(alias)</span></a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/yelp"><i aria-hidden="true" class="fa fa-yelp"></i> <span class="sr-only">Example of </span>yelp</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/yoast"><i aria-hidden="true" class="fa fa-yoast"></i> <span class="sr-only">Example of </span>yoast</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/youtube"><i aria-hidden="true" class="fa fa-youtube"></i> <span class="sr-only">Example of </span>youtube</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/youtube-play"><i aria-hidden="true" class="fa fa-youtube-play"></i> <span class="sr-only">Example of </span>youtube-play</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/youtube-square"><i aria-hidden="true" class="fa fa-youtube-square"></i> <span class="sr-only">Example of </span>youtube-square</a></div>
    
  </div>

  <div class="alert alert-success">
    <ul class="margin-bottom-none padding-left-lg">
  <li>All brand icons are trademarks of their respective owners.</li>
  <li>The use of these trademarks does not indicate endorsement of the trademark holder by Font Awesome, nor vice versa.</li>
  <li>Brand icons should only be used to represent the company or product to which they refer.</li>
</ul>

  </div>
</section>

    <section id="medical">
  <h2 class="page-header">Medical Icons</h2>

  <div class="row fontawesome-icon-list">
    

    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/ambulance"><i aria-hidden="true" class="fa fa-ambulance"></i> <span class="sr-only">Example of </span>ambulance</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/h-square"><i aria-hidden="true" class="fa fa-h-square"></i> <span class="sr-only">Example of </span>h-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/heart"><i aria-hidden="true" class="fa fa-heart"></i> <span class="sr-only">Example of </span>heart</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/heart-o"><i aria-hidden="true" class="fa fa-heart-o"></i> <span class="sr-only">Example of </span>heart-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/heartbeat"><i aria-hidden="true" class="fa fa-heartbeat"></i> <span class="sr-only">Example of </span>heartbeat</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/hospital-o"><i aria-hidden="true" class="fa fa-hospital-o"></i> <span class="sr-only">Example of </span>hospital-o</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/medkit"><i aria-hidden="true" class="fa fa-medkit"></i> <span class="sr-only">Example of </span>medkit</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/plus-square"><i aria-hidden="true" class="fa fa-plus-square"></i> <span class="sr-only">Example of </span>plus-square</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/stethoscope"><i aria-hidden="true" class="fa fa-stethoscope"></i> <span class="sr-only">Example of </span>stethoscope</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/user-md"><i aria-hidden="true" class="fa fa-user-md"></i> <span class="sr-only">Example of </span>user-md</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair"><i aria-hidden="true" class="fa fa-wheelchair"></i> <span class="sr-only">Example of </span>wheelchair</a></div>
    
      <div class="fa-hover col-md-3 col-sm-4"><a href="../icon/wheelchair-alt"><i aria-hidden="true" class="fa fa-wheelchair-alt"></i> <span class="sr-only">Example of </span>wheelchair-alt</a></div>
    
  </div>

</section>

</div>

</div>

